/*
 * Copyright (c) 1995, Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */

/* from gl.h */

typedef short Angle;
typedef short Screencoord;
typedef short Scoord;
typedef long Icoord;
typedef float Coord;

/* arcs */

void     arc( Coord, Coord, Coord, Angle, Angle );
void     arcf( Coord, Coord, Coord, Angle, Angle );
void     arcfi( Icoord, Icoord, Icoord, Angle, Angle );
void     arcfs( Scoord, Scoord, Scoord, Angle, Angle );
void     arci( Icoord, Icoord, Icoord, Angle, Angle );
void     arcs( Scoord, Scoord, Scoord, Angle, Angle );

/* circles */

void     circ( Coord, Coord, Coord );
void     circf( Coord, Coord, Coord );
void     circfi( Icoord, Icoord, Icoord );
void     circfs( Scoord, Scoord, Scoord );
void     circi( Icoord, Icoord, Icoord );
void     circs( Scoord, Scoord, Scoord );

/* rectangles */

void     rect( Coord, Coord, Coord, Coord );
void     rectf( Coord, Coord, Coord, Coord );
void     rectfi( Icoord, Icoord, Icoord, Icoord );
void     rectfs( Scoord, Scoord, Scoord, Scoord );
void     recti( Icoord, Icoord, Icoord, Icoord );
void     rects( Scoord, Scoord, Scoord, Scoord );

/* screen boxes */

void     sbox( Coord, Coord, Coord, Coord );
void     sboxf( Coord, Coord, Coord, Coord );
void     sboxfi( Icoord, Icoord, Icoord, Icoord );
void     sboxfs( Scoord, Scoord, Scoord, Scoord );
void     sboxi( Icoord, Icoord, Icoord, Icoord );
void     sboxs( Scoord, Scoord, Scoord, Scoord );

