//////////////////////////////////////////////////////////////
//
// Header file for glrduckMainWindow.c++
//
//    This class is a subclass of VkWindow
//
// Normally, very little in this file should need to be changed.
// Create/add/modify menus using RapidApp.
//
// Restrict changes to those sections between
// the "//--- Start/End editable code block" markers
// Doing so will allow you to make changes using RapidApp
// without losing any changes you may have made manually
//
//////////////////////////////////////////////////////////////
#ifndef GLRDUCKMAINWINDOW_H
#define GLRDUCKMAINWINDOW_H
#include <Vk/VkWindow.h>

class VkMenuItem;
class VkMenuToggle;
class VkMenuConfirmFirstAction;
class VkSubMenu;
class VkRadioSubMenu;
class SoSeparator;
class SoComplexity;
class SoRotationXYZ;
class SoXtGLRRenderArea;

//---- Start editable code block: headers and declarations
#include <Inventor/SbBasic.h>
//---- End editable code block: headers and declarations


//---- glrduckMainWindow class declaration

class glrduckMainWindow: public VkWindow {

  public:

    glrduckMainWindow( const char * name, 
			ArgList args = NULL,
			Cardinal argCount = 0 );
    ~glrduckMainWindow();
    const char *className();
    virtual Boolean okToQuit();

    //---- Start editable code block: glrduckMainWindow public
    static SbBool myEventCB(void *userData, XAnyEvent *event);


    //---- End editable code block: glrduckMainWindow public


  protected:



    // Classes created by this class

    class SoXtGLRRenderArea *_render;


    // Widgets created by this class


    // Menu items created by this class
    VkSubMenu  *_filePane;
    VkMenuItem *_exitButton;
    VkSubMenu  *_viewPane;
    VkMenuItem *_viewControl1;

    // Member functions called from callbacks

    virtual void quit ( Widget, XtPointer );


    //---- Start editable code block: glrduckMainWindow protected
    SbBool myRealEventCB(XAnyEvent *anyevent);
    void motionStart(int x, int y);
    void motion(int x, int);
    void motionStop();
    //---- End editable code block: glrduckMainWindow protected


  private:


    // Callbacks to interface with Motif

    static void quitCallback ( Widget, XtPointer, XtPointer );

    static String  _defaultglrduckMainWindowResources[];


    //---- Start editable code block: glrduckMainWindow private
    SoSeparator       *_root;
    SoComplexity      *_complexity;
    SoRotationXYZ     *_duckRotXYZ;

    short int          _moving;
    int                _begin;
    float              _angle;
    //---- End editable code block: glrduckMainWindow private


};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif
