/*
 * Copyright (c) 1995, Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/*----------------------------------------------------------------------------
 *
 * file   : draw.c 
 *
 * Author : Yusuf Attarwala
 * Date   : Mar 95
 *
 *---------------------------------------------------------------------------*/
#include <stdio.h>
#include <gl/device.h>

#include "globals.h"

void
drawScene()
{
    static float sp1[] = {0.2,0.2,0.2,3.0};
    static float sp2[] = {3.4,3.4,0.2,3.0};

    GLXwinset(XtDisplay(glw), XtWindow(glw));

    lmbind(LMODEL,curLModel);

    RGBcolor(0,0,0);
    clear();
    zclear();

    pushmatrix();
    rotate(anglex,'x');
    rotate(angley,'y');
    rotate(anglez,'z');
    lmbind(MATERIAL,curMatSet);
    sphdraw(sp1);
    lmbind(MATERIAL,curMatSet+1);
    sphdraw(sp2);
    popmatrix();

    lmbind(LMODEL,0);
 
    if (doubleBuffer) swapbuffers();

}

