/*
 * Copyright (c) 1995, Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/*----------------------------------------------------------------------------
 *
 * file   : globals.h
 *
 * Author : Yusuf Attarwala
 * Date   : Apr 94
 *
 *---------------------------------------------------------------------------*/
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <gl.h>

#ifdef DEFINE_GLOBALS
#define GLOBAL
#define INIT(x) = x
#else
#define GLOBAL extern
#define INIT(x)
#endif

#include "defines.h"

GLOBAL Display        *display;
GLOBAL long            screen;
GLOBAL XtAppContext    appContext;
GLOBAL XtTranslations  transTable;
GLOBAL Widget          toplevel,
                       glw;

GLOBAL Dimension       window_height,
                       window_width;

GLOBAL Angle  anglex,angley,anglez;

static Matrix identity = {1.0,0.0,0.0,0.0,
                          0.0,1.0,0.0,0.0,
                          0.0,0.0,1.0,0.0,
                          0.0,0.0,0.0,1.0};

GLOBAL unsigned long cpackValue;

GLOBAL int    doLighting, 	/* bunch of state flags */
	      doDisplayList,
	      doTumble,
	      refresh,
	      doubleBuffer;

GLOBAL int    curLModel,
	      curMatSet,
	      curLight;         /* although can have more */

/* these should be on the last lines */
#undef INIT
#undef GLOBAL
