/*
 * Copyright (c) 1995, Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/*----------------------------------------------------------------------------
 *
 * file   : main.c for irisGL version of lmwrap
 *
 * Author : Yusuf Attarwala
 * Date   : Apr 95
 *
 *---------------------------------------------------------------------------*/
#include <sys/types.h>
#include <malloc.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define DEFINE_GLOBALS 1
#include "globals.h"
#undef DEFINE_GLOBALS
#include <Xm/Protocols.h>
#include <X11/StringDefs.h>

typedef struct _cmdLine {
    String     complexity;           
} CmdLine, *CmdLinePtr;

CmdLine commandLine;

static XtResource resources[] = {
    {"complexity",    "Complexity",   XtRString,  sizeof(String),
      XtOffset(CmdLinePtr,complexity), XtRString, "10",},
};

static XrmOptionDescRec options[] = {
    {"-c",      "complexity",  XrmoptionSepArg, NULL},
};

static String fallbackResources[] = {
    "*background:                  grey",
    "*XmSeparator.traversalOn:     False",
    "*XmLabel.traversalOn:         False",
    "*fillOnSelect:                True",
    "*selectColor:                 yellow",
    "*ui*fontList:                 -adobe-helvetica-bold-r-normal-*-12-*-*-*-*-*-*-*",
    "*gizmo*fontList:              -adobe-helvetica-bold-r-normal-*-12-*-*-*-*-*-*-*",
    NULL
};

/* function declaration */
void main();


void
printDescription()
{
    printf("\n irisGL version of comp GL\n\n");
}

void
main(argc,argv)
int argc;
char **argv;
{
    Atom xaWmDeleteWindow;
    void doExit();

    toplevel = XtAppInitialize(&appContext,"LmIGL",
                               options,XtNumber(options),
                               &argc,argv,
                               fallbackResources,
                               (ArgList)NULL, 0);


    display  = XtDisplay(toplevel);
    screen   = XDefaultScreen(display);
    XtGetApplicationResources(toplevel,&commandLine,
                              resources,XtNumber(resources),
                              NULL,0);


    XtVaSetValues(toplevel,XmNtitle,"lmwrap - Iris GL",
                           XmNiconName,"lmwrapI",
                           XmNdeleteResponse, XmDO_NOTHING,
                           NULL);

    xaWmDeleteWindow = XmInternAtom(display,"WM_DELETE_WINDOW",TRUE);
    XmAddWMProtocolCallback(toplevel,xaWmDeleteWindow,doExit,0);



    initGlobals();

    createMenus(toplevel);
    XtRealizeWidget(toplevel);

    createGraphics(toplevel);
    drawScene();
    XFlush(display);

    XtAppMainLoop(appContext);
}

void
doExit()
{
    exit(0);
}

