/*
 * Copyright (c) 1995, Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/*----------------------------------------------------------------------------
 *
 * file   : defines.h
 *
 * Author : Yusuf Attarwala
 * Date   : Apr 95
 *
 *---------------------------------------------------------------------------*/

#define _R  0
#define _G  1
#define _B  2

#define _X  0
#define _Y  1
#define _Z  2

#define PROJ_TRANSF 1
#define VIEW_TRANSF 2
#define MODL_TRANSF 3

#define ANIMATE    0x0010

#define abs(x)   (x<0 ? -(x) : x)
#define SETMIN(b,c) if ((c) <= (b)) (b) = (c);
#define SETMAX(b,c) if ((c) >= (b)) (b) = (c);

#define SZ(x) sizeof(x)/sizeof(float)

