/*
 * Copyright (c) 1995, Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/*----------------------------------------------------------------------------
 *
 * file   : draw.c 
 *
 * Author : Yusuf Attarwala
 * Date   : Apr 95
 *
 *---------------------------------------------------------------------------*/
#include <math.h>
#include <stdio.h>
#include <gl/device.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/param.h>


#include "globals.h"
#include "lm.h"

/* irisGL style lmbind will call our lmbind */


void
drawScene()
{


    GLwDrawingAreaMakeCurrent(glw, glxc);

    lmbind(LMODEL,curLModel);

    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glEnable(GL_LIGHTING);
    glPushMatrix();
    glRotatef(anglex,1.0,0.0,0.0);
    glRotatef(angley,0.0,1.0,0.0);
    glRotatef(anglez,0.0,0.0,1.0);
    gluQuadricDrawStyle (quadObj, GLU_FILL);
    glTranslatef(0.2,0.2,0.2);
    lmbind(MATERIAL,curMatSet);
    if (curLModel == LTM_INF_TWO) lmbind(BACKMATERIAL,curMatSet+1);
    gluSphere(quadObj,3.0,15,15);
    glTranslatef(3.2,3.2,0.0);
    lmbind(MATERIAL,curMatSet+1);
    if (curLModel == LTM_INF_TWO) lmbind(BACKMATERIAL,curMatSet);
    gluSphere(quadObj,3.0,15,15);

    glPopMatrix();
    glFlush();
    glDisable(GL_LIGHTING);

    lmbind(LMODEL,0);

    if (doubleBuffer) glXSwapBuffers(XtDisplay(glw), XtWindow(glw));

}

