/*
 * Copyright (c) 1995, Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * OpenGL(TM) is a trademark of Silicon Graphics, Inc.
 */
/*----------------------------------------------------------------------------
 *
 * file   : mygl.h
 *
 * Author : Yusuf Attarwala
 * Date   : Apr 95
 *
 *---------------------------------------------------------------------------*/

 /* emulate irisGL's gl.h for lighting */

#define LMNULL                  0.0

/* MATERIAL properties */
#define DEFMATERIAL             0
#define EMISSION                1
#define AMBIENT                 2
#define DIFFUSE                 3
#define SPECULAR                4
#define SHININESS               5
#define COLORINDEXES            6
#define ALPHA                   7

/* LIGHT properties */
#define DEFLIGHT                100
#define LCOLOR                  101
#define POSITION                102
#define SPOTDIRECTION           103
#define SPOTLIGHT               104


/* LIGHTINGMODEL properties */
#define DEFLMODEL               200
#define LOCALVIEWER             201
#define ATTENUATION             202
#define ATTENUATION2            203
#define TWOSIDE                 204

/* TARGET constants */
#define MATERIAL                1000
#define BACKMATERIAL            1001
#define LIGHT0                  1100
#define LIGHT1                  1101
#define LIGHT2                  1102
#define LIGHT3                  1103
#define LIGHT4                  1104
#define LIGHT5                  1105
#define LIGHT6                  1106
#define LIGHT7                  1107
#define LMODEL                  1200

extern void     lmbind();
extern void     lmdef();
