/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _COLORCHOOSER_H
#define _COLORCHOOSER_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Jan 18 17:06:24 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:20 1994 by George Kyriazis
 *
 * a C++ encapsulation of the SGI color chooser widget
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

// X defines Object
#define Object XObject
#include <X11/Intrinsic.h>
#undef Object

#include "Object.h"
#include <Vk/VkComponent.h>
#include "TopLevelWindow.h"

class SbColor;
class MyColorEditor;
class GlWindow;

class ColorChooser : public Object, public VkComponent {
  public:
    ColorChooser( char *name, Widget parent, GlWindow * );
    virtual ~ColorChooser();

    // set the current color
    virtual	void	setValue( GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1 );

    // callback
    static const char *const newValue;
    
  protected:
    void	create_widget( char *name, Widget parent );

    Widget	rowcol;
    Widget	label;
    Widget	button;

    TopLevelWindow	toplev_window;
    Widget	color_widget;
    MyColorEditor	*color_thing;

    RGBColor	rgb_color;

    // info about the graphics context
    GlWindow	*glWindow;

    // callbacks
    static	void	ce_applyCB( void *, const SbColor * );
    static	void	showCB( Widget w, XtPointer, XtPointer );
    static	void	applyCB( Widget w, XtPointer, XtPointer );
    static	void	cancelCB( Widget w, XtPointer, XtPointer );
    static	void	okCB( Widget w, XtPointer, XtPointer );
    virtual	void	show_cb( Widget w, XtPointer );
    virtual	void	apply_cb( Widget w, XtPointer );
    virtual	void	cancel_cb( Widget w, XtPointer );
    virtual	void	ok_cb( Widget w, XtPointer );
};

#endif /* _COLORCHOOSER_H */
