/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Wed Jan 19 11:42:19 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:12:28 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "ColorChooserWAlpha.h"

#include <stdlib.h>
#include <Sgm/ColorC.h>

ColorChooserWAlpha::ColorChooserWAlpha( char *Name, Widget Parent,
				       GlWindow *dwa )
: ColorChooser( Name, Parent, dwa ),

  alpha_ti( "Alpha: ", rowcol )
{
    create_widget( Name, Parent );
}

ColorChooserWAlpha::~ColorChooserWAlpha()
{
}


void
ColorChooserWAlpha::setValue( GLfloat r, GLfloat g, GLfloat b, GLfloat a )
{
    ColorChooser::setValue( r, g, b );

    alpha_ti.set_text( ftoa(a) );
}


void
ColorChooserWAlpha::create_widget( char *, Widget )
{
    // this one just assembles callbacks
    alpha_ti.set_text( "0" );
    alpha_ti.set_accepted( TextItem::FRACTIONAL );

    alpha_ti.addCallback( TextItem::newValue,
			 &ColorChooserWAlpha::alphaCB, this );
}

void
ColorChooserWAlpha::alphaCB( VkCallbackObject *, void *client, void *call )
{
    ColorChooserWAlpha *self = (ColorChooserWAlpha *) client;

    self->alpha_cb( NULL, call );
}

void
ColorChooserWAlpha::alpha_cb( Widget, XtPointer )
{
    rgba_color.a = atof( alpha_ti.get_text() );

    callCallbacks( newValue, (void *) &rgba_color );
}

void
ColorChooserWAlpha::apply_cb( Widget, XtPointer call )
{
    SgColorChooserCallbackStruct *cb =
	(SgColorChooserCallbackStruct *) call;

    rgba_color.r = cb->r / 255.;
    rgba_color.g = cb->g / 255.;
    rgba_color.b = cb->b / 255.;
    rgba_color.a = atof( alpha_ti.get_text() );

    callCallbacks( newValue, (void *) &rgba_color );
}


void
ColorChooserWAlpha::show_cb( Widget w, XtPointer call )
{
    ColorChooser::show_cb( w, call );
}

void
ColorChooserWAlpha::cancel_cb( Widget w, XtPointer call )
{
    ColorChooser::cancel_cb( w, call );
}

void
ColorChooserWAlpha::ok_cb( Widget w, XtPointer call )
{
    ColorChooser::ok_cb( w, call );
}
