/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _COLORCHOOSERWALPHA_H
#define _COLORCHOOSERWALPHA_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Wed Jan 19 11:40:37 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:16 1994 by George Kyriazis
 *
 * a color chooser with alpha
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "ColorChooser.h"

#include "TextItem.h"

class ColorChooserWAlpha : public ColorChooser {
  public:
    ColorChooserWAlpha( char *name, Widget parent, GlWindow * );
    virtual ~ColorChooserWAlpha();

    // set the current color
    virtual	void	setValue( GLfloat r, GLfloat g, GLfloat b, GLfloat a = 1 );

  protected:
    void	create_widget( char *name, Widget parent );

    TextItem	alpha_ti;

    RGBAColor	rgba_color;

    // callbacks
    static	void	alphaCB(  VkCallbackObject *, void *, void * );
    virtual	void	alpha_cb( Widget w, XtPointer );
    // here we override behavior
    virtual	void	apply_cb( Widget w, XtPointer );
    // here we must redefine so that "this" doesn't point to the wrong place
    virtual	void	show_cb( Widget w, XtPointer );
    virtual	void	cancel_cb( Widget w, XtPointer );
    virtual	void	ok_cb( Widget w, XtPointer );
    
};

#endif /* _COLORCHOOSERWALPHA_H */
