/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _FAOPS_H
#define _FAOPS_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA
 *
 * Created:       Mon Jan 10 11:00:06 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:14:04 1994 by George Kyriazis
 *
 * Fog and Transparency operations
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "IfaceGenerator.h"

class FAOps : public IfaceGenerator {
  public:
    FAOps( GlWindow * );
    virtual ~FAOps();

    // fog
    void	set_glFog_mode( GLenum mode );
    void	get_glFog_mode( GLenum *mode );
    void	set_glFog_density( GLfloat dens );
    void	get_glFog_density( GLfloat *dens );
    void	set_glFog_start( GLfloat start );
    void	get_glFog_start( GLfloat *start );
    void	set_glFog_end( GLfloat end );
    void	get_glFog_end( GLfloat *end );
    void	set_glFog_index( GLint indx );
    void	get_glFog_index( GLint *indx );
    void	set_glFog_color(GLclampf red,
				GLclampf green,
				GLclampf blue,
				GLclampf alpha );
    void	get_glFog_color(GLclampf *red,
				GLclampf *green,
				GLclampf *blue,
				GLclampf *alpha );
    void	set_fog( Boolean );
    void	get_fog( Boolean * );

    // antialiasing
    void	set_point_smooth( Boolean );
    void	get_point_smooth( Boolean * );
    void	set_line_smooth( Boolean );
    void	get_line_smooth( Boolean * );
    void	set_polygon_smooth( Boolean );
    void	get_polygon_smooth( Boolean * );
    
    virtual	void	reset();

  protected:
    static	int	iface[];
    virtual	int	get_this() { return (int) this; }
    void	install_values();

    virtual	void	remember();

    // local state
    GLenum	_glFog_mode;
    GLfloat	_glFog_density;
    GLfloat	_glFog_start;
    GLfloat	_glFog_end;
    GLint	_glFog_index;
    RGBAColor	_glFog_color;
    Boolean	_fog;
    Boolean	_point_smooth;
    Boolean	_line_smooth;
    Boolean	_polygon_smooth;

    // callbacks
    static	void	cb_set_fog( CB_ARGS );
    static	void	cb_set_glFog_mode( CB_ARGS );
    static	void	cb_set_glFog_density( CB_ARGS );
    static	void	cb_set_glFog_start( CB_ARGS );
    static	void	cb_set_glFog_end( CB_ARGS );
    static	void	cb_set_glFog_index( CB_ARGS );
    static	void	cb_set_glFog_color( CB_ARGS );
    static	void	cb_set_point_smooth( CB_ARGS );
    static	void	cb_set_line_smooth( CB_ARGS );
    static	void	cb_set_polygon_smooth( CB_ARGS );
};

#endif /* _FAOPS_H */
