/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Thu Jan 13 10:36:34 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:10 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "FileName.h"

#include <Xm/RowColumn.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <Xm/FileSB.h>

const char * const FileName::newValue = "newValue";


FileName::FileName( char *Name, Widget Parent )
: VkComponent( Name )
{
    create_widget( Name, Parent );

    patternMask = NULL;
}

FileName::~FileName()
{
}

void
FileName::set_pattern_mask( char *mask )
{
    patternMask = mask;

    
    if( fileDialog ) {
	int	ac;
	Arg	av[3];

	ac = 0;
	XtSetArg( av[ac], XmNpattern, mask ); ac++;
	XtSetValues( fileDialog, av, ac );
    }
}

void
FileName::create_widget( char *name, Widget parent )
{
    int	ac;
    Arg	av[10];

    // create the container first
    ac = 0;
    XtSetArg( av[ac], XmNorientation, XmHORIZONTAL ); ac++;
    rowcol = XmCreateRowColumn( parent,
			       name,
			       av, ac );
    XtManageChild( rowcol );

    label = XmCreateLabel( rowcol,
			  name,
			  NULL, 0 );
    XtManageChild( label );

    // now the button thing
    ac = 0;
    XtSetArg( av[ac], XmNlabelString,
	     XmStringCreateLtoR( "none.rgb", XmFONTLIST_DEFAULT_TAG ) ); ac++;
    button = XmCreatePushButton( rowcol,
				"pushbutton",
				av, ac );
    XtManageChild( button );
    XtAddCallback( button,
		  XmNactivateCallback,
		  &FileName::showCB,
		  (XtPointer) this );

    // filename thingee to be initialized later
    fileDialog = NULL;
}

void
FileName::showCB( Widget, XtPointer client, XtPointer )
{
    FileName *self = (FileName *) client;
    
    if( self->fileDialog == NULL ) {
	Arg	av[5];
	int	ac = 0;

	XtSetArg( av[ac], XmNautoUnmanage, TRUE ); ac++;
	if( self->patternMask ) {
	    XmString xmstr = XmStringCreateLocalized( self->patternMask );
 	    XtSetArg( av[ac], XmNpattern, xmstr ); ac++;
 	}
	self->fileDialog = XmCreateFileSelectionDialog( self->rowcol,
						 "Texture File Name",
						 av, ac );

	XtAddCallback( self->fileDialog, XmNokCallback,
		      (XtCallbackProc) FileName::okCB,
		      (XtPointer) self );
    }

    // manage it
    XtManageChild( self->fileDialog );
}

void
FileName::okCB( Widget, XtPointer client, XtPointer call )
{
    FileName *self = (FileName *) client;
    XmFileSelectionBoxCallbackStruct *cb =
	(XmFileSelectionBoxCallbackStruct *) call;

    char *fname;
    XmStringGetLtoR( cb->value,
		    (XmStringCharSet) XmSTRING_DEFAULT_CHARSET, &fname );

    // update the label
    int	ac;
    Arg	av[3];

    ac = 0;
    XtSetArg( av[ac], XmNlabelString, XmStringCreateLocalized(fname) ); ac++;
    XtSetValues( self->button, av, ac );

    // now that we have the string, call the callbacks
    self->callCallbacks( self->newValue, fname );

}

