/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _FILENAME_H
#define _FILENAME_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Thu Jan 13 10:33:37 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:12 1994 by George Kyriazis
 *
 * a C++ encapsulation of a text item
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

// X defines Object
#define Object XObject
#include <X11/Intrinsic.h>
#undef Object

#include "Object.h"
#include <Vk/VkComponent.h>

class FileName : public Object, public VkComponent {
  public:
    FileName( char *name, Widget parent );
    virtual ~FileName();

    void	set_pattern_mask( char * );
    void	get_pattern_mask( char * );

    // callback
    static const char *const newValue;
    
  protected:
    virtual	void	create_widget( char *name, Widget parent );

    Widget	rowcol;
    Widget	label;
    Widget	button;
    Widget	fileDialog;

    char 	*patternMask;

    // callbacks
    static	void	showCB( Widget w, XtPointer, XtPointer );
    static	void	okCB( Widget w, XtPointer, XtPointer );
    void	ok_cb( Widget w, XtPointer );

};

#endif /* _FILENAME_H */
