/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA
 *
 * Created:       Fri Jan  7 19:10:29 1994 by George Kyriazis
 * Last Modified: Fri Nov 11 14:07:46 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "FragmentOps1.h"

#include <stdlib.h>
#include "IfaceGeneratorP.h"

#include "TextItem.h"

int FragmentOps1::iface[] = {
    IF_BEGIN,
    IF_WINDOW, IF_THIS, NULL,
    (int) "Depth/Alpha/Blend/Dithering Operations", 1,
    
    IF_RADIO, IF_THIS, NULL,
    (int) "Depth Test: ", 2,
    0, (int) &FragmentOps1::cb_set_depth_test,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RADIO, IF_THIS, NULL,
    (int) "Depth Function: ", 8,
    1, (int) &FragmentOps1::cb_set_glDepthFunc,
    (int) "GL_NEVER", GL_NEVER,
    (int) "GL_LESS", GL_LESS,
    (int) "GL_EQUAL", GL_EQUAL,
    (int) "GL_LEQUAL", GL_LEQUAL,
    (int) "GL_GREATER", GL_GREATER,
    (int) "GL_NOTEQUAL", GL_NOTEQUAL,
    (int) "GL_GEQUAL", GL_GEQUAL,
    (int) "GL_ALWAYS", GL_ALWAYS,

    IF_TEXT, IF_THIS, NULL,
    (int) "Near Depth value: ",
    10, (int) "0.0",
    (int) &TextItem::FRACTIONAL,
    (int) &FragmentOps1::cb_set_glDepthRange_near,

    IF_TEXT, IF_THIS, NULL,
    (int) "Far Depth value: ",
    10, (int) "1.0",
    (int) &TextItem::FRACTIONAL,
    (int) &FragmentOps1::cb_set_glDepthRange_far,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

#ifdef OGL_EXTENSIONS
    IF_TEXT, IF_THIS, NULL,
    (int) "Polygon Offset factor (EXT): ",
    10, (int) "0.0",
    (int) &TextItem::FRACTIONAL,
    (int) &FragmentOps1::cb_set_glPolygonOffsetEXT_factor,

    IF_TEXT, IF_THIS, NULL,
    (int) "Polygon Offset bias (EXT): ",
    10, (int) "0.0",
    (int) &TextItem::FRACTIONAL,
    (int) &FragmentOps1::cb_set_glPolygonOffsetEXT_bias,

    IF_RADIO, IF_THIS, NULL,
    (int) "Polygon Offset (EXT): ", 2,
    0, (int) &FragmentOps1::cb_set_polygon_offset_ext,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

#endif
    IF_RADIO, IF_THIS, NULL,
    (int) "Dithering: ", 2,
    1, (int) &FragmentOps1::cb_set_dither,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RADIO, IF_THIS, NULL,
    (int) "Alpha test: ", 2,
    0, (int) &FragmentOps1::cb_set_alpha_test,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RADIO, IF_THIS, NULL,
    (int) "Alpha Function: ", 8,
    7, (int) &FragmentOps1::cb_set_glAlphaFunc_func,
    (int) "GL_NEVER", GL_NEVER,
    (int) "GL_LESS", GL_LESS,
    (int) "GL_EQUAL", GL_EQUAL,
    (int) "GL_LEQUAL", GL_LEQUAL,
    (int) "GL_GREATER", GL_GREATER,
    (int) "GL_NOTEQUAL", GL_NOTEQUAL,
    (int) "GL_GEQUAL", GL_GEQUAL,
    (int) "GL_ALWAYS", GL_ALWAYS,

    IF_TEXT, IF_THIS, NULL,
    (int) "Alpha Ref value: ",
    10, (int) "0.0",
    (int) &TextItem::FRACTIONAL,
    (int) &FragmentOps1::cb_set_glAlphaFunc_ref,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RADIO, IF_THIS, NULL,
    (int) "Blending: ", 2,
    0, (int) &FragmentOps1::cb_set_blend,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RADIO, IF_THIS, NULL,
    (int) "Blend src factor: ", 9,
    IF_VALUE+0, (int) &FragmentOps1::cb_set_glBlendFunc_sfactor,
    (int) "GL_ZERO", GL_ZERO,
    (int) "GL_ONE", GL_ONE,
    (int) "GL_DST_COLOR", GL_DST_COLOR,
    (int) "GL_ONE_MINUS_DST_COLOR", GL_ONE_MINUS_DST_COLOR,
    (int) "GL_SRC_ALPHA", GL_SRC_ALPHA,
    (int) "GL_ONE_MINUS_SRC_ALPHA", GL_ONE_MINUS_SRC_ALPHA,
    (int) "GL_DST_ALPHA", GL_DST_ALPHA,
    (int) "GL_ONE_MINUS_DST_ALPHA", GL_ONE_MINUS_DST_ALPHA,
    (int) "GL_SRC_ALPHA_SATURATE", GL_SRC_ALPHA_SATURATE,
    
    IF_RADIO, IF_THIS, NULL,
    (int) "Blend dst factor: ", 8,
    IF_VALUE+1, (int) &FragmentOps1::cb_set_glBlendFunc_dfactor,
    (int) "GL_ZERO", GL_ZERO,
    (int) "GL_ONE", GL_ONE,
    (int) "GL_SRC_COLOR", GL_SRC_COLOR,
    (int) "GL_ONE_MINUS_SRC_COLOR", GL_ONE_MINUS_SRC_COLOR,
    (int) "GL_SRC_ALPHA", GL_SRC_ALPHA,
    (int) "GL_ONE_MINUS_SRC_ALPHA", GL_ONE_MINUS_SRC_ALPHA,
    (int) "GL_DST_ALPHA", GL_DST_ALPHA,
    (int) "GL_ONE_MINUS_DST_ALPHA", GL_ONE_MINUS_DST_ALPHA,

    IF_END
};

FragmentOps1::FragmentOps1( GlWindow *dwa )
: IfaceGenerator( dwa )
{
    install_this( iface );
    install_values();
    parse( iface );
    remember();
}

FragmentOps1::~FragmentOps1()
{
}

///////////////////////////////////////////////////////////////////

void
FragmentOps1::install_values()
{
    GLenum sfactor, dfactor;

    get_glBlendFunc( &sfactor, &dfactor );
    install( iface, IF_VALUE+0, sfactor );
    install( iface, IF_VALUE+1, dfactor );
}


void
FragmentOps1::remember()
{
    GLfloat	f1, f2;
    GLenum	e;
    GLenum	e1, e2;
    Boolean	b;
    GLclampd	d1, d2;

    get_glAlphaFunc( &e, &f1 );
    get_alpha_test( &b );
    get_glDepthFunc( &e );
    get_glDepthRange( &d1, &d2 );
    get_depth_test( &b );
#ifdef OGL_EXTENSIONS
    get_glPolygonOffsetEXT( &f1, &f2 );
    get_polygon_offset_EXT( &b );
#endif
    get_dither( &b );
    get_glBlendFunc( &e1, &e2 );
    get_blend( &b );
}


///////////////////////////////////////////////////////////////////


//
// alpha testing
//
void
FragmentOps1::set_glAlphaFunc( GLenum func, GLclampf ref )
{
    if( debuglevel > 0 ) {
	char	*f;
	switch( func ) {
	  case GL_NEVER:
	    f = "GL_NEVER";
	    break;
	  case GL_LESS:
	    f = "GL_LESS";
	    break;
	  case GL_EQUAL:
	    f = "GL_EQUAL";
	    break;
	  case GL_LEQUAL:
	    f = "GL_LEQUAL";
	    break;
	  case GL_GREATER:
	    f = "GL_GREATER";
	    break;
	  case GL_NOTEQUAL:
	    f = "GL_NOTEQUAL";
	    break;
	  case GL_GEQUAL:
	    f = "GL_GEQUAL";
	    break;
	  case GL_ALWAYS:
	    f = "GL_ALWAYS";
	    break;
	}
	printf("glAlphaFunc %s %f\n", f, ref );
    }

    glAlphaFunc( func, ref );

    _glAlphaFunc_func = func;
    _glAlphaFunc_ref = ref;

    redraw();
}

void
FragmentOps1::get_glAlphaFunc( GLenum *func, GLclampf *ref )
{
    glGetIntegerv( GL_ALPHA_TEST_FUNC, (int *)func );
    glGetFloatv( GL_ALPHA_TEST_REF, ref );

    _glAlphaFunc_func = *func;
    _glAlphaFunc_ref = *ref;
}

void
FragmentOps1::set_alpha_test( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_ALPHA_TEST\n");
	} else {
	    printf("glDisable GL_ALPHA_TEST\n");
	}
    }

    switch_flag( GL_ALPHA_TEST, bool );

    _alpha_test = bool;

    redraw();
}

void
FragmentOps1::get_alpha_test( Boolean *bool )
{
    Boolean	state = glIsEnabled( GL_ALPHA_TEST );

    _alpha_test = state;

    *bool = state;
}


//
// depth buffering
//

void
FragmentOps1::set_glDepthFunc( GLenum func )
{
    if( debuglevel > 0 ) {
	char *f;
	switch( func ) {
	  case GL_NEVER:
	    f = "GL_NEVER";
	    break;
	  case GL_LESS:
	    f = "GL_LESS";
	    break;
	  case GL_EQUAL:
	    f = "GL_EQUAL";
	    break;
	  case GL_LEQUAL:
	    f = "GL_LEQUAL";
	    break;
	  case GL_GREATER:
	    f = "GL_GREATER";
	    break;
	  case GL_NOTEQUAL:
	    f = "GL_NOTEQUAL";
	    break;
	  case GL_GEQUAL:
	    f = "GL_GEQUAL";
	    break;
	  case GL_ALWAYS:
	    f = "GL_ALWAYS";
	    break;
	}
	printf("glDepthFunc %s\n", f );
    }

    glDepthFunc( func );

    _glDepthFunc = func;

    redraw();
}

void
FragmentOps1::get_glDepthFunc( GLenum *func )
{
    glGetIntegerv( GL_DEPTH_FUNC, (int *)func );

    _glDepthFunc = *func;
}

void
FragmentOps1::set_depth_test( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_DEPTH_TEST\n");
	} else {
	    printf("glDisable GL_DEPTH_TEST\n");
	}
    }
    switch_flag( GL_DEPTH_TEST, bool );

    _depth_test = bool;

    redraw();
}

void
FragmentOps1::get_depth_test( Boolean *bool )
{
    Boolean state = glIsEnabled( GL_DEPTH_TEST );

    _depth_test = state;

    *bool = state;
}

void
FragmentOps1::set_glDepthRange( GLclampd near, GLclampd far )
{
    if( debuglevel > 0 ) {
	printf("glDepthRange %lf %lf\n", near, far );
    }

    glDepthRange( near, far );

    _glDepthRange_near = near;
    _glDepthRange_far = far;

    redraw();
}

void
FragmentOps1::get_glDepthRange( GLclampd *near, GLclampd *far )
{
    GLdouble	v[2];

    glGetDoublev( GL_DEPTH_RANGE, v );

    _glDepthRange_near = v[0];
    _glDepthRange_far = v[1];

    *near = v[0];
    *far = v[1];
}

#ifdef OGL_EXTENSIONS

void
FragmentOps1::set_glPolygonOffsetEXT( GLfloat factor, GLfloat bias )
{
    if( debuglevel > 0 ) {
	printf("glPolygonOffsetEXT %f %f\n", factor, bias );
    }

    glPolygonOffsetEXT( factor, bias );

    _glPolygonOffsetEXT_factor = factor;
    _glPolygonOffsetEXT_bias = bias;

    redraw();
}

void
FragmentOps1::get_glPolygonOffsetEXT( GLfloat *factor, GLfloat *bias )
{
    glGetFloatv( GL_POLYGON_OFFSET_FACTOR_EXT, factor );
    glGetFloatv( GL_POLYGON_OFFSET_BIAS_EXT, bias );

    _glPolygonOffsetEXT_factor = *factor;
    _glPolygonOffsetEXT_bias = *bias;
}

void
FragmentOps1::set_polygon_offset_EXT( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_POLYGON_OFFSET_EXT\n");
	} else {
	    printf("glDisable GL_POLYGON_OFFSET_EXT\n");
	}
    }
    switch_flag( GL_POLYGON_OFFSET_EXT, bool );

    _polygon_offset_ext = bool;

    redraw();
}

void
FragmentOps1::get_polygon_offset_EXT( Boolean *bool )
{
    Boolean state = glIsEnabled( GL_POLYGON_OFFSET_EXT );

    _polygon_offset_ext = state;

    *bool = state;
}
#endif

//
// dithering
//

void
FragmentOps1::set_dither( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_DITHER\n");
	} else {
	    printf("glDisable GL_DITHER\n");
	}
    }
    switch_flag( GL_DITHER, bool );

    _dither = bool;

    redraw();
}

void
FragmentOps1::get_dither( Boolean *bool )
{
    Boolean state = glIsEnabled( GL_DITHER );

    _dither = state;

    *bool = state;
}


//
// blending
//
void
FragmentOps1::set_glBlendFunc( GLenum sfactor, GLenum dfactor )
{
    if( debuglevel > 0 ) {
	char *s;
	char *(ss[2]);
	GLenum e[2];
	
	e[0] = sfactor;
	e[1] = dfactor;

	for( int i = 0; i < 2; i++ ) {
	    switch( e[i] ) {
	      case GL_ZERO:
		s = "GL_ZERO";
		break;
	      case GL_ONE:
		s = "GL_ONE";
		break;
	      case GL_DST_COLOR:
		s = "GL_DST_COLOR";
		break;
	      case GL_ONE_MINUS_DST_COLOR:
		s = "GL_ONE_MINUS_DST_COLOR";
		break;
	      case GL_SRC_COLOR:
		s = "GL_SRC_COLOR";
		break;
	      case GL_ONE_MINUS_SRC_COLOR:
		s = "GL_ONE_MINUS_SRC_COLOR";
		break;
	      case GL_SRC_ALPHA:
		s = "GL_SRC_ALPHA";
		break;
	      case GL_ONE_MINUS_SRC_ALPHA:
		s = "GL_ONE_MINUS_SRC_ALPHA";
		break;
	      case GL_DST_ALPHA:
		s = "GL_DST_ALPHA";
		break;
	      case GL_ONE_MINUS_DST_ALPHA:
		s = "GL_ONE_MINUS_DST_ALPHA";
		break;
	      case GL_SRC_ALPHA_SATURATE:
		s = "GL_SRC_ALPHA_SATURATE";
		break;
	    }
	    ss[i] = s;
	}
	printf("glBlendFunc %s %s\n", ss[0], ss[1] );
    }

    glBlendFunc( sfactor, dfactor );

    _glBlendFunc_sfactor = sfactor;
    _glBlendFunc_dfactor = dfactor;

    redraw();
}

void
FragmentOps1::get_glBlendFunc( GLenum *sfactor, GLenum *dfactor )
{
    glGetIntegerv( GL_BLEND_SRC, (int *) sfactor );
    glGetIntegerv( GL_BLEND_DST, (int *) dfactor );

    _glBlendFunc_sfactor = *sfactor;
    _glBlendFunc_dfactor = *dfactor;
}

void
FragmentOps1::set_blend( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_BLEND\n");
	} else {
	    printf("glDisable GL_BLEND\n");
	}
    }

    switch_flag( GL_BLEND, bool );

    _blend = bool;

    redraw();
}

void
FragmentOps1::get_blend( Boolean *bool )
{
    Boolean state = glIsEnabled( GL_BLEND );

    _blend = state;

    *bool = state;
}

void
FragmentOps1::reset()
{
    int	debugstack;
    Boolean redrawstack;
    
    if( debuglevel <= 1 ) {
	debugstack = debuglevel;
	set_debug_level( 0 );
    }
    if( redrawStatus ) {
	redrawstack = redrawStatus;
	setRedraw( FALSE );
    }

    set_glAlphaFunc( _glAlphaFunc_func, _glAlphaFunc_ref );
    set_alpha_test( _alpha_test );
    set_glDepthFunc( _glDepthFunc );
    set_depth_test( _depth_test );
    set_glDepthRange( _glDepthRange_near, _glDepthRange_far );
    set_dither( _dither );
    set_glBlendFunc( _glBlendFunc_sfactor, _glBlendFunc_dfactor );
    set_blend( _blend );

    if( debuglevel == 0 ) {
	set_debug_level( debugstack );
    }
    if( redrawstack == TRUE ) {
	setRedraw( TRUE );
    }
}


////////////////// callbacks

void
FragmentOps1::cb_set_depth_test( VkCallbackObject *, void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    int	state = (int) call;

    self->set_depth_test( state );
}

void
FragmentOps1::cb_set_glDepthFunc( VkCallbackObject *,
				void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;

    self->set_glDepthFunc( (GLenum) call );
}

void
FragmentOps1::cb_set_glDepthRange_near( VkCallbackObject *,
				       void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *) client;
    GLclampd near = atof( (char *)call );

    GLclampd	Near, Far;
    self->get_glDepthRange( &Near, &Far );

    self->set_glDepthRange( near, Far );
}
    
void
FragmentOps1::cb_set_glDepthRange_far( VkCallbackObject *,
				       void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *) client;
    GLclampd far = atof( (char *)call );

    GLclampd	Near, Far;
    self->get_glDepthRange( &Near, &Far );

    self->set_glDepthRange( Near, far );
}

#ifdef OGL_EXTENSIONS
void
FragmentOps1::cb_set_glPolygonOffsetEXT_factor( VkCallbackObject *,
					       void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *) client;
    GLfloat factor = atof( (char *)call );

    GLfloat Factor, Bias;
    self->get_glPolygonOffsetEXT( &Factor, &Bias );

    self->set_glPolygonOffsetEXT( factor, Bias );
}

void
FragmentOps1::cb_set_glPolygonOffsetEXT_bias( VkCallbackObject *,
					     void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *) client;
    GLfloat bias = atof( (char *)call );

    GLfloat Factor, Bias;
    self->get_glPolygonOffsetEXT( &Factor, &Bias );

    self->set_glPolygonOffsetEXT( Factor, bias );
}

void
FragmentOps1::cb_set_polygon_offset_ext( VkCallbackObject *,
					void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    int state = (int) call;

    self->set_polygon_offset_EXT( state );
}
#endif

void
FragmentOps1::cb_set_dither( VkCallbackObject *, void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    int	state = (int) call;

    self->set_dither( state );
}

void
FragmentOps1::cb_set_alpha_test( VkCallbackObject *, void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    int	state = (int) call;
    
    self->set_alpha_test( state );
}

void
FragmentOps1::cb_set_glAlphaFunc_func( VkCallbackObject *,
				      void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    int new_func = (int) call;

    GLenum	func;
    GLclampf	ref;

    self->get_glAlphaFunc( &func, &ref );
    self->set_glAlphaFunc( new_func, ref );
}

void
FragmentOps1::cb_set_glAlphaFunc_ref( VkCallbackObject *,
				    void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    GLfloat new_ref = atof( (char *)call );

    GLenum	func;
    GLclampf	ref;

    self->get_glAlphaFunc( &func, &ref );
    self->set_glAlphaFunc( func, new_ref );
}


void
FragmentOps1::cb_set_glBlendFunc_sfactor( VkCallbackObject *,
					void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    GLenum new_sfactor = (GLenum) call;

    GLenum sfactor;
    GLenum dfactor;

    self->get_glBlendFunc( &sfactor, &dfactor );
    self->set_glBlendFunc( new_sfactor, dfactor );
}

void
FragmentOps1::cb_set_glBlendFunc_dfactor( VkCallbackObject *,
					void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    GLenum new_dfactor = (GLenum) call;

    GLenum sfactor;
    GLenum dfactor;

    self->get_glBlendFunc( &sfactor, &dfactor );
    self->set_glBlendFunc( sfactor, new_dfactor );
}

void
FragmentOps1::cb_set_blend( VkCallbackObject *, void *client, void *call )
{
    FragmentOps1 *self = (FragmentOps1 *)client;
    int	state = (int) call;
    
    self->set_blend( state );
}


