/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA
 *
 * Created:       Fri Jan  7 19:10:29 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:14:47 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "FragmentOps2.h"

#include <stdlib.h>
#include "IfaceGeneratorP.h"

#include "TextItem.h"

int FragmentOps2::iface[] = {
    IF_BEGIN,
    IF_WINDOW, IF_THIS, NULL,
    (int) "Scissor/Stencil/Logic Operations", 2,
    
    IF_RADIO, IF_THIS, NULL,
    (int) "Scissor: ", 2,
    0, (int) &FragmentOps2::cb_set_scissor,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_TEXT, IF_THIS, NULL,
    (int) "Scissor x:     ",
    5, IF_VALUE+0,
    (int) &TextItem::NUMERIC,
    (int) &FragmentOps2::cb_set_scissor_x,
    
    IF_TEXT, IF_THIS, NULL,
    (int) "Scissor y:     ",
    5, IF_VALUE+1,
    (int) &TextItem::NUMERIC,
    (int) &FragmentOps2::cb_set_scissor_y,
    
    IF_TEXT, IF_THIS, NULL,
    (int) "Scissor width: ",
    5, IF_VALUE+2,
    (int) &TextItem::NUMERIC,
    (int) &FragmentOps2::cb_set_scissor_width,
    
    IF_TEXT, IF_THIS, NULL,
    (int) "Scissor height: ",
    5, IF_VALUE+3,
    (int) &TextItem::NUMERIC,
    (int) &FragmentOps2::cb_set_scissor_height,
    
    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RADIO, IF_THIS, NULL,
    (int) "Stencil: ", 2,
    0, (int) &FragmentOps2::cb_set_stencil_test,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RADIO, IF_THIS, NULL,
    (int) "Stencil op fail: ", 6,
    0, (int) &FragmentOps2::cb_set_glStencilOp_fail,
    (int) "GL_KEEP", GL_KEEP,
    (int) "GL_ZERO", GL_ZERO,
    (int) "GL_REPLACE", GL_REPLACE,
    (int) "GL_INCR", GL_INCR,
    (int) "GL_DECR", GL_DECR,
    (int) "GL_INVERT", GL_INVERT,

    IF_RADIO, IF_THIS, NULL,
    (int) "Stencil op zfail: ", 6,
    0, (int) &FragmentOps2::cb_set_glStencilOp_zfail,
    (int) "GL_KEEP", GL_KEEP,
    (int) "GL_ZERO", GL_ZERO,
    (int) "GL_REPLACE", GL_REPLACE,
    (int) "GL_INCR", GL_INCR,
    (int) "GL_DECR", GL_DECR,
    (int) "GL_INVERT", GL_INVERT,
    
    IF_RADIO, IF_THIS, NULL,
    (int) "Stencil op zpass: ", 6,
    0, (int) &FragmentOps2::cb_set_glStencilOp_zpass,
    (int) "GL_KEEP", GL_KEEP,
    (int) "GL_ZERO", GL_ZERO,
    (int) "GL_REPLACE", GL_REPLACE,
    (int) "GL_INCR", GL_INCR,
    (int) "GL_DECR", GL_DECR,
    (int) "GL_INVERT", GL_INVERT,

    IF_RADIO, IF_THIS, NULL,
    (int) "Stencil test function: ", 8,
    7, (int) &FragmentOps2::cb_set_glStencilFunc_func,
    (int) "GL_NEVER", GL_NEVER,
    (int) "GL_LESS", GL_LESS,
    (int) "GL_EQUAL", GL_EQUAL,
    (int) "GL_LEQUAL", GL_LEQUAL,
    (int) "GL_GREATER", GL_GREATER,
    (int) "GL_NOTEQUAL", GL_NOTEQUAL,
    (int) "GL_GEQUAL", GL_GEQUAL,
    (int) "GL_ALWAYS", GL_ALWAYS,

    IF_TEXT, IF_THIS, NULL,
    (int) "Stencil ref:     ",
    10, IF_VALUE+4,
    (int) &TextItem::NUMERIC,
    (int) &FragmentOps2::cb_set_glStencilFunc_ref,

    IF_TEXT, IF_THIS, NULL,
    (int) "Stencil mask(hex): ",
    16, IF_VALUE+5,
    (int) &TextItem::HEX,
    (int) &FragmentOps2::cb_set_glStencilFunc_mask,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RADIO, IF_THIS, NULL,
    (int) "Boolean functions: ", 2,
    0, (int) &FragmentOps2::cb_set_logic_op,
    (int) "Off", FALSE,
    (int) "On", TRUE,
    
    IF_RADIO, IF_THIS, NULL,
    (int) "Boolean function: ", 16,
    2, (int) &FragmentOps2::cb_set_glLogicOp,
    (int) "GL_CLEAR", GL_CLEAR,
    (int) "GL_SET", GL_SET,
    (int) "GL_COPY", GL_COPY,
    (int) "GL_COPY_INVERTED", GL_COPY_INVERTED,
    (int) "GL_NOOP", GL_NOOP,
    (int) "GL_INVERT", GL_INVERT,
    (int) "GL_AND", GL_AND,
    (int) "GL_NAND", GL_NAND,
    (int) "GL_OR", GL_OR,
    (int) "GL_NOR", GL_NOR,
    (int) "GL_XOR", GL_XOR,
    (int) "GL_EQUIV", GL_EQUIV,
    (int) "GL_AND_REVERSE", GL_AND_REVERSE,
    (int) "GL_AND_INVERTED", GL_AND_INVERTED,
    (int) "GL_OR_REVERSE", GL_OR_REVERSE,
    (int) "GL_OR_INVERTED", GL_OR_INVERTED,

    IF_END
};

FragmentOps2::FragmentOps2( GlWindow *dwa )
: IfaceGenerator( dwa )
{
    install_this( iface );
    install_values();
    parse( iface );
    remember();
}

FragmentOps2::~FragmentOps2()
{
}

///////////////////////////////////////////////////////////////////

void
FragmentOps2::install_values()
{
    int	x, y, width, height;
    get_glScissor( &x, &y, &width, &height );

    install( iface, IF_VALUE+0, (int) itoa(x) );
    install( iface, IF_VALUE+1, (int) itoa(y) );
    install( iface, IF_VALUE+2, (int) itoa(width) );
    install( iface, IF_VALUE+3, (int) itoa(height) );

    GLenum func;
    GLint ref;
    GLuint mask;
    get_glStencilFunc( &func, &ref, &mask );
    install( iface, IF_VALUE+4, (int) itoa(ref) );
    install( iface, IF_VALUE+5, (int) itox(mask) );
}


void
FragmentOps2::remember()
{
    GLint	i;
    GLint	i1, i2, i3, i4;
    GLuint	ui;
    GLenum	e;
    GLenum	e1, e2, e3;
    Boolean	b;

    get_glScissor( &i1, &i2, &i3, &i4 );
    get_scissor( &b );
    get_glStencilOp( &e1, &e2, &e3 );
    get_glStencilFunc( &e, &i, &ui );
    get_stencil_test( &b );
    get_glLogicOp( &e );
    get_logic_op( &b );
}


///////////////////////////////////////////////////////////////////


//
// scissor tests
//

void
FragmentOps2::set_glScissor(GLint x,
			   GLint y,
			   GLsizei width,
			   GLsizei height )
{
    if( debuglevel > 0 ) {
	printf("glScirror %d %d %d %d\n", x, y, width, height );
    }
    glScissor( x, y, width, height );

    _glScissor_x = x;
    _glScissor_y = y;
    _glScissor_width = width;
    _glScissor_height = height;

    redraw();
}

void
FragmentOps2::get_glScissor(GLint *x,
			   GLint *y,
			   GLsizei *width,
			   GLsizei *height )
{
    GLint	v[4];

    glGetIntegerv( GL_SCISSOR_BOX, v );

    *x = v[0];
    *y = v[1];
    *width = v[2];
    *height = v[3];

    _glScissor_x = *x;
    _glScissor_y = *y;
    _glScissor_width = *width;
    _glScissor_height = *height;
}

void
FragmentOps2::set_scissor( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_SCISSOR_TEST\n");
	} else {
	    printf("glDisable GL_SCISSOR_TEST\n");
	}
    }
    switch_flag( GL_SCISSOR_TEST, bool );

    _scissor = bool;

    redraw();
}

void
FragmentOps2::get_scissor( Boolean *bool )
{
    Boolean	state = glIsEnabled( GL_SCISSOR_TEST );

    _scissor = state;

    *bool = state;
}

//
// stencils
//
void
FragmentOps2::set_glStencilOp(GLenum fail,
			     GLenum zfail,
			     GLenum zpass )
{
    if( debuglevel > 0 ) {
	char *s;
	char *(ss[3]);
	GLenum e[3];
	
	e[0] = fail;
	e[1] = zfail;
	e[2] = zpass;

	for( int i = 0; i < 3; i++ ) {
	    switch( e[i] ) {
	      case GL_KEEP:
		s = "GL_KEEP";
		break;
	      case GL_ZERO:
		s = "GL_ZERO";
		break;
	      case GL_REPLACE:
		s = "GL_REPLACE";
		break;
	      case GL_INCR:
		s = "GL_INCR";
		break;
	      case GL_DECR:
		s = "GL_DECR";
		break;
	      case GL_INVERT:
		s = "GL_INVERT";
		break;
	    }
	    ss[i] = s;
	}
	printf("glStencilOp %s %s %s\n", ss[0], ss[1], ss[2] );
    }

    glStencilOp( fail, zfail, zpass );

    _glStencilOp_fail = fail;
    _glStencilOp_zfail = zfail;
    _glStencilOp_zpass = zpass;

    redraw();
}

void
FragmentOps2::get_glStencilOp(GLenum *fail,
			     GLenum *zfail,
			     GLenum *zpass )
{
    glGetIntegerv( GL_STENCIL_FAIL, (int *) fail );
    glGetIntegerv( GL_STENCIL_PASS_DEPTH_FAIL, (int *) zfail );
    glGetIntegerv( GL_STENCIL_PASS_DEPTH_PASS, (int *) zpass );

    _glStencilOp_fail = *fail;
    _glStencilOp_zfail = *zfail;
    _glStencilOp_zpass = *zpass;
}

void
FragmentOps2::set_glStencilFunc(GLenum func,
			       GLint ref,
			       GLuint mask )
{
    if( debuglevel > 0 ) {
	char	*f;
	switch( func ) {
	  case GL_NEVER:
	    f = "GL_NEVER";
	    break;
	  case GL_LESS:
	    f = "GL_LESS";
	    break;
	  case GL_EQUAL:
	    f = "GL_EQUAL";
	    break;
	  case GL_LEQUAL:
	    f = "GL_LEQUAL";
	    break;
	  case GL_GREATER:
	    f = "GL_GREATER";
	    break;
	  case GL_NOTEQUAL:
	    f = "GL_NOTEQUAL";
	    break;
	  case GL_GEQUAL:
	    f = "GL_GEQUAL";
	    break;
	  case GL_ALWAYS:
	    f = "GL_ALWAYS";
	    break;
	}
	printf("glStencilFunc %s %d 0x%x\n", f, ref, mask );
    }

    glStencilFunc( func, ref, mask );

    _glStencilFunc_func = func;
    _glStencilFunc_ref = ref;
    _glStencilFunc_mask = mask;

    redraw();
}

void
FragmentOps2::get_glStencilFunc(GLenum *func,
			       GLint *ref,
			       GLuint *mask )
{
    glGetIntegerv( GL_STENCIL_FUNC, (int *) func );
    glGetIntegerv( GL_STENCIL_REF, (int *) ref );
    glGetIntegerv( GL_STENCIL_VALUE_MASK, (int *) mask );

    _glStencilFunc_func = *func;
    _glStencilFunc_ref = *ref;
    _glStencilFunc_mask = *mask;
}
	

void
FragmentOps2::set_stencil_test( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_STENCIL_TEST\n");
	} else {
	    printf("glDisable GL_STENCIL_TEST\n");
	}
    }

    switch_flag( GL_STENCIL_TEST, bool );

    _stencil_test = bool;

    redraw();
}

void
FragmentOps2::get_stencil_test( Boolean *bool )
{
    Boolean state = glIsEnabled( GL_STENCIL_TEST );

    _stencil_test = state;

    *bool = state;
}

//
// logic ops
//
void
FragmentOps2::set_glLogicOp( GLenum opcode )
{
    if( debuglevel > 0 ) {
	char	*f;
	switch( opcode ) {
	  case GL_CLEAR:
	    f = "GL_CLEAR";
	    break;
	  case GL_SET:
	    f = "GL_SET";
	    break;
	  case GL_COPY:
	    f = "GL_COPY";
	    break;
	  case GL_COPY_INVERTED:
	    f = "GL_COPY_INVERTED";
	    break;
	  case GL_NOOP:
	    f = "GL_NOOP";
	    break;
	  case GL_INVERT:
	    f = "GL_INVERT";
	    break;
	  case GL_AND:
	    f = "GL_AND";
	    break;
	  case GL_NAND:
	    f = "GL_NAND";
	    break;
	  case GL_OR:
	    f = "GL_OR";
	    break;
	  case GL_NOR:
	    f = "GL_NOR";
	    break;
	  case GL_XOR:
	    f = "GL_XOR";
	    break;
	  case GL_EQUIV:
	    f = "GL_EQUIV";
	    break;
	  case GL_AND_REVERSE:
	    f = "GL_AND_REVERSE";
	    break;
	  case GL_AND_INVERTED:
	    f = "GL_AND_INVERTED";
	    break;
	  case GL_OR_REVERSE:
	    f = "GL_OR_REVERSE";
	    break;
	  case GL_OR_INVERTED:
	    f = "GL_OR_INVERTED";
	    break;
	}
	printf("glLogicOp %s\n", f );
    }

    glLogicOp( opcode );

    _glLogicOp = opcode;

    redraw();
}

void
FragmentOps2::get_glLogicOp( GLenum *opcode )
{
    glGetIntegerv( GL_LOGIC_OP_MODE, (int *) opcode );

    _glLogicOp = *opcode;
}

void
FragmentOps2::set_logic_op( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_LOGIC_OP\n");
	} else {
	    printf("glDisable GL_LOGIC_OP\n");
	}
    }

    switch_flag( GL_LOGIC_OP, bool );

    _logic_op = bool;

    redraw();
}

void
FragmentOps2::get_logic_op( Boolean *bool )
{
    Boolean state = glIsEnabled( GL_LOGIC_OP );

    _logic_op = state;

    *bool = state;
}


void
FragmentOps2::reset()
{
    int	debugstack;
    Boolean redrawstack;
    
    if( debuglevel <= 1 ) {
	debugstack = debuglevel;
	set_debug_level( 0 );
    }
    if( redrawStatus ) {
	redrawstack = redrawStatus;
	setRedraw( FALSE );
    }

    set_glScissor( _glScissor_x, _glScissor_y,
		  _glScissor_width, _glScissor_height );
    set_scissor( _scissor );
    set_glStencilOp( _glStencilOp_fail, _glStencilOp_zfail,
		    _glStencilOp_zpass );
    set_stencil_test( _stencil_test );
    set_glLogicOp( _glLogicOp );
    set_logic_op( _logic_op );

    if( debuglevel == 0 ) {
	set_debug_level( debugstack );
    }
    if( redrawstack == TRUE ) {
	setRedraw( TRUE );
    }
}


////////////////// callbacks

void
FragmentOps2::cb_set_scissor( VkCallbackObject *, void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    int	state = (int) call;
    
    self->set_scissor( state );
}

void
FragmentOps2::cb_set_scissor_x( VkCallbackObject *, void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    int	new_x = atoi( (char *)call );

    GLint	x, y;
    GLsizei	width, height;

    self->get_glScissor( &x, &y, &width, &height );
    self->set_glScissor( new_x, y, width, height );
}

void
FragmentOps2::cb_set_scissor_y( VkCallbackObject *, void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    int	new_y = atoi( (char *)call );
    
    GLint	x, y;
    GLsizei	width, height;

    self->get_glScissor( &x, &y, &width, &height );
    self->set_glScissor( x, new_y, width, height );
}

void
FragmentOps2::cb_set_scissor_width( VkCallbackObject *, void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    int	new_width = atoi( (char *)call );
    
    GLint	x, y;
    GLsizei	width, height;

    self->get_glScissor( &x, &y, &width, &height );
    self->set_glScissor( x, y, new_width, height );
}

void
FragmentOps2::cb_set_scissor_height( VkCallbackObject *, void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    int	new_height = atoi( (char *)call );
    
    GLint	x, y;
    GLsizei	width, height;

    self->get_glScissor( &x, &y, &width, &height );
    self->set_glScissor( x, y, width, new_height );
}

void
FragmentOps2::cb_set_stencil_test( VkCallbackObject *, void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    int state = (int) call;

    self->set_stencil_test( state );
}

void
FragmentOps2::cb_set_glStencilOp_fail( VkCallbackObject *,
				     void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    GLenum new_fail = (GLenum) call;

    GLenum fail, zfail, zpass;

    self->get_glStencilOp( &fail, &zfail, &zpass );
    self->set_glStencilOp( new_fail, zfail, zpass );
}

void
FragmentOps2::cb_set_glStencilOp_zfail( VkCallbackObject *,
				     void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    GLenum new_zfail = (GLenum) call;

    GLenum fail, zfail, zpass;

    self->get_glStencilOp( &fail, &zfail, &zpass );
    self->set_glStencilOp( fail, new_zfail, zpass );
}

void
FragmentOps2::cb_set_glStencilOp_zpass( VkCallbackObject *,
				     void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    GLenum new_zpass = (GLenum) call;

    GLenum fail, zfail, zpass;

    self->get_glStencilOp( &fail, &zfail, &zpass );
    self->set_glStencilOp( fail, zfail, new_zpass );
}

void
FragmentOps2::cb_set_glStencilFunc_func( VkCallbackObject *,
				       void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    GLenum new_func = (GLenum) call;

    GLenum	func;
    GLint	ref;
    GLuint	mask;

    self->get_glStencilFunc( &func, &ref, &mask );
    self->set_glStencilFunc( new_func, ref, mask );
}

void
FragmentOps2::cb_set_glStencilFunc_ref( VkCallbackObject *,
				       void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    GLint new_ref = (GLint) atoi((char *)call);

    GLenum	func;
    GLint	ref;
    GLuint	mask;

    self->get_glStencilFunc( &func, &ref, &mask );
    self->set_glStencilFunc( func, new_ref, mask );
}

void
FragmentOps2::cb_set_glStencilFunc_mask( VkCallbackObject *,
				       void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    GLuint new_mask = (GLuint) xtoi((char *)call);

    GLenum	func;
    GLint	ref;
    GLuint	mask;

    self->get_glStencilFunc( &func, &ref, &mask );
    self->set_glStencilFunc( func, ref, new_mask );
}


void
FragmentOps2::cb_set_glLogicOp( VkCallbackObject *,
			    void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    GLenum new_opcode = (GLenum) call;

    self->set_glLogicOp( new_opcode );
}

void
FragmentOps2::cb_set_logic_op( VkCallbackObject *, void *client, void *call )
{
    FragmentOps2 *self = (FragmentOps2 *)client;
    int	bool = (int) call;

    self->set_logic_op( bool );
}

