/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Jul 12 13:27:02 1994 by George Kyriazis
 * Last Modified: Mon Aug  1 18:47:50 1994 by George Kyriazis
 *
 * how to render the user-defined shape
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "GlUserDef1.h"

#include <GL/gl.h>
#include <Inventor/actions/SoGLRenderAction.h>
#include <Inventor/SbBox.h>

SO_NODE_SOURCE(GlUserDef1);

GlUserDef1::GlUserDef1()
{
    SO_NODE_CONSTRUCTOR(GlUserDef1);
    isBuiltIn = TRUE;

#ifdef FILL_HERE
//
// add the fields you added in the .h file....
// so we can read from a file.  Include a default value.
//
    SO_NODE_ADD_FIELD(parts,		(ALL));
    SO_NODE_ADD_FIELD(bottomRadius,	(1.0));
    SO_NODE_ADD_FIELD(height,	(2.0));
#endif

#ifdef FILL_HERE
//
// this maybe needed too, in case we are doing enums
//
    // Set up static info for enumerated type field
    SO_NODE_DEFINE_ENUM_VALUE(Part, SIDES);
    SO_NODE_DEFINE_ENUM_VALUE(Part, BOTTOM);
    SO_NODE_DEFINE_ENUM_VALUE(Part, ALL);

    // Set up info in enumerated type field
    SO_NODE_SET_SF_ENUM_TYPE(parts, Part);
#endif
}

GlUserDef1::~GlUserDef1()
{
}

void
GlUserDef1::initClass()
{
    SO__NODE_INIT_CLASS(GlUserDef1, "UserDef1", SoShape );
}

void
GlUserDef1::computeBBox(SoAction *, SbBox3f &box, SbVec3f &center )
{
#ifdef FILL_HERE
    // add here code that will calculate the bounding box
    // of this shape.
#else
    box.setBounds( -1, -1, -1, 1, 1, 1 );
    center.setValue( 0, 0, 0 );
#endif
}


void
GlUserDef1::GLRender(SoGLRenderAction *action)
{
    // First see if the object is visible and should be rendered now
    if (! shouldGLRender(action))
	return;

    GLRenderGeneric(action);
}

/*
** fake it...   Don't do anything
*/
void
GlUserDef1::generatePrimitives(SoAction *)
{
}


void
GlUserDef1::GLRenderGeneric(SoGLRenderAction *action)
{
#ifdef FILL_HERE
// add your OpenGL code here
#endif
}


