/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _GLUSERDEF1_H
#define _GLUSERDEF1_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Jul 12 13:24:27 1994 by George Kyriazis
 * Last Modified: Mon Aug  1 18:46:54 1994 by George Kyriazis
 *
 * a user-definable shape
 *
 * Please search for FILL_HERE for places you need to insert code
 *  examples are given..  put your own instead.
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include <Inventor/nodes/SoShape.h>

#include <Inventor/SbLinear.h>
#include <Inventor/fields/SoSFBitMask.h>
#include <Inventor/fields/SoSFFloat.h>


class GlUserDef1 : public SoShape {

    SO_NODE_HEADER(GlUserDef1);

  public:

#ifdef FILL_HERE
// add fields as needed
    // Fields
    SoSFBitMask		parts;		// Visible parts of cone
    SoSFFloat		bottomRadius;	// Radius of bottom circular face
    SoSFFloat		height;		// Size in y dimension
#endif

    // Constructor
    GlUserDef1();

  SoEXTENDER public:
    // Implement actions

    virtual void	GLRender(SoGLRenderAction *action);
    virtual void	generatePrimitives(SoAction *action);

  SoINTERNAL public:
    static void		initClass();

  protected:
      virtual	void	computeBBox(SoAction *action, SbBox3f &box,
				    SbVec3f &center );

  private:

    // Destructor
    virtual ~GlUserDef1();

    // These render the cone
    void		GLRenderGeneric(SoGLRenderAction *action);

};

#endif /* _GLUSERDEF1_H */
