/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
// This may look like C code, but it is really -*- C++ -*-


/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Wed Jan 26 11:15:51 1994 by George Kyriazis
 * Last Modified: Tue Oct 18 15:03:11 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

// shouldn't be doing this, but oh well.
#define private protected

#include "GlWindow.h"
#include <GL/glx.h>

#include "FBControl.h"
#include "FragmentOps1.h"
#include "FragmentOps2.h"
#include "TextureOps.h"
#include "TexGenOps.h"
#include "FAOps.h"
#include "RasterOps.h"
#include "LightAndShade.h"
#include "MaterialProps.h"
#include "Hints.h"
#include "ModelClipPlanes.h"
#include "Transforms.h"

#include <Vk/VkApp.h>
#include <Vk/VkSubMenu.h>
#include <Vk/VkMenuBar.h>

#include <Xm/FileSB.h>

#include <Inventor/SoDB.h>
#include <Inventor/Xt/SoXt.h>
#include <Inventor/nodes/SoSelection.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/nodes/SoCallback.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoCylinder.h>
#include <Inventor/nodes/SoFaceSet.h>
#include <Inventor/nodes/SoIndexedFaceSet.h>
#include <Inventor/nodes/SoSwitch.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/nodes/SoPackedColor.h>
#include <Inventor/manips/SoCenterballManip.h>
#include <Inventor/manips/SoHandleBoxManip.h>
#include <Inventor/manips/SoJackManip.h>
#include <Inventor/manips/SoTabBoxManip.h>
#include <Inventor/manips/SoTrackballManip.h>
#include <Inventor/manips/SoTransformBoxManip.h>
#include <Inventor/actions/SoGetBoundingBoxAction.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/errors/SoDebugError.h>
#include <Inventor/elements/SoGLPolygonStippleElement.h>
#include <Inventor/SoPickedPoint.h>

#include <Inventor/SbTime.h>

#include "GlSceneMgr.h"

// some gross defines from image.h, since original file is
// not c++ compatible..  IIick..
extern "C" {

typedef struct {
    unsigned short      imagic;         /* stuff saved on disk . . */
    unsigned short      type;
    unsigned short      dim;
    unsigned short      xsize;
    unsigned short      ysize;
    unsigned short      zsize;
    unsigned long       min;
    unsigned long       max;
    unsigned long       wastebytes;
    char                name[80];
    unsigned long       colormap;
} IMAGE;
extern IMAGE *fiopen(int, const char *, int = 0, int = 0,
                     int = 0, int = 0, int = 0);
extern void putrow(IMAGE *, short *, unsigned int, unsigned int);
extern void iclose(IMAGE *);
};  /* end of extern "C" */
#define TYPEMASK        0xff00
#define BPPMASK         0x00ff
#define ITYPE_VERBATIM  0x0000
#define ITYPE_RLE       0x0100
#define ISRLE(type)             (((type) & 0xff00) == ITYPE_RLE)
#define ISVERBATIM(type)        (((type) & 0xff00) == ITYPE_VERBATIM)
#define BPP(type)               ((type) & BPPMASK)
#define RLE(bpp)                (ITYPE_RLE | (bpp))
#define VERBATIM(bpp)           (ITYPE_VERBATIM | (bpp))
#define IBUFSIZE(pixels)        ( (pixels+(pixels>>6))*sizeof(long) )
#define RLE_NOP         0x00




#define pixmap_bits_width 24
#define pixmap_bits_height 24
static char pixmap_bits_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x44, 0x00, 0x3c, 0x44, 0x00, 0x24, 0x28, 0x00,
   0x24, 0x11, 0x00, 0x3c, 0x29, 0x00, 0x04, 0x45, 0x00, 0x04, 0x45, 0x00,
   0x00, 0x01, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x10, 0x01, 0x0f, 0xb0, 0x01, 0x09, 0x50, 0x01, 0x09, 0x10, 0x39, 0x0f,
   0x10, 0x45, 0x01, 0x10, 0x45, 0x01, 0x00, 0x7c, 0x00, 0x00, 0x44, 0x00,
   0x00, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

//
// what type of viewer
//
enum ViewerPushButtons {
    PICK_PUSH = 0,
    VIEW_PUSH,
    HOME_PUSH,
    SET_HOME_PUSH,
    VIEW_ALL_PUSH,
    SEEK_PUSH,
    PIXMAP_PUSH,

    PUSH_NUM
};

//
// what type of manipulator
//
enum ManipulatorType {
    TRACKBALL_MANIP = 0,
    HANDLEBOX_MANIP,
    JACK_MANIP,
    CENTERBALL_MANIP,
    XFORMBOX_MANIP,
    TABBOX_MANIP,
    NONE_MANIP,

    MAXNUM_MANIP
};

typedef struct {
    GlWindow *self;
    int	type;
} ManipCallbackStruct;

static	ManipCallbackStruct	manipCallbackStruct[MAXNUM_MANIP];

//
// what type of popup
//
enum PopupType {
    FB_CONTROL_PU = 0,
    FRAG_OPS1_PU,
    FRAG_OPS2_PU,
    TEXTURE_OPS_PU,
    TEX_GEN_OPS_PU,
    FA_OPS_PU,
    RASTER_OPS_PU,
    LIGHT_SHADE_PU,
    MATERIAL_PU,
    HINTS_PU,
    MODEL_CLIP_PLANES_PU,
    TRANSFORMS_PU,

    MAXNUM_PU
    };

typedef struct {
    GlWindow *self;
    int type;
} PopupCallbackStruct;

static	PopupCallbackStruct	popupCallbackStruct[MAXNUM_PU];

//
// what type of view matrix
//
enum CameraType {
    ORTHOGRAPHIC_CAMERA,
    PERSPECTIVE_CAMERA,

    MAXNUM_CAMERA
};

typedef struct {
    GlWindow *self;
    int type;
} CameraCallbackStruct;

static CameraCallbackStruct	cameraCallbackStruct[MAXNUM_CAMERA];

typedef struct {
    GlWindow *self;
    int	type;
} VisualTypeCallbackStruct;

static VisualTypeCallbackStruct	*visualTypeCallbackStruct;

GlWindow::GlWindow( VkApp *, char *name )
: VkWindow( name ),

  SoXtExaminerViewer(mainWindowWidget(),
		     name,
		     TRUE,
		     SoXtFullViewer::BUILD_DECORATION,
		     SoXtViewer::EDITOR,
		     FALSE )
{
    // initialize various vars
    not_realized = TRUE;
    fileDialog = NULL;
    manip = NULL;
    xfPath = NULL;
    currentManipType = NONE_MANIP;
    updateMode = TRUE;
    
    visualTypeCallbackStruct = NULL;
    vislist = NULL;
    rgbaMode = FALSE;
    dbufMode = FALSE;
    ciDepth = 1;
    rDepth = gDepth = bDepth = aDepth = 1;
    zDepth = 1;
    sDepth = 1;
    accumRDepth = accumGDepth = accumBDepth = accumADepth = 1;
    stereoMode = FALSE;

    fbControl = NULL;
    fragmentOps1 = NULL;
    fragmentOps2 = NULL;
    textureOps = NULL;
    texGenOps = NULL;
    faOps = NULL;
    rasterOps = NULL;
    lightAndShade = NULL;
    materialProps = NULL;
    hints = NULL;
    modelClipPlanes = NULL;
    transforms = NULL;

    showFPSmode = FALSE;

    // clear the list of buttons
    buttonList = new SoXtBitmapButton * [PUSH_NUM];
    int i;
    for( i = 0; i < PUSH_NUM; i++ ) {
	buttonList[i] = NULL;
    }
    
    // create the menubar
    createMenuBar();
    
    // create our own nodes
    toplevelNode = new SoSelection( 3 );
    toplevelNode->ref();
    preExtenderNode = new SoGroup( 10 );
    preExtenderNode->ref();
    postExtenderNode = new SoGroup( 10 );
    postExtenderNode->ref();
    // this callback is used to grab the model-view and projection
    // matrices, so we can see them, among other things that are
    // needed for inventor
    cameraCbNode = new SoCallback();
    cameraCbNode->ref();
    cameraCbNode->setCallback( grabCameraCB, this );

    localSceneGraph = NULL;
    
    toplevelNode->renderCaching.setValue( SoSeparator::OFF );
    toplevelNode->renderCulling.setValue( SoSeparator::OFF );
    
    // fix the selection callbacks
    toplevelNode->addSelectionCallback(GlWindow::selectionCallback, this );
    toplevelNode->addDeselectionCallback(GlWindow::deselectionCallback, this );
    toplevelNode->setPickFilterCallback(GlWindow::pickFilterCallback, this );
    
    // create a new scene manager (we need it!)
    sceneManager = new GlSceneManager();
    sceneManager->setRenderCallback( SoXtRenderArea::renderCB,
				    (SoXtRenderArea *) this );
    setSceneManager( sceneManager );
    
    // allocate our cameras
    orthographicCamera = new SoOrthographicCamera;
    orthographicCamera->ref();
    perspectiveCamera = new SoPerspectiveCamera;
    perspectiveCamera->ref();
    
    // tell the scene manager what to render
    sceneManager->setSceneGraph( toplevelNode );
    
    // alter decoration
    setDecoration( FALSE );
    leftTrimForm = NULL;
    setDecoration( TRUE );

    // set various modes
    setRgbaMode( TRUE );
    setDbufMode( TRUE );

    // a hack for zbuffering..
    // Basically, make the drawing style simple enough, so that Inventor
    // will not enable depth buffering behind our backs..
    setDrawStyle( SoXtViewer::STILL, SoXtViewer::VIEW_BBOX );
    setDrawStyle( SoXtViewer::INTERACTIVE, SoXtViewer::VIEW_BBOX );
}

GlWindow::~GlWindow()
{
    toplevelNode->unref();

    // get rid of the buttons
    int i;
    for( i = 0; i < PUSH_NUM; i++ ) {
	if( buttonList[i] ) {
	    delete buttonList[i];
	}
    }
}

////////////////////////////////////////////////////////////////

void
GlWindow::alterGlAttribList()
{
    // first get rid of what they had
    delete [] attribList;

    attribList = new int [50];

    int	i = 0;

    // rgba or colorindex
    if( rgbaMode ) {
	attribList[i++] = GLX_RGBA;
    }

    // double buffer
    if( dbufMode ) {
	attribList[i++] = GLX_DOUBLEBUFFER;
    }

    // set a level of 0
    attribList[i++] = GLX_LEVEL;
    attribList[i++] = 0;

    if( rgbaMode ) {
	// size of the RGBA buffers
	attribList[i++] = GLX_RED_SIZE;
	attribList[i++] = rDepth;
	attribList[i++] = GLX_GREEN_SIZE;
	attribList[i++] = gDepth;
	attribList[i++] = GLX_BLUE_SIZE;
	attribList[i++] = bDepth;
	attribList[i++] = GLX_ALPHA_SIZE;
	attribList[i++] = aDepth;
    } else {
	// size of the CI buffes
	attribList[i++] = GLX_BUFFER_SIZE;
	attribList[i++] = ciDepth;
    }

    // size of the depth buffer
    attribList[i++] = GLX_DEPTH_SIZE;
    attribList[i++] = zDepth;

    // size of the stencil buffers
    attribList[i++] = GLX_STENCIL_SIZE;
    attribList[i++] = sDepth;

    // size of the accumulation buffers
    if( rgbaMode ) {
	attribList[i++] = GLX_ACCUM_RED_SIZE;
	attribList[i++] = accumRDepth;
	attribList[i++] = GLX_ACCUM_GREEN_SIZE;
	attribList[i++] = accumGDepth;
	attribList[i++] = GLX_ACCUM_BLUE_SIZE;
	attribList[i++] = accumBDepth;
	attribList[i++] = GLX_ACCUM_ALPHA_SIZE;
	attribList[i++] = accumADepth;
    }

    // that's it!
    attribList[i++] = NULL;
}

void
GlWindow::setDbufMode( Boolean state )
{
    setVisualType( rgbaMode, state, ciDepth );
}

void
GlWindow::setCiDepth( int d )
{
    setVisualType( rgbaMode, dbufMode, d );
}

void
GlWindow::setRgbaMode( Boolean state )
{
    setVisualType( state, dbufMode, ciDepth );
}

void
GlWindow::setVisualType( Boolean rgba_mode,
			Boolean dbuf_mode,
			int ci_depth,
			int r_depth,
			int g_depth,
			int b_depth,
			int a_depth,
			int z_depth,
			int s_depth,
			int accum_rdepth,
			int accum_gdepth,
			int accum_bdepth,
			int accum_adepth,
			Boolean stereo )
{
    rgbaMode = rgba_mode;
    dbufMode = dbuf_mode;
    ciDepth = ci_depth;
    rDepth = r_depth;
    gDepth = g_depth;
    bDepth = b_depth;
    aDepth = a_depth;
    zDepth = z_depth;
    sDepth = s_depth;
    accumRDepth = accum_rdepth;
    accumGDepth = accum_gdepth;
    accumBDepth = accum_bdepth;
    accumADepth = accum_adepth;
    stereoMode = stereo;

    if( rgba_mode ) {
	glModes |= SO_GLX_RGB;
    } else {
	glModes &= ~SO_GLX_RGB;
    }

    if( dbuf_mode ) {
	glModes |= SO_GLX_DOUBLE;
    } else {
	glModes &= ~SO_GLX_DOUBLE;
    }

    alterGlAttribList();

    buildVisual();

    // let the popups reset their values
    if( fbControl ) fbControl->reset();
    if( fragmentOps1 ) fragmentOps1->reset();
    if( fragmentOps2 ) fragmentOps2->reset();
    if( textureOps ) textureOps->reset();
    if( texGenOps ) texGenOps->reset();
    if( faOps ) faOps->reset();
    if( rasterOps ) rasterOps->reset();
    if( lightAndShade ) lightAndShade->reset();
    if( materialProps ) materialProps->reset();
    if( hints ) hints->reset();
    if( modelClipPlanes ) modelClipPlanes->reset();
    if( transforms ) transforms->reset();
}

void
GlWindow::buildVisual()
{
    // build a visual if we can
    Widget w = getWidget();
    if( w == NULL ) return;

    // the following is done only if we are realized.
    
    Display *dpy = XtDisplay(w);
    int scn = DefaultScreen( dpy );

    // first try to find an exact match on the visual
    XVisualInfo match, *vi;
    int	found, i;

    match.screen = scn;
    vi = XGetVisualInfo( dpy, VisualScreenMask, &match, &found );

    vis = NULL;

    for( i = 0; i < found; i++, vi++ ) {
	int _bufferSize, _rgba, _db, _stereo;
	int _rSize, _gSize, _bSize, _aSize;
	int _depthSize, _sSize;
	int _arSize, _agSize, _abSize, _aaSize;

	glXGetConfig( dpy, vi, GLX_BUFFER_SIZE, &_bufferSize );
	glXGetConfig( dpy, vi, GLX_RGBA, &_rgba );
	glXGetConfig( dpy, vi, GLX_DOUBLEBUFFER, &_db );
	glXGetConfig( dpy, vi, GLX_STEREO, &_stereo );
	glXGetConfig( dpy, vi, GLX_RED_SIZE, &_rSize );
	glXGetConfig( dpy, vi, GLX_GREEN_SIZE, &_gSize );
	glXGetConfig( dpy, vi, GLX_BLUE_SIZE, &_bSize );
	glXGetConfig( dpy, vi, GLX_ALPHA_SIZE, &_aSize );
	glXGetConfig( dpy, vi, GLX_DEPTH_SIZE, &_depthSize );
	glXGetConfig( dpy, vi, GLX_STENCIL_SIZE, &_sSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_RED_SIZE, &_arSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_GREEN_SIZE, &_agSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_BLUE_SIZE, &_abSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_ALPHA_SIZE, &_aaSize );

	if( (_bufferSize == ciDepth) &&
	   (_rgba == rgbaMode) &&
	   (_db == dbufMode) &&
	   (_stereo == stereoMode) &&
	   (_rSize == rDepth) &&
	   (_gSize == gDepth) &&
	   (_bSize == bDepth) &&
	   (_aSize == aDepth) &&
	   (_depthSize == zDepth) &&
	   (_sSize == sDepth) &&
	   (_arSize == accumRDepth) &&
	   (_agSize == accumGDepth) &&
	   (_abSize == accumBDepth) &&
	   (_aaSize == accumADepth) ) {
	    match.visualid = vi->visualid;
	    match.screen = scn;
	    vis = XGetVisualInfo(dpy, VisualIDMask|VisualScreenMask,
				 &match, &found );
	    break;
	}
    }

    // if exact match not found, try to see what glXChooseVisual
    // will choose for us.
    if( vis == NULL ) {
	vis = glXChooseVisual( dpy, scn, attribList );
    }

    if( vis == NULL ) {
	SoDebugError::post("GlWindow::buildVisual", "NULL visual");
	return;
    }
    
    // now that attrib list is altered, rebuild the window
    setNormalVisual( vis );

    if( rgbaMode == FALSE ) {	// color index mode
	// build the colormap
	buildColormap();
    }
}

void
GlWindow::buildColormap()
{
    int	max;
    int	i;
    XColor	c;

    Widget	w = getWidget();
    Display	*dpy = XtDisplay( w );

    printf("Allocated colormap of size %d, only asked %d\n",
	   vis->colormap_size,
	   1 << ciDepth );

    max = 1 << ciDepth;

    float I;
    int	r, g, b;
    switch( vis->c_class ) {
      case GrayScale:
	// a grey colormap
	I = 0;
	for( i = 0; i < max; i++ ) {
	    c.pixel = i;
	    c.red = (unsigned short)(I * 65535);
	    c.green = (unsigned short)(I * 65535);
	    c.blue = (unsigned short)(I * 65535);
	    c.flags = DoRed | DoGreen | DoBlue;
	    XStoreColor( dpy, colorMap, &c );

	    I += 1. / max;
	}
	break;
	
      case DirectColor:
      case PseudoColor:
	switch( max ) {
	  case 4096:
	    // a 16x16x16 (colors) colormap
	    for( r = 0; r < 16; r++ ) {
		for( g = 0; g < 16; g++ ) {
		    for( b = 0; b < 16; b++ ) {
			c.pixel = r*256 + g*16 + b;
			c.red =	r * 4096;
			c.green = g * 4096;
			c.blue = b * 4096;
			c.flags = DoRed | DoGreen | DoBlue;
			XStoreColor( dpy, colorMap, &c );
		    }
		}
	    }
	    break;

	  case 256:
	    // a 8x8x4 colormap
	    for( r = 0; r < 8; r++ ) {
		for( g = 0; g < 8; g++ ) {
		    for(b = 0; b < 4; b++ ) {
			c.pixel = r*32 + g*4 + b;
			c.red = r * 8192;
			c.green = g * 8192;
			c.blue = b * 16384;
			c.flags = DoRed | DoGreen | DoBlue;
			XStoreColor( dpy, colorMap, &c );
		    }
		}
	    }
	    break;

	  case 16:
	    // a grey colormap (not too many colors for anything else)
	    I = 0;
	    for( i = 0; i < max; i++ ) {
		c.pixel = i;
		c.red = (unsigned short)(I * 65535);
		c.green = (unsigned short)(I * 65535);
		c.blue = (unsigned short)(I * 65535);
		c.flags = DoRed | DoGreen | DoBlue;
		XStoreColor( dpy, colorMap, &c );

		I += 1. / max;
	    }
	    break;
	}
    }
}

void
GlWindow::setNormalVisual( XVisualInfo *vis )
{
    destroyNormalWindows();
    buildNormalGLXWidget( vis );
}

Widget
GlWindow::setUpInterface( Widget parent )
{
    buildWidget( parent );
    SoXtComponent::_baseWidget = mainWindowWidget();

    return mgrWidget;
}

void
GlWindow::set_model_view( GLfloat * )
{
    // not here yet..  Will be filled whenever we need it.
}

void
GlWindow::afterRealizeHook()
{
    not_realized = FALSE;

    // these are needed because we are messing around with
    // Inventors widgets a whee bit too much
    ShellMapped = TRUE;
    widgetMapped = TRUE;
    
    // could not set the camera before realization...
    // SoXtExaminerViewer::defineCursors() barfed.
    if( localSceneGraph ) {
	setSceneGraph( localSceneGraph );
    }

    // now that things are settled, create the popups
    // (they need GL to be initialized properly)
    createPopups();
}

void
GlWindow::setUpdateMode( Boolean state )
{
    updateMode = state;

    if( fbControl ) {
	fbControl->setRedraw( state );
	fragmentOps1->setRedraw( state );
	fragmentOps2->setRedraw( state );
	textureOps->setRedraw( state );
	texGenOps->setRedraw( state );
	faOps->setRedraw( state );
	rasterOps->setRedraw( state );
	lightAndShade->setRedraw( state );
	materialProps->setRedraw( state );
	hints->setRedraw( state );
	modelClipPlanes->setRedraw( state );
	transforms->setRedraw( state );
    }
}
	

void
GlWindow::createPopups()
{
    // create instances
    fbControl = new FBControl( this );
    fragmentOps1 = new FragmentOps1( this );
    fragmentOps2 = new FragmentOps2( this );
    textureOps = new TextureOps( this );
    texGenOps = new TexGenOps( this );
    faOps = new FAOps( this );
    rasterOps = new RasterOps( this );
    lightAndShade = new LightAndShade( this );
    materialProps = new MaterialProps( this );
    hints = new Hints( this );
    modelClipPlanes = new ModelClipPlanes( this );
    transforms = new Transforms( this );

    // set debug level (for printing)
    fbControl->set_debug_level( 1 );
    fragmentOps1->set_debug_level( 1 );
    fragmentOps2->set_debug_level( 1 );
    textureOps->set_debug_level( 1 );
    texGenOps->set_debug_level( 1 );
    faOps->set_debug_level( 1 );
    rasterOps->set_debug_level( 1 );
    lightAndShade->set_debug_level( 1 );
    materialProps->set_debug_level( 1 );
    hints->set_debug_level( 1 );
    modelClipPlanes->set_debug_level( 1 );
    transforms->set_debug_level( 1 );

    // set redraw status
    fbControl->setRedraw( updateMode );
    fragmentOps1->setRedraw( updateMode );
    fragmentOps2->setRedraw( updateMode );
    textureOps->setRedraw( updateMode );
    texGenOps->setRedraw( updateMode );
    faOps->setRedraw( updateMode );
    rasterOps->setRedraw( updateMode );
    lightAndShade->setRedraw( updateMode );
    materialProps->setRedraw( updateMode );
    hints->setRedraw( updateMode );
    modelClipPlanes->setRedraw( updateMode );
    transforms->setRedraw( updateMode );
}

void
GlWindow::createMenuBar()
{
    int	i;
    
    // a generic "File" menu...  
    VkSubMenu *menu_pane = addMenuPane( "File" );

    menu_pane->addAction( "Open...", &GlWindow::openCB, (XtPointer) this );
    menu_pane->addAction( "Quit", &GlWindow::quitCB, (XtPointer) this );

    for( i = 0; i < MAXNUM_MANIP; i++ ) {
	manipCallbackStruct[i].self = this;
	manipCallbackStruct[i].type = i;
    }

    // a menu for the manipulator types
    menu_pane = addMenuPane( "Manips" );

    menu_pane->addAction( "Trackball", &GlWindow::setManipCB,
			 (XtPointer) &manipCallbackStruct[TRACKBALL_MANIP] );
    menu_pane->addAction( "HandleBox", &GlWindow::setManipCB,
			 (XtPointer) &manipCallbackStruct[HANDLEBOX_MANIP] );
    menu_pane->addAction( "Jack", &GlWindow::setManipCB,
			 (XtPointer) &manipCallbackStruct[JACK_MANIP] );
    menu_pane->addAction( "Centerball", &GlWindow::setManipCB,
			 (XtPointer) &manipCallbackStruct[CENTERBALL_MANIP] );
    menu_pane->addAction( "TransformBox", &GlWindow::setManipCB,
			 (XtPointer) &manipCallbackStruct[XFORMBOX_MANIP] );
    menu_pane->addAction( "TabBox", &GlWindow::setManipCB,
			 (XtPointer) &manipCallbackStruct[TABBOX_MANIP] );
    menu_pane->addAction( "None! Zip! Nil!", &GlWindow::setManipCB,
			 (XtPointer) &manipCallbackStruct[NONE_MANIP] );

    for( i = 0; i < MAXNUM_PU; i++ ) {
	popupCallbackStruct[i].self = this;
	popupCallbackStruct[i].type = i;
    }
    
    // a menu for the popups
    menu_pane = addMenuPane( "Popups" );

    menu_pane->addAction( "Frame Buffer Control", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[FB_CONTROL_PU] );
    menu_pane->addAction( "Depth/Alpha/Blend/Dithering Ops",
			 &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[FRAG_OPS1_PU] );
    menu_pane->addAction( "Scissor/Stencil/Logic Ops", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[FRAG_OPS2_PU] );
    menu_pane->addAction( "Texture Ops", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[TEXTURE_OPS_PU] );
    menu_pane->addAction( "Texture Generation", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[TEX_GEN_OPS_PU] );
    menu_pane->addAction( "Fog/AntiAliasing Ops", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[FA_OPS_PU] );
    menu_pane->addAction( "Rasterization Ops", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[RASTER_OPS_PU] );
    menu_pane->addAction( "Lighting and Shading", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[LIGHT_SHADE_PU] );
    menu_pane->addAction( "Material Properties", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[MATERIAL_PU] );
    menu_pane->addAction( "Hints", &GlWindow::popupCB,
			 (XtPointer) &popupCallbackStruct[HINTS_PU] );
    menu_pane->addAction( "Model Clip Planes", &GlWindow::popupCB, (XtPointer)
			 &popupCallbackStruct[MODEL_CLIP_PLANES_PU] );
    menu_pane->addAction( "Transformations", &GlWindow::popupCB, (XtPointer)
			 &popupCallbackStruct[TRANSFORMS_PU] );

    for( i = 0; i < MAXNUM_CAMERA; i++ ) {
	cameraCallbackStruct[i].self = this;
	cameraCallbackStruct[i].type = i;
    }

    // a menu for the view matrices
    menu_pane = addMenuPane( "View" );

    menu_pane->addAction( "Orthographic", &GlWindow::cameraCB, (XtPointer)
			 &cameraCallbackStruct[ORTHOGRAPHIC_CAMERA] );
    menu_pane->addAction( "Perspective", &GlWindow::cameraCB, (XtPointer)
			 &cameraCallbackStruct[PERSPECTIVE_CAMERA] );


    // create the visual menu
    createVisualMenu();
}

void
GlWindow::createVisualMenu()
{
    VkSubMenu *menu_pane = addMenuPane( "Visuals" );
    
    Display *dpy;
    XVisualInfo match, *vi;
    int	found;
    int	i;
    int	value;
    int	level;
    int	rgba, db, bufferSize, rSize, gSize, bSize, aSize;
    int sSize, depthSize, arSize, agSize, abSize, aaSize;
    int auxBuffers;
    int stereo;

    if( visualTypeCallbackStruct ) {
	delete [] visualTypeCallbackStruct;
    }
    if( vislist ) {
	XFree( vislist );
    }

    dpy = XOpenDisplay( NULL );
    
    match.screen = DefaultScreen( dpy );
    vi = XGetVisualInfo( dpy, VisualScreenMask, &match, &found );
    vislist = vi;

    visualTypeCallbackStruct = new VisualTypeCallbackStruct[found];

    for( i = 0; i < found; i++, vi++ ) {
	/* ignore visuals that don't support opengl */
	glXGetConfig( dpy, vi, GLX_USE_GL, &value );
	if( value == FALSE ) {
	    continue;
	}

	/* ignore visuals that are not in the normal planes */
	glXGetConfig( dpy, vi, GLX_LEVEL, &level );
	if( level != 0 ) {
	    continue;
	}

	/* get info for the visuals */
	glXGetConfig( dpy, vi, GLX_BUFFER_SIZE, &bufferSize );
	glXGetConfig( dpy, vi, GLX_RGBA, &rgba );
	glXGetConfig( dpy, vi, GLX_DOUBLEBUFFER, &db );
	glXGetConfig( dpy, vi, GLX_STEREO, &stereo );
	glXGetConfig( dpy, vi, GLX_RED_SIZE, &rSize );
	glXGetConfig( dpy, vi, GLX_GREEN_SIZE, &gSize );
	glXGetConfig( dpy, vi, GLX_BLUE_SIZE, &bSize );
	glXGetConfig( dpy, vi, GLX_ALPHA_SIZE, &aSize );
	glXGetConfig( dpy, vi, GLX_DEPTH_SIZE, &depthSize );
	glXGetConfig( dpy, vi, GLX_STENCIL_SIZE, &sSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_RED_SIZE, &arSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_GREEN_SIZE, &agSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_BLUE_SIZE, &abSize );
	glXGetConfig( dpy, vi, GLX_ACCUM_ALPHA_SIZE, &aaSize );
	glXGetConfig( dpy, vi, GLX_AUX_BUFFERS, &auxBuffers );

	char dbS[20];
	char rgbaS[50];
	char depthS[50];
	char accumS[50];
	char stencilS[50];
	char stereoS[50];
	char auxBuffersS[50];
	char label[250];

	if( db ) {
	    sprintf( dbS, "Double" );
	} else {
	    sprintf( dbS, "Single" );
	}
	if( depthSize == 0 ) {
	    sprintf( depthS, "No Z" );
	} else {
	    sprintf( depthS, "%d-bit Z", depthSize );
	}
	if( (arSize == 0) && (agSize == 0) && (abSize == 0) && (aaSize == 0)) {
	    sprintf( accumS, "No" );
	} else {
	    sprintf( accumS, "%d-%d-%d-%d", arSize, agSize, abSize, aaSize );
	}
	if( rgba ) {
	    sprintf( rgbaS, "RGBA %d-%d-%d-%d",
		    rSize, gSize, bSize, aSize );
	} else {
	    sprintf( rgbaS, "CI %d-bit", bufferSize );
	}
	if( sSize ) {
	    sprintf( stencilS, "%d-bit", sSize );
	} else {
	    sprintf( stencilS, "No" );
	}
	if( stereo ) {
	    sprintf( stereoS, "Stereo" );
	} else {
	    sprintf( stereoS, "" );
	}
	if( auxBuffers ) {
	    sprintf( auxBuffersS, ", %d Aux", auxBuffers );
	} else {
	    sprintf( auxBuffersS, "" );
	}

	sprintf( label,
		"%s, %s %s Buffered, %s, %s Stencil, %s Accum %s",
		rgbaS, stereoS, dbS, depthS, stencilS, accumS, auxBuffersS );

	visualTypeCallbackStruct[i].self = this;
	visualTypeCallbackStruct[i].type = i;
	menu_pane->addAction( label, &GlWindow::visualCB, (XtPointer)
			     &visualTypeCallbackStruct[i] );
    }

    XCloseDisplay( dpy );
}

void
GlWindow::openCB( Widget, XtPointer client, XtPointer )
{
    GlWindow *self = (GlWindow *) client;

    self->getFileName();
}

void
GlWindow::quitCB( Widget, XtPointer, XtPointer )
{
    exit( 0 );
}

void
GlWindow::grabCameraCB( void *user, SoAction * )
{
    GlWindow *self = (GlWindow *) user;

    SbMatrix	modelview;
    SbMatrix	proj;

    // get the camera
    self->camera->getViewVolume().getMatrices( modelview, proj );

    if( self->transforms ) {
	self->transforms->set_model_view_text( modelview );
	self->transforms->set_proj_text( proj );
    }
}

void
GlWindow::setManipCB( Widget, XtPointer client, XtPointer )
{
    ManipCallbackStruct *cbs = (ManipCallbackStruct *) client;
    GlWindow *self = cbs->self;

    // set the current mode
    self->currentManipType = cbs->type;

    // detach the old manipulator if needed
    // (NULL arg creates it's own xform)
    if( self->manip ) {
	if( self->xfPath ) {
	    self->manip->replaceManip( self->xfPath, NULL );
	}
	self->manip->unref();
    }
    // allocate another one with the same path
    self->manip = self->allocateManipOfType( cbs->type );
    if( self->manip ) {
	self->manip->ref();
	if( self->xfPath ) {
	    self->manip->replaceNode( self->xfPath );
	}
    }
}

void
GlWindow::popupCB( Widget, XtPointer client, XtPointer )
{
    PopupCallbackStruct *cbs = (PopupCallbackStruct *) client;
    GlWindow *self = cbs->self;

    switch( cbs->type ) {
      case FB_CONTROL_PU:
	self->fbControl->show();
	break;

      case FRAG_OPS1_PU:
	self->fragmentOps1->show();
	break;

      case FRAG_OPS2_PU:
	self->fragmentOps2->show();
	break;

      case TEXTURE_OPS_PU:
	self->textureOps->show();
	break;

      case TEX_GEN_OPS_PU:
	self->texGenOps->show();
	break;

      case FA_OPS_PU:
	self->faOps->show();
	break;

      case RASTER_OPS_PU:
	self->rasterOps->show();
	break;

      case LIGHT_SHADE_PU:
	self->lightAndShade->show();
	break;

      case MATERIAL_PU:
	self->materialProps->show();
	break;

      case HINTS_PU:
	self->hints->show();
	break;

      case MODEL_CLIP_PLANES_PU:
	self->modelClipPlanes->show();
	break;

      case TRANSFORMS_PU:
	self->transforms->show();
    }
}

SoTransformManip *
GlWindow::allocateManipOfType( int mType )
{
    SoTransformManip	*manip;

    switch( mType ) {
      case TRACKBALL_MANIP:
	manip = new SoTrackballManip;
	break;

      case HANDLEBOX_MANIP:
	manip = new SoHandleBoxManip;
	break;

      case JACK_MANIP:
	manip = new SoJackManip;
	break;

      case CENTERBALL_MANIP:
	manip = new SoCenterballManip;
	break;

      case XFORMBOX_MANIP:
	manip = new SoTransformBoxManip;
	break;

      case TABBOX_MANIP:
	manip = new SoTabBoxManip;
	break;

      case NONE_MANIP:
	manip = NULL;
	break;
    }

    return manip;
}

void
GlWindow::getFileName()
{
    if( fileDialog == NULL ) {
	Arg	av[5];
	int	ac = 0;

	// unmanage when ok/cancel are pressed
	XtSetArg( av[ac], XmNautoUnmanage, TRUE); ac++;
	XmString xmstr = XmStringCreateLocalized( "*.iv" );
	XtSetArg( av[ac], XmNpattern, xmstr ); ac++;
	fileDialog = XmCreateFileSelectionDialog(
	    mainWindowWidget(), "File Dialog", av, ac );
	
	XtAddCallback(fileDialog, XmNokCallback,
		      (XtCallbackProc)GlWindow::fileDialogCB,
		      (XtPointer)this);
    }
    
    // manage the dialog
    XtManageChild(fileDialog);
}

void
GlWindow::fileDialogCB( Widget, XtPointer client, XtPointer call )
{
    GlWindow *self = (GlWindow *) client;
    XmFileSelectionBoxCallbackStruct *cb =
	(XmFileSelectionBoxCallbackStruct *) call;

    char *fname;
    XmStringGetLtoR(cb->value,
	(XmStringCharSet) XmSTRING_DEFAULT_CHARSET, &fname);

    // do it!
    self->readFile( fname );

    XtFree( fname );
}

void
GlWindow::cameraCB( Widget, XtPointer client, XtPointer )
{
    CameraCallbackStruct *cbs = (CameraCallbackStruct *) client;
    GlWindow *self = cbs->self;

    switch( cbs->type ) {
      case PERSPECTIVE_CAMERA:
	self->setCamera( self->perspectiveCamera );
	break;

      case ORTHOGRAPHIC_CAMERA:
	self->setCamera( self->orthographicCamera );
	break;
    }
}

void
GlWindow::visualCB( Widget, XtPointer client, XtPointer )
{
    VisualTypeCallbackStruct *cbs = (VisualTypeCallbackStruct *) client;
    GlWindow *self = cbs->self;

    Display *dpy;
    XVisualInfo *vi;
    int	rgba, db, bufferSize, rSize, gSize, bSize, aSize;
    int sSize, depthSize, arSize, agSize, abSize, aaSize;
    int stereo;

    Widget w = self->getWidget();
    if( w == NULL ) return;
    dpy = XtDisplay( w );
    
    vi = &(self->vislist[cbs->type]);

    glXGetConfig( dpy, vi, GLX_RGBA, &rgba );
    glXGetConfig( dpy, vi, GLX_DOUBLEBUFFER, &db );
    glXGetConfig( dpy, vi, GLX_BUFFER_SIZE, &bufferSize );
    glXGetConfig( dpy, vi, GLX_RED_SIZE, &rSize );
    glXGetConfig( dpy, vi, GLX_GREEN_SIZE, &gSize );
    glXGetConfig( dpy, vi, GLX_BLUE_SIZE, &bSize );
    glXGetConfig( dpy, vi, GLX_ALPHA_SIZE, &aSize );
    glXGetConfig( dpy, vi, GLX_STENCIL_SIZE, &sSize );
    glXGetConfig( dpy, vi, GLX_DEPTH_SIZE, &depthSize );
    glXGetConfig( dpy, vi, GLX_ACCUM_RED_SIZE, &arSize );
    glXGetConfig( dpy, vi, GLX_ACCUM_GREEN_SIZE, &agSize );
    glXGetConfig( dpy, vi, GLX_ACCUM_BLUE_SIZE, &abSize );
    glXGetConfig( dpy, vi, GLX_ACCUM_ALPHA_SIZE, &aaSize );
    glXGetConfig( dpy, vi, GLX_STEREO, &stereo );

    self->setVisualType(rgba, db, bufferSize,
			rSize, gSize, bSize, aSize,
			depthSize, sSize,
			arSize, agSize, abSize, aaSize,
			stereo);

}

////////////////////////////////////////////////////////////////

/*
 * build our own set of button widgets
 */
void
GlWindow::createViewerButtons( Widget parent )
{
    int	i;
    
    // truncate current list
    viewerButtonWidgets->truncate( 0 );

    // build current list
    for( i = 0; i < PUSH_NUM; i++ ) {
	buttonList[i] = new SoXtBitmapButton( parent, (i==0 || i==1) );
	Widget w = buttonList[i]->getWidget();
	XtVaSetValues( w, XmNuserData, this, NULL );
	XtAddCallback( w, XmNactivateCallback,
		      (XtCallbackProc) GlWindow::pushButtonCB,
		      (XtPointer) i );

	viewerButtonWidgets->append( w );
    }

    // set the images
    buttonList[PICK_PUSH]->setIcon( so_xt_pick_bits,
				   so_xt_icon_width,
				   so_xt_icon_height );
    buttonList[VIEW_PUSH]->setIcon( so_xt_view_bits,
				   so_xt_icon_width,
				   so_xt_icon_height );
    buttonList[HOME_PUSH]->setIcon( so_xt_home_bits,
				   so_xt_icon_width,
				   so_xt_icon_height );
    buttonList[SET_HOME_PUSH]->setIcon( so_xt_set_home_bits,
				   so_xt_icon_width,
				   so_xt_icon_height );
    buttonList[VIEW_ALL_PUSH]->setIcon( so_xt_see_all_bits,
				   so_xt_icon_width,
				   so_xt_icon_height );
    buttonList[SEEK_PUSH]->setIcon( so_xt_seek_bits,
				   so_xt_icon_width,
				   so_xt_icon_height );
    buttonList[PIXMAP_PUSH]->setIcon( pixmap_bits_bits,
				     pixmap_bits_width,
				     pixmap_bits_height );
}

void
GlWindow::pushButtonCB( Widget w, int id, void * )
{
    GlWindow *v;
    XtVaGetValues( w, XmNuserData, &v, NULL );

    switch( id ) {
      case PICK_PUSH:
	v->setViewing( FALSE );
	break;

      case VIEW_PUSH:
	v->setViewing( TRUE );
	break;

      case HOME_PUSH:
	v->resetToHomePosition();
	break;

      case SET_HOME_PUSH:
	v->saveHomePosition();
	break;

      case VIEW_ALL_PUSH:
	v->viewAll();
	break;

      case SEEK_PUSH:
	v->setSeekMode( ! v->isSeekMode() );
	break;

      case PIXMAP_PUSH:
	v->renderToPixmap();
	break;
    }
}
    
////////////////////////////////////////////////////////////////

/*
 * delete the scene graph
 */
void
GlWindow::deleteScene()
{
    // don't worry about freeing it..  Too much hassle..
}

/*
 * load in a new file
 */
void
GlWindow::readFile( char *name )
{
    SoInput	in;
    SoNode	*newScene;

    if( !in.openFile( name ) ) {
	return;
    }

    if( ! SoDB::read( &in, newScene ) || newScene == NULL ) {
	return;
    }

    newScene->ref();	// so that we don't lose it

    // now time to replace it.
    deleteScene();
    setSceneGraph( newScene );

    viewAll();
}

/*
 * Well, we don't want to carry all the default nodes that
 * SoXtViewer gives, so we ignore the whole tree and create
 * something local.
 */
void
GlWindow::setSceneGraph( SoNode *node )
{
    if( not_realized ) {
	localSceneGraph = node;
	return;
    }

    // let the superclass do its thing.
    // fake it...  give it our root, but it's not going to
    // draw it anyway, so who cares...
    SoXtViewer::setSceneGraph( toplevelNode );

    // set our local graph now
    toplevelNode->removeAllChildren();
    toplevelNode->addChild( getCamera() );
    toplevelNode->addChild( cameraCbNode );
    toplevelNode->addChild( preExtenderNode );
    if( node ) {
	toplevelNode->addChild( node );
	localSceneGraph = node;

	// traverse recursively to alter the graph appropriately
	alterGraph( node, TRUE );
    }
    toplevelNode->addChild( postExtenderNode );

    // turn off the headlight
    setHeadlight( FALSE );

    // I think we are done now.

    if( debuglevel > 1 ) {
	SoWriteAction	wa;
	wa.getOutput()->openFile( "/tmp/node.iv" );
	wa.getOutput()->setBinary( FALSE );
	wa.apply( node );
	wa.getOutput()->closeFile();
    }
    if( debuglevel > 2 ) {
	SoWriteAction	wa;
	wa.getOutput()->openFile( "/tmp/toplevelNode.iv" );
	wa.getOutput()->setBinary( FALSE );
	wa.apply( toplevelNode );
	wa.getOutput()->closeFile();
    }
}

void
GlWindow::setCamera( SoCamera *newCamera )
{
    if( newCamera == NULL ) {
	// ack!  somebody wants us dead!! Recover!!!
	newCamera = perspectiveCamera;
    }

    if( camera == newCamera )
	return;

    if( debuglevel > 2 ) {
	SoWriteAction	wa;
	wa.getOutput()->openFile( "/tmp/beforeCamera.iv" );
	wa.getOutput()->setBinary( FALSE );
	wa.apply( toplevelNode );
	wa.getOutput()->closeFile();
    }

    if( newCamera && (camera == NULL ||
		      (newCamera->getTypeId() != camera->getTypeId()) ) ) {
	if( newCamera->isOfType( SoOrthographicCamera::getClassTypeId() ) ) {
	    setRightWheelString( "Zoom" );
	} else {
	    setRightWheelString( "Dolly" );
	}
    }

    // detach feedback which depends on camera
    if( feedbackFlag ) {
	setFeedbackVisibility( FALSE );
	feedbackFlag = TRUE;
    }

    // call parent class
    SoXtFullViewer::setCamera( newCamera );

    // and replace our local camera
    toplevelNode->removeAllChildren();
    toplevelNode->addChild( newCamera );
    toplevelNode->addChild( cameraCbNode );
    toplevelNode->addChild( preExtenderNode );
    if( localSceneGraph ) {
	toplevelNode->addChild( localSceneGraph );
    }
    toplevelNode->addChild( postExtenderNode );

    // attach feedback back on
    if( feedbackFlag ) {
	feedbackFlag = FALSE;
	setFeedbackVisibility( TRUE );
    }

    viewAll();
    
    if( debuglevel > 2 ) {
	{
	    SoWriteAction	wa;
	    wa.getOutput()->openFile( "/tmp/afterCamera.iv" );
	    wa.getOutput()->setBinary( FALSE );
	    wa.apply( toplevelNode );
	    wa.getOutput()->closeFile();
	}
	
	SoWriteAction	wa;
	wa.getOutput()->openFile( "/tmp/afterCameraJustScene.iv" );
	wa.getOutput()->setBinary( FALSE );
	wa.apply( localSceneGraph );
	wa.getOutput()->closeFile();
    }
}

void
GlWindow::actualRedraw()
{
    // start up a timer
    SbTime	start, stop;
    start.setToTimeOfDay();
    
    // before rendering, setup the material properties
    materialProps->reset();

    // render
    getSceneManager()->render( isClearBeforeRender() );

    // get elapsed time and display it
    stop.setToTimeOfDay();
    float secs = stop.getValue() - start.getValue();
    float fps = 1 / secs;

    if( showFPSmode ) {
	displayFPS( fps );
    }
}

int
GlWindow::renderToPixmap()
{
    Widget	w = getWidget();
    Display	*dpy = XtDisplay(w);
    const SbVec2s	&vp = getViewportRegion().getWindowSize();
    Pixmap	xpmap;
    GLXPixmap	glxpmap;
    GLXContext	glxc;
    
    // create a pixmap
    glxc = glXCreateContext(dpy, vis, NULL, FALSE);
    if( glxc == NULL ) {
	error("Oat: cannot create pixmap context.");
	return FALSE;
    }
    xpmap = XCreatePixmap(dpy, DefaultRootWindow(dpy),
			  (unsigned int)vp[0], (unsigned int)vp[1], vis->depth);

    glxpmap = glXCreateGLXPixmap( dpy, vis, xpmap );

    if( !glXMakeCurrent(dpy, glxpmap, glxc) ) {
	glXDestroyGLXPixmap( dpy, glxpmap );
	glXDestroyContext(dpy, glxc);
	return FALSE;
    }

    // now clear it, so we start up nice.
    glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    
    // before rendering, setup all the properties
    if( fbControl ) fbControl->reset();
    if( fragmentOps1 ) fragmentOps1->reset();
    if( fragmentOps2 ) fragmentOps2->reset();
    if( textureOps ) textureOps->reset();
    if( texGenOps ) texGenOps->reset();
    if( faOps ) faOps->reset();
    if( rasterOps ) rasterOps->reset();
    if( lightAndShade ) lightAndShade->reset();
    if( materialProps ) materialProps->reset();
    if( hints ) hints->reset();
    if( modelClipPlanes ) modelClipPlanes->reset();
    if( transforms ) transforms->reset();

    // render as usual
    getSceneManager()->render( isClearBeforeRender() );

    // now try to read the pixels out...
    int	allocSize;
    unsigned char *pixelBuffer;
    
    allocSize = vp[0] * vp[1] * 3;	// RGB
    pixelBuffer = new unsigned char[allocSize];
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glReadPixels(0, 0, vp[0], vp[1], GL_RGB, GL_UNSIGNED_BYTE,
		 (GLvoid *)pixelBuffer);

    // destroy pixmaps, etc...
    glXDestroyGLXPixmap( dpy, glxpmap );
    glXDestroyContext(dpy, glxc);
    
    // open up the file
    char *pixmapFile = tmpnam( NULL );
    FILE *fp = fopen( pixmapFile, "w" );
    if( fp == NULL ) {
	error("Oat: cannot open temp file.");
	return FALSE;
    }

    // write out the file
    IMAGE *image;
    if( (image = fiopen(fileno(fp), "w", RLE(2), 3,
			(unsigned int)vp[0], (unsigned int)vp[1],
			3) ) == NULL ) {
	error("Oat: cannot open image file.");
	return FALSE;
    }

    short *rowBuf = new short[vp[0]];
    unsigned char *buf = pixelBuffer;
    for( int row = 0; row < vp[1]; row++, buf += vp[0]*3 ) {
	unsigned char *tbuf = buf;

	for( int comp = 0; comp < 3; comp++ ) {
	    short *trow = rowBuf;
	    tbuf = buf + comp;
	    for( int j = 0; j < vp[0]; j++, tbuf += 3 ) {
		*trow++ = (short) *tbuf;
	    }
	    putrow( image, rowBuf, row, comp );
	}
    }
    
    iclose(image);
    delete rowBuf;
    fclose( fp );

    // now display the file
    char displayCmd[200];
    sprintf( displayCmd, "(ipaste -f %s; rm -f %s) &",
	    pixmapFile, pixmapFile );
    system( displayCmd );

    // and get rid of it
    sleep(1);

    return 0;
}

////////////////////////////////////////////////////////////////

void
GlWindow::displayFPS( float fps )
{
    printf("\t%3.1lf\r", fps);
    fflush(stdout);
}

void
GlWindow::showFPS( Boolean state )
{
    showFPSmode = state;
}

////////////////////////////////////////////////////////////////

void
GlWindow::selectionCallback( void *userData, SoPath *path )
{
    GlWindow *self = (GlWindow *) userData;

    if( self->debuglevel > 1 ) {
	SoWriteAction	wa;
	wa.getOutput()->openFile( "/dev/tty" );
	wa.getOutput()->setBinary( FALSE );
	wa.apply( self->toplevelNode );
	wa.getOutput()->closeFile();
    }
    
    self->attachManip( path );
}

void
GlWindow::deselectionCallback( void *userData, SoPath *path )
{
    GlWindow *self = (GlWindow *) userData;

    self->detachManip( path );

    self->alterGraph( self->toplevelNode );

    if( self->debuglevel > 1 ) {
	SoWriteAction	wa;
	wa.getOutput()->openFile( "/dev/tty" );
	wa.getOutput()->setBinary( FALSE );
	wa.apply( self->toplevelNode );
	wa.getOutput()->closeFile();
    }
}

SoPath *
GlWindow::pickFilterCallback( void *userData, const SoPickedPoint *pick )
{
    GlWindow *sv = (GlWindow *) userData;
    SoPath *filteredPath = NULL;

    // point to the path attach to our manip, if needed
    SoFullPath *fullP = (SoFullPath *) pick->getPath();
    SoNode *n;
    for( int i = 0; i < fullP->getLength(); i++ ) {
	n = fullP->getNode( i );
	if( n->isOfType( SoTransformManip::getClassTypeId() ) ) {
	    return sv->xfPath;
	}
    }

    // otherwise, return normal path
    filteredPath = pick->getPath();
    return filteredPath;
}

////////////////////////////////////////////////////////////////////////
//
// Description:
//   Find the appropriate transform node in the scene graph for attaching a 
//   transform editor or manipulator.
//
//   How we treat the 'center' field of the transform node:
//   If we need to create a new transform node:
//       set the 'center' to be the geometric center of all objects 
//       affected by that transform. 
//   If we find a transform node that already exists:
//       'center' will not be changed.
//
//   Three possible cases:
//        [1] The path-tail is a node kit. Just ask the node kit for a path
//            to the part called "transform"
//        [2] The path-tail is NOT a group.  We search the siblings of the path
//            tail (including the tail itself) from right to left for a node
//	      that is affected by transforms (shapes, groups, lights,cameras).
//            We stop the search if we come to a transform node to the left of 
//	      the pathTail.  If we find a node that IS affected by transform, 
//	      we will insert a transform node just before the path-tail. This is
//            because the editor should not affect nodes that appear
//            before attachPath in the scene graph.
//        [3] The path-tail IS a group.  We search the children from left to
//            right for transform nodes.
//            We stop the search if we come to a transform node.
//            If we find a node that is affected by transform, we will insert a
//	      transform just before this node. This is because the editor for a
//	      group should affect ALL nodes within that group.
//
// NOTE: For the purposes of this routine, we consider SoSwitch as different
//       from other types of group. This is because we don't want to put
//       the new node underneath the switch, but next to it.
//
// Use: private
//
SoPath *
GlWindow::findTransformForAttach(
			const SoPath *target )	// path to start search from
//
////////////////////////////////////////////////////////////////////////
{
    int 		pathLength;
    SoPath 		*selectionPath;
    SoTransform		*editXform;

    
    if ( ( selectionPath = (SoPath *) target ) == NULL ) {
	//
	//  If no selection path is specified, then use the LAST path in the
	//  current selection list.
	//
	selectionPath = (*selection)[selection->getNumSelected() - 1];
    }
    pathLength = selectionPath->getLength();

    if ( pathLength <= 0 ) {
	error("No objects currently selected...");
	return NULL;
    }

#ifdef DEBUG
    if ( pathLength < 2 ) {
	error("Picked object has no parent!!..");
	return NULL;
    }
#endif

    // find 'group' and try to find 'editXform'
    SoGroup     *group;
    SoNode      *node;
    int         index, i;
    SbBool      isTailGroup,  isTailKit;
    SbBool      existedBefore = FALSE;
    SoPath      *pathToXform = NULL;

    editXform = NULL;

    isTailGroup =
	    (   selectionPath->getTail()->isOfType(SoGroup::getClassTypeId() )
	    && !selectionPath->getTail()->isOfType(SoSwitch::getClassTypeId()));

    isTailKit = selectionPath->getTail()->isOfType(SoBaseKit::getClassTypeId());

    //    CASE 1: The path-tail is a node kit.
    if ( isTailKit ) {

	// Nodekits have their own built in policy for creating new transform
	// nodes. Allow them to contruct and return a path to it.
	SoBaseKit *kit = (SoBaseKit *) 
			 ((SoNodeKitPath *)selectionPath)->getTail();

	// Before creating path, see if the transform part exists yet:
	if (SO_CHECK_PART(kit, "transform", SoTransform) != NULL)
	    existedBefore = TRUE;

	if ((editXform = SO_GET_PART(kit, "transform", SoTransform)) != NULL) {
	    pathToXform = kit->createPathToPart( "transform", TRUE, selectionPath );
	    pathToXform->ref();
	}
	else {
	    // This nodekit has no transform part. 
	    // Treat the object as if it were not a nodekit.
	    isTailKit = FALSE;
	}
    }
    
    if ( !isTailGroup && !isTailKit ) {
	//
        //    CASE 2: The path-tail is not a group.
        //    'group'      becomes the second to last node in the path.
        //    We search the path tail and its siblings from right to left for a
        //    transform node.
        //    We stop the search if we come to a 'movable' node
        //    to the left of the pathTail.  If we find a movable node, we
        //    will insert a transform just before the path-tail. This is
        //    because the manipulator should not affect objects that appear
        //    before selectionPath in the scene graph.
	//
        group      = (SoGroup *) selectionPath->getNode(pathLength - 2);
        index      = group->findChild( selectionPath->getTail() );

        for (i = index; (i >= 0) && (editXform == NULL); i--){
            node = group->getChild(i);
            if (node->isOfType(SoTransform::getClassTypeId()))  // found an SoMaterial
                editXform = (SoTransform *) node;
            else if ( i != index ) { 
		if ( isAffectedByTransform( node ) )
		    break;
            }
        }

        if ( editXform == NULL ) {
	    existedBefore = FALSE;
            editXform = new SoTransform;
            group->insertChild( editXform, index );
        }
	else
	    existedBefore = TRUE;
    }
    else if ( !isTailKit ) {
        //    CASE 3: The path-tail is a group.
        //    'group'      becomes the path tail
        //      We search the children from left to right for transform nodes.
        //      We stop the search if we come to a movable node.
        //      If we find a movable node, we will insert a transform just
        //      before this node. This is because the editor
        //      for a group should affect ALL objects within that group.
	//
        group = (SoGroup *) selectionPath->getTail();
        for (i = 0; (i < group->getNumChildren()) && (editXform == NULL); i++ ) {
            node = group->getChild(i);
            if (node->isOfType(SoTransform::getClassTypeId()))
                editXform = (SoTransform *) node;
            else if ( isAffectedByTransform( node ) )
                break;
        }

        if ( editXform == NULL ) {
	    existedBefore = FALSE;
            editXform = new SoTransform;
            group->insertChild( editXform, i );
        }
	else
	    existedBefore = TRUE;
    }

    // If we don't have a path yet (i.e., we weren't handed a nodekit path)
    // create the 'pathToXform'
    // by copying editPath and making the last node in the path be editXform
    if ( pathToXform == NULL ) {
	if ( !isTailGroup )
	    // CASE 2: path-tail was NOT 'group' -- copy all but last entry
	    pathToXform = selectionPath->copy(0, pathLength - 1);
	else
	    // CASE 3: path-tail was 'group' -- copy all of editPath
	    pathToXform = selectionPath->copy(0, pathLength);
	pathToXform->ref();

	// add the transform to the end
	int xfIndex    = group->findChild(editXform);
	pathToXform->append( xfIndex );
    }


    // Now. If we created the transform node right here, right now, then
    // we will set the 'center' field based on the geometric center. We 
    // don't do this if we didn't create the transform, because "maybe it
    // was that way for a reason."
    if ( existedBefore == FALSE ) {
	// First, find 'applyPath' by popping nodes off the path until you 
	// reach a separator. This path will contain all nodes affected by
	// the transform at the end of 'pathToXform'
	SoFullPath *applyPath = (SoFullPath *) pathToXform->copy();
	applyPath->ref();
	for (int i = (applyPath->getLength() - 1); i >0; i-- ) {
	    if (applyPath->getNode(i)->isOfType( SoSeparator::getClassTypeId()))
		break;
	    applyPath->pop();
	}

	// Next, apply a bounding box action to applyPath, and reset the
	// bounding box just before the tail of 'pathToXform' (which is just
	// the editXform). This will assure that the only things included in 
	// the resulting bbox will be those affected by the editXform.
	SoGetBoundingBoxAction bboxAction(getViewportRegion());
	bboxAction.setResetPath(pathToXform,TRUE,SoGetBoundingBoxAction::BBOX );
	bboxAction.apply(applyPath);

	applyPath->unref();

	// Get the center of the bbox in world space...
	SbVec3f worldBoxCenter = bboxAction.getBoundingBox().getCenter();

	// Convert it into local space of the transform...
	SbVec3f localBoxCenter;
	SoGetMatrixAction ma(getViewportRegion());
	ma.apply( pathToXform );
	ma.getInverse().multVecMatrix( worldBoxCenter, localBoxCenter );

	// Finally, set the center value...
	editXform->center.setValue( localBoxCenter );
    }

    pathToXform->unrefNoDelete();
    return( pathToXform );
}

////////////////////////////////////////////////////////////////////////
//
// Description:
//    Determines whether a given node is affected by a transform.
//
// Use: static, public
//
SbBool
GlWindow::isAffectedByTransform(
	SoNode *theNode )		// node to be affected?
//
////////////////////////////////////////////////////////////////////////
{
    if ( theNode->isOfType( SoGroup::getClassTypeId() )
	    || theNode->isOfType( SoShape::getClassTypeId() )
	    || theNode->isOfType( SoCamera::getClassTypeId() )
	    || theNode->isOfType( SoLight::getClassTypeId() ) )  {
	return TRUE;
    }
    return FALSE;
}

////////////////////////////////////////////////////////////////////////
//
// Description:
//   Find the appropriate material node in the scene graph to attach a material
//   editor to.
//
//   Two possible cases:
//        [1] The path-tail is NOT a group.  We search the siblings of the path
//            tail (including the tail itself) from right to left for a node
//	      that is affected by materials (shapes or groups).
//            We stop the search if we come to a material node to the left of the
//	      pathTail.  If we find a node that IS affected by material, we will
//	      insert a material node just before the path-tail. This is
//            because the editor should not affect nodes that appear
//            before attachPath in the scene graph.
//        [2] The path-tail IS a group.  We search the children from left to
//            right for material nodes.
//            We stop the search if we come to a material node.
//            If we find a node that is affected by materials, we will insert a
//	      material just before this node. This is because the editor for a
//	      group should affect ALL nodes within that group.
//
// NOTE: For the purposes of this routine, we consider SoSwitch as different
//       from other types of group. This is because we don't want to put
//       the new node underneath the switch, but next to it.
//
// Use: private
//
SoMaterial *
GlWindow::findMaterialForAttach(
			const SoPath *target )	// path to start search from
//
////////////////////////////////////////////////////////////////////////
{
    int 		pathLength;
    SoPath 		*selectionPath;
    SoMaterial		*editMtl;

    SbBool		madeNewMtl = FALSE; // did we create a new material
					    // node within this method?


    if ( ( selectionPath = (SoPath *) target ) == NULL ) {
	//
	//  If no selection path is specified, then use the LAST path in the
	//  current selection list.
	//
	selectionPath = (*selection)[selection->getNumSelected() - 1];	// last guy
    }
    pathLength = selectionPath->getLength();

    if ( pathLength <= 0 ) {
	error("NO objects currently selected...");
	return NULL;
    }

#ifdef DEBUG
    if ( pathLength < 2 ) {
	error("Picked object has no parent!!..");
	return NULL;
    }
#endif


    // find 'group' and try to find 'editMtl'
    SoGroup     *group;
    SoNode      *node;
    int         index, i;
    SbBool	ignoreNodekit = FALSE;

    editMtl = NULL;

    if ( selectionPath->getTail()->isOfType( SoBaseKit::getClassTypeId() )) {
	// Nodekits have their own built in policy for creating new material
	// nodes. Allow them to contruct and return it.
	// Get the last nodekit in the path:
	SoBaseKit *kit = (SoBaseKit *) 
			 ((SoNodeKitPath *)selectionPath)->getTail();
	// SO_CHECK_PART returns NULL if the part doesn't exist yet...
	editMtl = SO_GET_PART( kit, "material", SoMaterial );
	if ( editMtl == NULL ) {
	    // This nodekit does not have a material part.
	    // Ignore the fact that this is a nodekit.
	    ignoreNodekit = TRUE;
	}
    }

    SbBool isTailGroup 	= 
      selectionPath->getTail()->isOfType( SoGroup::getClassTypeId()) &&
      (!selectionPath->getTail()->isOfType( SoSwitch::getClassTypeId()));
    
    if ((editMtl == NULL) && ( !isTailGroup )) {
	//
        //    CASE 1: The path-tail is not a group.
        //    'group'      becomes the second to last node in the path.
        //    We search the path tail and its siblings from right to left for a
        //    mtl node.
        //    We stop the search if we come to a shape node or a group node
        //    to the left of the pathTail.  If we find a shape or group, we
        //    will insert a mtl just before the path-tail. This is
        //    because the manipulator should not affect objects that appear
        //    before selectionPath in the scene graph.
	//
        group      = (SoGroup *) selectionPath->getNode(pathLength - 2);
        index      = group->findChild( selectionPath->getTail() );

        for (i = index; (i >= 0) && (editMtl == NULL); i--){
            node = group->getChild(i);
            if (node->isOfType(SoMaterial::getClassTypeId())) // found SoMaterial
                editMtl = (SoMaterial *) node;
            else if ( i != index ) { 
                if ( isAffectedByMaterial( node ) )
                    break;
            }
        }

        if ( editMtl == NULL ) {
            editMtl = new SoMaterial;
            group->insertChild( editMtl, index );
	    madeNewMtl = TRUE;
        }
    }
    else if (editMtl == NULL) {
        //    CASE 2: The path-tail is a group.
        //    'group'      becomes the path tail
        //      We search the children from left to right for mtl nodes.
        //      We stop the search if we come to a shape node or a group node.
        //      If we find a shape or group, we will insert a mtl just
        //      before this shape or group. This is because the editor
        //      for a group should affect ALL objects within that group.
	//
        group = (SoGroup *) selectionPath->getTail();
        for (i = 0; (i < group->getNumChildren()) && (editMtl == NULL); i++ ) {
            node = group->getChild(i);
            if (node->isOfType(SoMaterial::getClassTypeId()))
                editMtl = (SoMaterial *) node;
            else if ( isAffectedByMaterial( node ) )
                break;
        }

        if ( editMtl == NULL ) {
            editMtl = new SoMaterial;
            group->insertChild( editMtl, i );
	    madeNewMtl = TRUE;
        }
    }

    // If we just created the material node here, then set the ignore
    // flags for all fields in the node.  This will cause the fields
    // to be inherited from their ancestors. The material editor will
    // undo these flags whenever it changes the value of a field
    if ( madeNewMtl == TRUE ) {
	editMtl->ambientColor.setIgnored( TRUE );
	editMtl->diffuseColor.setIgnored( TRUE );
	editMtl->specularColor.setIgnored( TRUE );
	editMtl->emissiveColor.setIgnored( TRUE );
	editMtl->shininess.setIgnored( TRUE );
	editMtl->transparency.setIgnored( TRUE );
    }

    // If any of the fields is ignored, then fill the value with the value
    // inherited from the rest of the scene graph
    if ( editMtl->ambientColor.isIgnored() 
	|| editMtl->diffuseColor.isIgnored() 
	|| editMtl->specularColor.isIgnored() 
	|| editMtl->emissiveColor.isIgnored() 
	|| editMtl->shininess.isIgnored() 
	|| editMtl->transparency.isIgnored() ){

	// Create a path to the material
	SoPath *mtlPath;
	if ( (! ignoreNodekit) && selectionPath->getTail()->isOfType( SoBaseKit::getClassTypeId() )) {
	    SoBaseKit *kit = (SoBaseKit *) 
			     ((SoNodeKitPath *)selectionPath)->getTail();
	    mtlPath = kit->createPathToPart( "material", TRUE, selectionPath );
	    mtlPath->ref();
	}
	else {
	    if ( !isTailGroup ) {
		// CASE 1: path-tail was NOT 'group' -- copy all but last entry
		mtlPath = selectionPath->copy(0, pathLength - 1);
	    }
	    else {
		// CASE 2: path-tail was 'group' -- copy all of editPath
		mtlPath = selectionPath->copy(0, pathLength);
	    }
	    mtlPath->ref();
	    // add the material to the end of the path
	    int mtlIndex    = group->findChild(editMtl);
	    mtlPath->append( mtlIndex );
	}

	// Pass the material node to an accumulate state callback
	// that will load any 'ignored' values with their inherited values.
	SoCallbackAction cba;
	cba.addPreTailCallback( GlWindow::findMtlPreTailCB, editMtl);
	cba.apply( mtlPath );

	mtlPath->unref();
    }


    return( editMtl );
}

////////////////////////////////////////////////////////////////////////
//
// Description:
//   Callback used by 'findMaterialForAttach' as part of the accumulate state
//   action. Returns 'PRUNE', which tells the action not to draw the
//   shape as part of the accum state action.
//   editor to.
//
// Use: private
//
SoCallbackAction::Response
GlWindow::findMtlPreTailCB( void *data, SoCallbackAction *accum, 
				 const SoNode * )
//
////////////////////////////////////////////////////////////////////////
{
    SoMaterial *mtl = (SoMaterial *) data;

    SbColor ambient, diffuse, specular, emissive;
    float   shininess, transparency;

    accum->getMaterial( ambient, diffuse, specular, emissive, 
			shininess, transparency ); 

    // inherit the accumulated values only in those fields being ignored.
    if ( mtl->ambientColor.isIgnored() )
	 mtl->ambientColor.setValue( ambient );
    if ( mtl->diffuseColor.isIgnored() )
	 mtl->diffuseColor.setValue( diffuse );
    if ( mtl->specularColor.isIgnored() )
	 mtl->specularColor.setValue( specular );
    if ( mtl->emissiveColor.isIgnored() )
	 mtl->emissiveColor.setValue( emissive );
    if ( mtl->shininess.isIgnored() )
	 mtl->shininess.setValue( shininess );
    if ( mtl->transparency.isIgnored() )
	 mtl->transparency.setValue( transparency );

    return SoCallbackAction::ABORT;
}

////////////////////////////////////////////////////////////////////////
//
// Description:
//    Determines whether a given node is affected by material node.
//
// Use: static, public
//
SbBool
GlWindow::isAffectedByMaterial(
	SoNode *theNode )		// node to be affected?
//
////////////////////////////////////////////////////////////////////////
{
    if ( theNode->isOfType( SoGroup::getClassTypeId() )
	    || theNode->isOfType( SoShape::getClassTypeId() ) ) {
	return TRUE;
    }
    return FALSE;
}


void
GlWindow::attachManip( SoPath *path )
{
    // first deal with the transforms and the manipulator
    xfPath = findTransformForAttach( path );
    xfPath->ref();

    manip = allocateManipOfType( currentManipType );
    if( manip == NULL ) {
	return;
    }

    SoFullPath *fp = (SoFullPath *) xfPath;

    // grab the transform that we will be changing
    SoTransform *oldXf = (SoTransform *) fp->getTail();
    oldXf->ref();
    manip->ref();

    manip->replaceNode( xfPath );
}

void
GlWindow::detachManip( SoPath * )
{
    if( manip == NULL ) {
	return;
    }

    manip->replaceManip( xfPath, NULL );

    manip->unref();
    xfPath->unref();

    manip = NULL;
    xfPath = NULL;
}

////////////////////////////////////////////////////////////////

void
GlWindow::alterGraph( SoNode *node, Boolean verbose )
{
    // if it is a group, traverse children
    if( node->isOfType( SoGroup::getClassTypeId() ) ) {
	SoGroup *gnode = (SoGroup *) node;
	
	// if it is a separator, disable caching
	if( node->isOfType( SoSeparator::getClassTypeId() ) ) {
	    SoSeparator *snode = (SoSeparator *) node;
	    snode->renderCaching = SoSeparator::OFF;
	}

	// traverse children recursively
	int	i;
	for( i = 0; i < gnode->getNumChildren(); i++ ) {
	    SoNode *child = gnode->getChild(i);
	    Boolean	remove_this;
	    remove_this = FALSE;

	    // we don't support materials and misc things that are
	    // going to alter material props
	    if( child->isOfType( SoMaterial::getClassTypeId() ) ||
	       child->isOfType( SoBaseColor::getClassTypeId() ) ||
	       child->isOfType( SoShapeHints::getClassTypeId() ) ||
	       child->isOfType( SoPackedColor::getClassTypeId() )
	       ) {
		// remove
		if( verbose ) {
		    char	str[200];
		    sprintf( str, "Material node %s not supported (yet)!\n",
			    child->getTypeId().getName().getString()
			    );
		    error(str);
		}
		remove_this = TRUE;
	    }
	    
	    // all unsupported nodes, too
	    if( child->isOfType( SoShape::getClassTypeId() ) ) {
		if( child->isOfType( SoCone::getClassTypeId() ) ||
		   child->isOfType( SoCylinder::getClassTypeId() ) ||
		   child->isOfType( SoCube::getClassTypeId() ) ||
		   child->isOfType( SoFaceSet::getClassTypeId() ) ||
		   child->isOfType( SoIndexedFaceSet::getClassTypeId() ) ||
		   child->isOfType( SoSphere::getClassTypeId() )
		   ) {
		    alterGraph( child );
		} else {
		    // remove
		    if( verbose ) {
			char	str[200];
			sprintf( str,
				"Node %s unsupported! Removed.\n",
				child->getTypeId().getName().getString()
				);
			error(str);
		    }
		    remove_this = TRUE;
		}
	    }

	    if( remove_this ) {
		gnode->removeChild( child );
		i = -1;
		continue;
	    } else {
		alterGraph( child, verbose );
	    }
	}
    }
}

////////////////////////////////////////////////////////////////

void
GlWindow::show()
{
    VkWindow::show();
    SoXt::show( raWidget );
    SoXtExaminerViewer::show();
    
    vis = getNormalVisual();
}

void
GlWindow::hide()
{
    // no need to hide the viewer...
    
    VkSimpleWindow::hide();
}

////////////////////////////////////////////////////////////////

void
GlWindow::handleWmDeleteMessage()
{
    // ignore
}

void
GlWindow::handleWmQuitMessage()
{
    // ignore
}
