/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _HINTS_H
#define _HINTS_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Thu Feb 17 17:58:30 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:43 1994 by George Kyriazis
 *
 * OpenGL hints
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "IfaceGenerator.h"

class Hints : public IfaceGenerator {
  public:
    Hints( GlWindow * );
    virtual ~Hints();

    // misc hints
    void	set_glHint_fog( GLenum mode );
    void	get_glHint_fog( GLenum *mode );
    void	set_glHint_point_smooth( GLenum mode );
    void	get_glHint_point_smooth( GLenum *mode );
    void	set_glHint_line_smooth( GLenum mode );
    void	get_glHint_line_smooth( GLenum *mode );
    void	set_glHint_polygon_smooth( GLenum mode );
    void	get_glHint_polygon_smooth( GLenum *mode );
    void	set_glHint_perspective_correction( GLenum mode );
    void	get_glHint_perspective_correction( GLenum *mode );

    virtual	void	reset();

  protected:
    static	int	iface[];
    virtual	int	get_this() { return (int) this; }
    void	install_values();

    virtual	void	remember();

    void	print_hint_type( GLenum );

    // our state
    GLenum	_glHint_fog;
    GLenum	_glHint_point_smooth;
    GLenum	_glHint_line_smooth;
    GLenum	_glHint_polygon_smooth;
    GLenum	_glHint_perspective_correction;

    // callbacks
    static	void	cb_set_glHint_fog( CB_ARGS );
    static	void	cb_set_glHint_point_smooth( CB_ARGS );
    static	void	cb_set_glHint_line_smooth( CB_ARGS );
    static	void	cb_set_glHint_polygon_smooth( CB_ARGS );
    static	void	cb_set_glHint_perspective_correction( CB_ARGS );
    
};

#endif /* _HINTS_H */
