/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _IFACEGENERATOR_H
#define _IFACEGENERATOR_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Wed Jan 12 16:30:06 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:15:16 1994 by George Kyriazis
 *
 * This class is able to create interfaces from configuration scripts.
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "Object.h"

#include <Vk/VkCallbackObject.h>
#include "TopLevelWindow.h"

#define CB_ARGS VkCallbackObject *, void *, void *

class GlWindow;

class IfaceGenerator : public Object, public VkCallbackObject {
  public:
    IfaceGenerator( GlWindow * );
    virtual ~IfaceGenerator();

    // hide and show the toplevel window
    inline void hide() { toplevel->hide(); }
    inline void show() { toplevel->show(); }

    // resend the values of our configuration
    virtual	void	reset() = 0;

    // should we redraw at the end of each GL command?
    void	setRedraw( Boolean );

  protected:

    // remember our current values
    virtual	void	remember() = 0;

    // redraw the graphics screen at the end of a GL command
    virtual	void	redraw();
    Boolean	redrawStatus;

    virtual	int	get_this() = 0;
    virtual	void	install_this( int *script );	// subs the this ptr
    virtual	void	parse( int *script );	// parse a string
    virtual	void	install( int *script, int token, int repl );

    GlWindow	*glWindow;
    
    TopLevelWindow	*toplevel;
};

#endif /* _IFACEGENERATOR_H */
