/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _IFACEGENERATORP_H
#define _IFACEGENERATORP_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Wed Jan 12 16:32:20 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:15:54 1994 by George Kyriazis
 *
 * here we keep all the different defines and constants needed
 *   in parsing the interface configuration string.
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

// the following is a magic token specifying that this is to be filled
// with "this" at constructor time.
#define	IF_THIS		0xDEADBEEF

#define	IF_END		0x9abad9e7	// end of interface definition
#define	IF_BEGIN	2		// begin an interface definition
#define	IF_WINDOW	3		// create a toplevel window
	// arguments
	//	a this pointer
	//	a return handle
	//	a pointer to a NULL-terminated string specifying the
	//	name of the window
	//	number of columns
#define	IF_RADIO	4		// a radio button with choices.
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the radio button
	//	an integer specifying how many items there are
	//	the initial state (button #)
	//	a callback function ptr
	//	a list of string-value pairs:
	//		a pair is a pointer to a NULL-terminated string
	//		an int (for return value).
#define	IF_TEXT		5		// a text item
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the text item
	//	the size in characters
	//	the initial value
	//	a pointer to a string specifying acceptable values
	//	a callback function ptr
#define	IF_RGB		6		// an RGB color item
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the color item
	//	initial value
	//	a callback function ptr
#define	IF_RGBA		7		// an RGBA color item
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the color item
	//	initial value
	//	a callback function ptr
#define	IF_FNAME	8		// a filename 	item
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the thing
	//	acceptable pattern
	//	a callback funtcion ptr
#define	IF_PLANE	9		// a 3-D plane
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the thing
	//	the initial value (4 string floats)
	// 	a callback function ptr
#define	IF_MATRIX	10		// a 4x4 matrix
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the thing
	//	the initial value (16 string floats)
	// 	a callback function ptr
#define	IF_SEPARATOR	11		// a horizontal line separator
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the thing
#define	IF_MULTI_TEXT		12		// a multi-line text item
	// arguments:
	//	a this pointer
	//	a return handle
	//	the name of the text item
	//	the size of each row, in characters
	//	the number of rows
	//	the initial value
	//	a pointer to a string specifying acceptable values
	//	a callback function ptr


// this is a magic token that tells us that token numbers greater
// than that can be used for placeholders
#define	IF_VALUE	0xa000000

#endif /* _IFACEGENERATORP_H */
