/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Fri Jan 21 11:47:15 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:56 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "LightAndShade.h"

#include "IfaceGeneratorP.h"

#include "TextItem.h"
#include "RadioBoxItem.h"
#include <stdlib.h>

int LightAndShade::iface[] = {
    IF_BEGIN,
    IF_WINDOW, IF_THIS, NULL,
    (int) "Lighting and Shading", 1,

    IF_RADIO, IF_THIS, NULL,
    (int) "Shading Model: ", 2,
    1, (int) &LightAndShade::cb_set_glShadeModel,
    (int) "GL_FLAT", GL_FLAT,
    (int) "GL_SMOOTH", GL_SMOOTH,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RADIO, IF_THIS, NULL,
    (int) "Lighting: ", 2,
    0, (int) &LightAndShade::cb_set_lighting,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RGBA, IF_THIS, NULL,
    (int) "Light Model Ambient: ",
    IF_VALUE+0, IF_VALUE+1, IF_VALUE+2, IF_VALUE+3,
    (int) &LightAndShade::cb_set_glLightModel_ambient,

    IF_RADIO, IF_THIS, NULL,
    (int) "Local Viewer: ", 2,
    0, (int) &LightAndShade::cb_set_glLightModel_local_viewer,
    (int) "NO (FAST)", 0,
    (int) "YES (SLOW)", 1,

    IF_RADIO, IF_THIS, NULL,
    (int) "Two Sided Lighting: ", 2,
    0, (int) &LightAndShade::cb_set_glLightModel_two_side,
    (int) "FALSE", 0,
    (int) "TRUE", 1,

    IF_RADIO, IF_THIS, NULL,
    (int) "Front Face Defn: ", 2,
    1, (int) &LightAndShade::cb_set_glFrontFace,
    (int) "GL_CW", GL_CW,
    (int) "GL_CCW", GL_CCW,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RADIO, IF_THIS, NULL,
    (int) "Light #: ", 8,
    0, (int) &LightAndShade::cb_set_current_light,
    (int) "0", 0,
    (int) "1", 1,
    (int) "2", 2,
    (int) "3", 3,
    (int) "4", 4,
    (int) "5", 5,
    (int) "6", 6,
    (int) "7", 7,

    IF_RADIO, IF_THIS, IF_VALUE+110,
    (int) "Light status: ", 2,
    0, (int) &LightAndShade::cb_set_light_status,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RGBA, IF_THIS, IF_VALUE+100,
    (int) "Light Ambient Color: ",
    IF_VALUE+10, IF_VALUE+11, IF_VALUE+12, IF_VALUE+13,
    (int) &LightAndShade::cb_set_glLight_ambient,

    IF_RGBA, IF_THIS, IF_VALUE+101,
    (int) "Light Diffuse Color: ",
    IF_VALUE+20, IF_VALUE+21, IF_VALUE+22, IF_VALUE+23,
    (int) &LightAndShade::cb_set_glLight_diffuse,

    IF_RGBA, IF_THIS, IF_VALUE+102,
    (int) "Light Specular Color: ",
    IF_VALUE+30, IF_VALUE+31, IF_VALUE+32, IF_VALUE+33,
    (int) &LightAndShade::cb_set_glLight_specular,

    IF_TEXT, IF_THIS, IF_VALUE+103,
    (int) "Light Position: ",
    40, (int) "0 0 0 0",
    (int) &TextItem::VECTOR,
    (int) &LightAndShade::cb_set_glLight_position,

    IF_TEXT, IF_THIS, IF_VALUE+104,
    (int) "Light Spot Direction: ",
    30, (int) "0 0 0",
    (int) &TextItem::VECTOR,
    (int) &LightAndShade::cb_set_glLight_spot_direction,

    IF_TEXT, IF_THIS, IF_VALUE+105,
    (int) "Light Spot Exponent: ",
    10, (int) "",
    (int) &TextItem::FRACTIONAL,
    (int) &LightAndShade::cb_set_glLight_spot_exp,

    IF_TEXT, IF_THIS, IF_VALUE+106,
    (int) "Light Spot Cutoff: ",
    10, (int) "",
    (int) &TextItem::FRACTIONAL,
    (int) &LightAndShade::cb_set_glLight_spot_cutoff,

    IF_TEXT, IF_THIS, IF_VALUE+107,
    (int) "Light Constant Attenuation: ",
    10, (int) "",
    (int) &TextItem::FRACTIONAL,
    (int) &LightAndShade::cb_set_glLight_const_atten,

    IF_TEXT, IF_THIS, IF_VALUE+108,
    (int) "Light Linear Attenuation: ",
    10, (int) "",
    (int) &TextItem::FRACTIONAL,
    (int) &LightAndShade::cb_set_glLight_linear_atten,

    IF_TEXT, IF_THIS, IF_VALUE+109,
    (int) "Light Quadratic Attenuation: ",
    10, (int) "",
    (int) &TextItem::FRACTIONAL,
    (int) &LightAndShade::cb_set_glLight_quad_atten,

    IF_END
};

LightAndShade::LightAndShade( GlWindow *dwa )
: IfaceGenerator( dwa )
{
    install_this( iface );
    install_values();
    parse( iface );
    remember();

    cb_set_current_light( NULL, this, 0 );
}

LightAndShade::~LightAndShade()
{
}

///////////////////////////////////////////////////////////////////

void
LightAndShade::install_values()
{
    // install values
    GLfloat	r, g, b, a;
    get_glLightModel_ambient( &r, &g, &b, &a );
    install( iface, IF_VALUE+0, (int) ftoa(r) );
    install( iface, IF_VALUE+1, (int) ftoa(g) );
    install( iface, IF_VALUE+2, (int) ftoa(b) );
    install( iface, IF_VALUE+3, (int) ftoa(a) );

    int	lno = 0;
    get_glLight_ambient( lno, &r, &g, &b, &a );
    install( iface, IF_VALUE+10, (int) ftoa(r) );
    install( iface, IF_VALUE+11, (int) ftoa(g) );
    install( iface, IF_VALUE+12, (int) ftoa(b) );
    install( iface, IF_VALUE+13, (int) ftoa(a) );

    get_glLight_diffuse( lno, &r, &g, &b, &a );
    install( iface, IF_VALUE+20, (int) ftoa(r) );
    install( iface, IF_VALUE+21, (int) ftoa(g) );
    install( iface, IF_VALUE+22, (int) ftoa(b) );
    install( iface, IF_VALUE+23, (int) ftoa(a) );

    get_glLight_specular( lno, &r, &g, &b, &a );
    install( iface, IF_VALUE+30, (int) ftoa(r) );
    install( iface, IF_VALUE+31, (int) ftoa(g) );
    install( iface, IF_VALUE+32, (int) ftoa(b) );
    install( iface, IF_VALUE+33, (int) ftoa(a) );

    // install instance handles
    install( iface, IF_VALUE+110, (int) &enable_thing );
    install( iface, IF_VALUE+100, (int) &ambient_color_thing );
    install( iface, IF_VALUE+101, (int) &diffuse_color_thing );
    install( iface, IF_VALUE+102, (int) &specular_color_thing );
    install( iface, IF_VALUE+103, (int) &light_position_thing );
    install( iface, IF_VALUE+104, (int) &spot_direction_thing );
    install( iface, IF_VALUE+105, (int) &spot_exp_thing );
    install( iface, IF_VALUE+106, (int) &spot_cutoff_thing );
    install( iface, IF_VALUE+107, (int) &const_atten_thing );
    install( iface, IF_VALUE+108, (int) &linear_atten_thing );
    install( iface, IF_VALUE+109, (int) &quad_atten_thing );
}

void
LightAndShade::remember()
{
    GLenum	e;
    GLfloat	f;
    GLfloat	f1, f2, f3, f4;
    GLboolean	b;
    Boolean	B;

    get_glShadeModel( &e );
    get_glLightModel_ambient( &f1, &f2, &f3, &f4 );
    get_glLightModel_local_viewer( &b );
    get_glLightModel_two_side( &b );
    get_glFrontFace( &e );
    get_lighting( &B );

    for( int i = 0; i < MAXNUM_L; i++ ) {
	get_light_status( i, &b );
	get_glLight_ambient( i, &f1, &f2, &f3, &f4 );
	get_glLight_diffuse( i, &f1, &f2, &f3, &f4 );
	get_glLight_specular( i, &f1, &f2, &f3, &f4 );
	get_glLight_position( i, &f1, &f2, &f3, &f4 );
	get_glLight_spot_direction( i, &f1, &f2, &f3 );
	get_glLight_spot_exp( i, &f );
	get_glLight_spot_cutoff( i, &f );
	get_glLight_const_atten( i, &f );
	get_glLight_linear_atten( i, &f );
	get_glLight_quad_atten( i, &f );
    }
}

///////////////////////////////////////////////////////////////////

void
LightAndShade::set_glShadeModel( GLenum mode )
{
    if( debuglevel > 0 ) {
	char *s;

	switch( mode ) {
	  case GL_FLAT:
	    s = "GL_FLAT";
	    break;
	  case GL_SMOOTH:
	    s = "GL_SMOOTH";
	    break;
	}

	printf("glShadeModel %s\n", s );
    }

    glShadeModel( mode );

    _glShadeModel = mode;

    redraw();
}

void
LightAndShade::get_glShadeModel( GLenum *mode )
{
    glGetIntegerv( GL_SHADE_MODEL, (int *) mode );

    _glShadeModel = *mode;
}

void
LightAndShade::set_glLightModel_ambient( GLfloat r, GLfloat g,
					GLfloat b, GLfloat a )
{
    if( debuglevel > 0 ) {
	printf("glLightModel GL_LIGHT_MODEL_AMBIENT [%f %f %f %f]\n",
	       r, g, b, a );
    }

    GLfloat	v[4];

    v[0] = r;
    v[1] = g;
    v[2] = b;
    v[3] = a;
    glLightModelfv( GL_LIGHT_MODEL_AMBIENT, v );

    _glLightModel_ambient.r = r;
    _glLightModel_ambient.g = g;
    _glLightModel_ambient.b = b;
    _glLightModel_ambient.a = a;

    redraw();
}

void
LightAndShade::get_glLightModel_ambient( GLfloat *r, GLfloat *g,
					GLfloat *b, GLfloat *a )
{
    GLfloat	v[4];

    glGetFloatv( GL_LIGHT_MODEL_AMBIENT, v );

    *r = v[0];
    *g = v[1];
    *b = v[2];
    *a = v[3];

    _glLightModel_ambient.r = *r;
    _glLightModel_ambient.g = *g;
    _glLightModel_ambient.b = *b;
    _glLightModel_ambient.a = *a;
}


void
LightAndShade::set_glLightModel_local_viewer( GLboolean state )
{
    if( debuglevel > 0 ) {
	char *s;
	
	if( state ) {
	    s = "TRUE";
	} else {
	    s = "FALSE";
	}
	
	printf("glLightModel GL_LIGHT_MODEL_LOCAL_VIEWER %s\n", s );
    }

    int	s = state;
    glLightModeli( GL_LIGHT_MODEL_LOCAL_VIEWER, s );

    _glLightModel_local_viewer = s;

    redraw();
}

void
LightAndShade::get_glLightModel_local_viewer( GLboolean *state )
{
    glGetBooleanv( GL_LIGHT_MODEL_LOCAL_VIEWER, state );

    _glLightModel_local_viewer = *state;
}

void
LightAndShade::set_glLightModel_two_side( GLboolean state )
{
    if( debuglevel > 0 ) {
	char *s;

	if( state ) {
	    s = "TRUE";
	} else {
	    s = "FALSE";
	}

	printf("glLightModel GL_LIGHT_MODEL_TWO_SIDE %s\n", s );
    }

    int s = state;
    glLightModeli( GL_LIGHT_MODEL_TWO_SIDE, s );

    _glLightModel_two_side = state;

    redraw();
}

void
LightAndShade::get_glLightModel_two_side( GLboolean *state )
{
    glGetBooleanv( GL_LIGHT_MODEL_TWO_SIDE, state );

    _glLightModel_two_side = *state;
}

void
LightAndShade::set_glFrontFace( GLenum mode )
{
    if( debuglevel > 0 ) {
	char *s;

	switch( mode ) {
	  case GL_CW:
	    s = "GL_CW";
	    break;
	  case GL_CCW:
	    s = "GL_CCW";
	    break;
	}

	printf("glFrontFace %s\n", s );
    }

    glFrontFace( mode );

    _glFrontFace = mode;

    redraw();
}

void
LightAndShade::get_glFrontFace( GLenum *mode )
{
    glGetIntegerv( GL_FRONT_FACE, (int *) mode );

    _glFrontFace = *mode;
}

void
LightAndShade::set_lighting( Boolean bool )
{
    if( debuglevel > 0 ) {
	if( bool ) {
	    printf("glEnable GL_LIGHTING\n");
	} else {
	    printf("glDisable GL_LIGHTING\n");
	}
    }

    switch_flag( GL_LIGHTING, bool );

    _lighting = bool;

    redraw();
}

void
LightAndShade::get_lighting( Boolean *bool )
{
    Boolean state = glIsEnabled( GL_LIGHTING );

    _lighting = state;

    *bool = state;
}

void
LightAndShade::set_light_status( int lno, GLboolean state )
{
    if( debuglevel > 0 ) {
	switch( state ) {
	  case FALSE:
	    printf("glDisable GL_LIGHT%d\n", lno );
	    break;

	  case TRUE:
	    printf("glEnable GL_LIGHT%d\n", lno );
	    break;
	}
    }

    switch_flag( GL_LIGHT0+lno, state );

    _light_status[lno] = state;

    redraw();
}

void
LightAndShade::get_light_status( int lno, GLboolean *state )
{
    glGetBooleanv( GL_LIGHT0+lno, state );

    _light_status[lno] = *state;
}

void
LightAndShade::set_glLight_ambient(int lno,
				   GLfloat r, GLfloat g,
				   GLfloat b, GLfloat a )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_AMBIENT [%f %f %f %f]\n",
	       lno, r, g, b, a );
    }

    GLfloat	v[4];
    v[0] = r;
    v[1] = g;
    v[2] = b;
    v[3] = a;

    glLightfv( GL_LIGHT0+lno, GL_AMBIENT, v );

    _glLight_ambient[lno].r = r;
    _glLight_ambient[lno].g = g;
    _glLight_ambient[lno].b = b;
    _glLight_ambient[lno].a = a;

    redraw();
}

void
LightAndShade::get_glLight_ambient(int lno,
				   GLfloat *r, GLfloat *g,
				   GLfloat *b, GLfloat *a )
{
    GLfloat	v[4];

    glGetLightfv( GL_LIGHT0+lno, GL_AMBIENT, v );

    *r = v[0];
    *g = v[1];
    *b = v[2];
    *a = v[3];

    _glLight_ambient[lno].r = *r;
    _glLight_ambient[lno].g = *g;
    _glLight_ambient[lno].b = *b;
    _glLight_ambient[lno].a = *a;
}

void
LightAndShade::set_glLight_diffuse(int lno,
				   GLfloat r, GLfloat g,
				   GLfloat b, GLfloat a )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_DIFFUSE [%f %f %f %f]\n",
	       lno, r, g, b, a );
    }

    GLfloat	v[4];
    v[0] = r;
    v[1] = g;
    v[2] = b;
    v[3] = a;

    glLightfv( GL_LIGHT0+lno, GL_DIFFUSE, v );

    _glLight_diffuse[lno].r = r;
    _glLight_diffuse[lno].g = g;
    _glLight_diffuse[lno].b = b;
    _glLight_diffuse[lno].a = a;

    redraw();
}

void
LightAndShade::get_glLight_diffuse(int lno,
				   GLfloat *r, GLfloat *g,
				   GLfloat *b, GLfloat *a )
{
    GLfloat v[4];

    glGetLightfv( GL_LIGHT0+lno, GL_DIFFUSE, v );

    *r = v[0];
    *g = v[1];
    *b = v[2];
    *a = v[3];

    _glLight_diffuse[lno].r = *r;
    _glLight_diffuse[lno].g = *g;
    _glLight_diffuse[lno].b = *b;
    _glLight_diffuse[lno].a = *a;
}

void
LightAndShade::set_glLight_specular(int lno,
				    GLfloat r, GLfloat g,
				    GLfloat b, GLfloat a )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_SPECULAR [%f %f %f %f]\n",
	       lno, r, g, b, a );
    }

    GLfloat	v[4];
    v[0] = r;
    v[1] = g;
    v[2] = b;
    v[3] = a;

    glLightfv( GL_LIGHT0+lno, GL_SPECULAR, v );

    _glLight_specular[lno].r = r;
    _glLight_specular[lno].g = g;
    _glLight_specular[lno].b = b;
    _glLight_specular[lno].a = a;

    redraw();
}

void
LightAndShade::get_glLight_specular(int lno,
				    GLfloat *r, GLfloat *g,
				    GLfloat *b, GLfloat *a )
{
    GLfloat v[4];

    glGetLightfv( GL_LIGHT0+lno, GL_SPECULAR, v );

    *r = v[0];
    *g = v[1];
    *b = v[2];
    *a = v[3];

    _glLight_specular[lno].r = *r;
    _glLight_specular[lno].g = *g;
    _glLight_specular[lno].b = *b;
    _glLight_specular[lno].a = *a;
}

void
LightAndShade::set_glLight_position(int lno,
				    GLfloat x, GLfloat y,
				    GLfloat z, GLfloat w )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_POSITION [%f %f %f %f]\n",
	       lno, x, y, z, w );
    }

    GLfloat	v[4];
    v[0] = x;
    v[1] = y;
    v[2] = z;
    v[3] = w;

    glLightfv( GL_LIGHT0+lno, GL_POSITION, v );

    _glLight_position_x[lno] = x;
    _glLight_position_y[lno] = y;
    _glLight_position_z[lno] = z;
    _glLight_position_w[lno] = w;

    redraw();
}

void
LightAndShade::get_glLight_position(int lno,
				    GLfloat *x, GLfloat *y,
				    GLfloat *z, GLfloat *w )
{
    GLfloat v[4];

    glGetLightfv( GL_LIGHT0+lno, GL_POSITION, v );

    *x = v[0];
    *y = v[1];
    *z = v[2];
    *w = v[3];

    _glLight_position_x[lno] = *x;
    _glLight_position_y[lno] = *y;
    _glLight_position_z[lno] = *z;
    _glLight_position_w[lno] = *w;
}

void
LightAndShade::set_glLight_spot_direction(int lno,
					  GLfloat x, GLfloat y,
					  GLfloat z )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_SPOT_DIRECTION [%f %f %f]\n",
	       lno, x, y, z );
    }

    GLfloat	v[3];
    v[0] = x;
    v[1] = y;
    v[2] = z;
    glLightfv( GL_LIGHT0+lno, GL_SPOT_DIRECTION, v );

    _glLight_spot_direction_x[lno] = x;
    _glLight_spot_direction_x[lno] = y;
    _glLight_spot_direction_x[lno] = z;

    redraw();
}

void
LightAndShade::get_glLight_spot_direction(int lno,
					  GLfloat *x, GLfloat *y,
					  GLfloat *z )
{
    GLfloat v[3];

    glGetLightfv( GL_LIGHT0+lno, GL_SPOT_DIRECTION, v );

    *x = v[0];
    *y = v[1];
    *z = v[2];

    _glLight_spot_direction_x[lno] = *x;
    _glLight_spot_direction_x[lno] = *y;
    _glLight_spot_direction_x[lno] = *z;
}

void
LightAndShade::set_glLight_spot_exp( int lno, GLfloat exp )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_SPOT_EXPONENT %f\n", lno, exp );
    }

    glLightf( GL_LIGHT0+lno, GL_SPOT_EXPONENT, exp );

    _glLight_spot_exp[lno] = exp;

    redraw();
}

void
LightAndShade::get_glLight_spot_exp( int lno, GLfloat *exp )
{
    glGetLightfv( GL_LIGHT0+lno, GL_SPOT_EXPONENT, exp );

    _glLight_spot_exp[lno] = *exp;
}

void
LightAndShade::set_glLight_spot_cutoff( int lno, GLfloat ang )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_SPOT_CUTOFF %f\n", lno, ang );
    }

    glLightf( GL_LIGHT0+lno, GL_SPOT_CUTOFF, ang );

    _glLight_spot_cutoff[lno] = ang;

    redraw();
}

void
LightAndShade::get_glLight_spot_cutoff( int lno, GLfloat *ang )
{
    glGetLightfv( GL_LIGHT0+lno, GL_SPOT_CUTOFF, ang );

    _glLight_spot_cutoff[lno] = *ang;
}

void
LightAndShade::set_glLight_const_atten( int lno, GLfloat fac )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_CONSTANT_ATTENUATION %f\n", lno, fac );
    }

    glLightf( GL_LIGHT0+lno, GL_CONSTANT_ATTENUATION, fac );

    _glLight_const_atten[lno] = fac;

    redraw();
}

void
LightAndShade::get_glLight_const_atten( int lno, GLfloat *fac )
{
    glGetLightfv( GL_LIGHT0+lno, GL_CONSTANT_ATTENUATION, fac );

    _glLight_const_atten[lno] = *fac;
}

void
LightAndShade::set_glLight_linear_atten( int lno, GLfloat fac )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_LINEAR_ATTENUATION %f\n", lno, fac );
    }

    glLightf( GL_LIGHT0+lno, GL_LINEAR_ATTENUATION, fac );

    _glLight_linear_atten[lno] = fac;

    redraw();
}

void
LightAndShade::get_glLight_linear_atten( int lno, GLfloat *fac )
{
    glGetLightfv( GL_LIGHT0+lno, GL_LINEAR_ATTENUATION, fac );

    _glLight_linear_atten[lno] = *fac;
}

void
LightAndShade::set_glLight_quad_atten( int lno, GLfloat fac )
{
    if( debuglevel > 0 ) {
	printf("glLight GL_LIGHT%d GL_QUADRATIC_ATTENUATION %f\n", lno, fac );
    }

    glLightf( GL_LIGHT0+lno, GL_QUADRATIC_ATTENUATION, fac );

    _glLight_quad_atten[lno] = fac;

    redraw();
}

void
LightAndShade::get_glLight_quad_atten( int lno, GLfloat *fac )
{
    glGetLightfv( GL_LIGHT0+lno, GL_QUADRATIC_ATTENUATION, fac );

    _glLight_quad_atten[lno] = *fac;
}


void
LightAndShade::reset()
{
    int	debugstack;
    Boolean redrawstack;
    
    if( debuglevel <= 1 ) {
	debugstack = debuglevel;
	set_debug_level( 0 );
    }
    if( redrawStatus ) {
	redrawstack = redrawStatus;
	setRedraw( FALSE );
    }

    set_glShadeModel( _glShadeModel );
    set_glLightModel_ambient( _glLightModel_ambient.r,
			     _glLightModel_ambient.g,
			     _glLightModel_ambient.b,
			     _glLightModel_ambient.a );
    set_glLightModel_local_viewer( _glLightModel_local_viewer );
    set_glLightModel_two_side( _glLightModel_two_side );
    set_glFrontFace( _glFrontFace );
    set_lighting( _lighting );

    for( int i = 0; i < MAXNUM_L; i++ ) {
	set_light_status( i, _light_status[i] );
	set_glLight_ambient( i, _glLight_ambient[i].r,
			    _glLight_ambient[i].g,
			    _glLight_ambient[i].b,
			    _glLight_ambient[i].a );
	set_glLight_diffuse( i, _glLight_diffuse[i].r,
			    _glLight_diffuse[i].g,
			    _glLight_diffuse[i].b,
			    _glLight_diffuse[i].a );
	set_glLight_specular( i, _glLight_specular[i].r,
			     _glLight_specular[i].g,
			     _glLight_specular[i].b,
			     _glLight_specular[i].a );
	set_glLight_position( i, _glLight_position_x[i],
			     _glLight_position_y[i],
			     _glLight_position_z[i],
			     _glLight_position_w[i] );
	set_glLight_spot_direction( i, _glLight_spot_direction_x[i],
				   _glLight_spot_direction_y[i],
				   _glLight_spot_direction_z[i] );
	set_glLight_spot_exp( i, _glLight_spot_exp[i] );
	set_glLight_spot_cutoff( i, _glLight_spot_cutoff[i] );
	set_glLight_const_atten( i, _glLight_const_atten[i] );
	set_glLight_linear_atten( i, _glLight_const_atten[i] );
	set_glLight_quad_atten( i, _glLight_quad_atten[i] );
    }
    
    if( debuglevel == 0 ) {
	set_debug_level( debugstack );
    }
    if( redrawstack == TRUE ) {
	setRedraw( TRUE );
    }
}


///////////////////////////////////////////////////////////////////

void
LightAndShade::cb_set_glShadeModel( VkCallbackObject *,
				   void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    GLenum mode = (GLenum) call;

    self->set_glShadeModel( mode );
}

void
LightAndShade::cb_set_glLightModel_ambient( VkCallbackObject *,
					   void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    RGBAColor *c = (RGBAColor *) call;

    self->set_glLightModel_ambient( c->r, c->g, c->b, c->a );
}

void
LightAndShade::cb_set_glLightModel_local_viewer( VkCallbackObject *,
						void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    int	state = (int) call;

    self->set_glLightModel_local_viewer( state );
}

void
LightAndShade::cb_set_glLightModel_two_side( VkCallbackObject *,
					    void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    int	state = (int) call;

    self->set_glLightModel_two_side( state );
}

void
LightAndShade::cb_set_glFrontFace( VkCallbackObject *,
				  void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    GLenum mode = (GLenum) call;

    self->set_glFrontFace( mode );
}

void
LightAndShade::cb_set_lighting( VkCallbackObject *,
			       void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    int	bool = (int) call;

    self->set_lighting( bool );
}

void
LightAndShade::cb_set_light_status( VkCallbackObject *,
				   void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    int	bool = (int) call;

    self->set_light_status( self->current_light, bool );
}

void
LightAndShade::cb_set_glLight_ambient( VkCallbackObject *,
				      void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    RGBAColor *c = (RGBAColor *) call;

    self->set_glLight_ambient(self->current_light,
			      c->r, c->g, c->b, c->a );
}

void
LightAndShade::cb_set_glLight_diffuse( VkCallbackObject *,
				      void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    RGBAColor *c = (RGBAColor *) call;

    self->set_glLight_diffuse(self->current_light,
			      c->r, c->g, c->b, c->a );
}

void
LightAndShade::cb_set_glLight_specular( VkCallbackObject *,
				      void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    RGBAColor *c = (RGBAColor *) call;

    self->set_glLight_specular(self->current_light,
			      c->r, c->g, c->b, c->a );
}

void
LightAndShade::cb_set_glLight_position( VkCallbackObject *,
				      void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;

    GLfloat	x, y, z, w;
    sscanf( (char *) call, "%f %f %f %f", &x, &y, &z, &w );

    self->set_glLight_position(self->current_light,
			       x, y, z, w );
}

void
LightAndShade::cb_set_glLight_spot_direction( VkCallbackObject *,
					     void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;

    GLfloat	x, y, z;
    sscanf( (char *) call, "%f %f %f", &x, &y, &z );

    self->set_glLight_spot_direction(self->current_light,
			       x, y, z );
}

void
LightAndShade::cb_set_glLight_spot_exp( VkCallbackObject *,
				       void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    GLfloat	exp = atof( (char *) call );

    self->set_glLight_spot_exp( self->current_light, exp );
}

void
LightAndShade::cb_set_glLight_spot_cutoff( VkCallbackObject *,
					  void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    GLfloat	ang = atof( (char *) call );

    self->set_glLight_spot_cutoff( self->current_light, ang );
}

void
LightAndShade::cb_set_glLight_const_atten( VkCallbackObject *,
					  void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    GLfloat	att = atof( (char *) call );

    self->set_glLight_const_atten( self->current_light, att );
}

void
LightAndShade::cb_set_glLight_linear_atten( VkCallbackObject *,
					  void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    GLfloat	att = atof( (char *) call );

    self->set_glLight_linear_atten( self->current_light, att );
}

void
LightAndShade::cb_set_glLight_quad_atten( VkCallbackObject *,
					  void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    GLfloat	att = atof( (char *) call );

    self->set_glLight_quad_atten( self->current_light, att );
}

void
LightAndShade::cb_set_current_light( VkCallbackObject *,
				    void *client, void *call )
{
    LightAndShade *self = (LightAndShade *) client;
    int	choice = (int) call;

    self->current_light = choice;

    GLboolean	state;
    GLfloat	r, g, b, a;
    GLfloat	x, y, z, w;
    GLfloat	f;
    char	text[100];

    self->get_light_status( choice, &state );
    self->enable_thing->set_value( state );

    self->get_glLight_ambient( choice, &r, &g, &b, &a );

    self->get_glLight_diffuse( choice, &r, &g, &b, &a );

    self->get_glLight_specular( choice, &r, &g, &b, &a );

    self->get_glLight_position( choice, &x, &y, &z, &w );
    sprintf( text, "%f %f %f %f", x, y, z, w );
    self->light_position_thing->set_text( text );

    self->get_glLight_spot_direction( choice, &x, &y, &z );
    sprintf( text, "%f %f %f", x, y, z );
    self->spot_direction_thing->set_text( text );

    self->get_glLight_spot_exp( choice, &f );
    sprintf( text, "%f", f );
    self->spot_exp_thing->set_text( text );

    self->get_glLight_spot_cutoff( choice, &f );
    sprintf( text, "%f", f );
    self->spot_cutoff_thing->set_text( text );

    self->get_glLight_const_atten( choice, &f );
    sprintf( text, "%f", f );
    self->const_atten_thing->set_text( text );

    self->get_glLight_linear_atten( choice, &f );
    sprintf( text, "%f", f );
    self->linear_atten_thing->set_text( text );

    self->get_glLight_quad_atten( choice, &f );
    sprintf( text, "%f", f );
    self->quad_atten_thing->set_text( text );
}
