/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _MATRIXITEM_H
#define _MATRIXITEM_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Mar 15 14:32:40 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:15:06 1994 by George Kyriazis
 *
 * a panel item showing a 4x4 matrix
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

// X defines Object
#define Object XObject
#include <X11/Intrinsic.h>
#undef Object

#include "Object.h"
#include <Vk/VkComponent.h>

class MatrixItem : public Object, public VkComponent {
  public:
    MatrixItem( char *name, Widget parent );
    virtual ~MatrixItem();

    // get/set the content of the item
    virtual	void	set_matrix( GLfloat * );
    virtual	GLfloat*get_matrix();

    // callback
    static const char *const newValue;

  protected:
    virtual	void	create_widget( char *name, Widget parent );

    Widget rowcol;
    Widget label;
    Widget ti;

    GLfloat *ourMat;

    static const char *const acceptable_string;

    // callbacks
    static	void	activateCB( Widget w, XtPointer, XtPointer );
    static	void	verifyCB( Widget w, XtPointer, XtPointer );
    void	activate_cb( Widget w, XtPointer );
    void	verify_cb( Widget w, XtPointer );

    // don't touch these guys
    static	XtCallbackRec	act_call[2];
    static	XtCallbackRec	ver_call[2];

};

#endif /* _MATRIXITEM_H */
