/*
 * Copyright (c) 1990-94 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of Silicon Graphics may not be used in any advertising or
 * publicity relating to the software without the specific, prior written
 * permission of Silicon Graphics.
 *
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 *
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
 * POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
//  -*- C++ -*-

/*
 * Copyright (C) 1990,91   Silicon Graphics, Inc.
 *
 _______________________________________________________________________
 ______________  S I L I C O N   G R A P H I C S   I N C .  ____________
 |
 |   $Revision: 1.1 $
 |
 |   Description:
 |	This file contains convenience routines which draws borders, and 
 |    elevated 3D looking regions. Those 3D looking UI regions are primarly
 |    used in SoSliders, SoColorPatch, SoColorWheel, ...
 |
 |   Author(s)	: Alain Dumesny
 |
 |
 ______________  S I L I C O N   G R A P H I C S   I N C .  ____________
 _______________________________________________________________________
 */

#ifndef  _SO_UI_REGION_
#define  _SO_UI_REGION_

#include <Inventor/SbBasic.h>

/*
 * Defines
 */

//
// list of grey colors used when drawing regions
//
#define WHITE_UI_COLOR	    glColor3ub(255,255,255)
#define BLACK_UI_COLOR	    glColor3ub(0,0,0)
#define MAIN_UI_COLOR	    glColor3ub(170,170,170)
#define DARK1_UI_COLOR	    glColor3ub(128,128,128)
#define DARK2_UI_COLOR	    glColor3ub(85,85,85)
#define DARK3_UI_COLOR	    glColor3ub(50,50,50)
#define LIGHT1_UI_COLOR	    glColor3ub(215,215,215)

#define UI_THICK 3


#define SO_UI_REGION_GREY1	glColor3ub(240, 240, 240)
#define SO_UI_REGION_GREY2	glColor3ub(190, 190, 190)
#define SO_UI_REGION_GREY3	glColor3ub(150, 150, 150)
#define SO_UI_REGION_GREY4	glColor3ub(130, 130, 130)
#define SO_UI_REGION_GREY5	glColor3ub(110, 110, 110)
#define SO_UI_REGION_GREY6	glColor3ub(70, 70, 70)
#define SO_UI_REGION_GREY7	glColor3ub(30, 30, 30)


/*
 * Function prototypes
 */
 
extern void
drawDownUIRegion(short x1, short y1, short x2, short y2);

extern void
drawDownUIBorders(short x1, short y1, short x2, short y2, SbBool blackLast=FALSE);

extern void
drawThumbUIRegion(short x1, short y1, short x2, short y2);

#endif  // _SO_UI_REGION_
