/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA
 *
 * Created:       Fri Jan  7 17:45:37 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:15:20 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "Object.h"

#include <stdlib.h>

char	___tempstr[300];	// well, shouldn't be here, but oh well..
char *___hexconv = "0123456789abcdef";


//
// first deal with the error level
//

ErrorLevel
Object::get_error_level() const
{
    return errorlevel;
}

void
Object::set_error_level( ErrorLevel level )
{
    errorlevel = level;
}

void
Object::perror( char *s ) const
{
    switch( errorlevel ) {
      case ERROR_IGNORE:
	break;
	
      case ERROR_PRINT:
	::perror( s );
	break;
	
      case ERROR_HALT:
	::perror( s );
	exit( 1 );
	break;

      case ERROR_ABORT:
	::perror( s );
	abort();
	break;
    }
}

void
Object::error( char *s ) const
{
    switch( errorlevel ) {
      case ERROR_IGNORE:
	break;

      case ERROR_PRINT:
	cerr << s << "\n" << flush;
	break;

      case ERROR_HALT:
	cerr << s << "\n" << flush;
	exit( 1 );
	break;

      case ERROR_ABORT:
	cerr << s << "\n" << flush;
	abort();
	break;
    }
}


//
// now deal with the debug level
//
int
Object::get_debug_level() const
{
    return debuglevel;
}

void
Object::set_debug_level( int level )
{
    debuglevel = level;
}
