/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _OBJECT_H
#define _OBJECT_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA
 *
 * Created:       Fri Jan  7 17:44:37 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:19:42 1994 by George Kyriazis
 *
 * every class inherits from here. Provides debugging info, etc.
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "BasicDefs.h"

typedef enum {
    ERROR_IGNORE,
    ERROR_PRINT,
    ERROR_HALT,
    ERROR_ABORT
} ErrorLevel;

class Object {
  public:
    inline	Object();
    inline 	~Object();

    // error stuff
    ErrorLevel	get_error_level() const;
    void	set_error_level( ErrorLevel );
    void	perror( char *s ) const;
    void	error( char *s ) const;

    // debugging stuff
    int		get_debug_level() const;
    void	set_debug_level( int );
    

  protected:
    ErrorLevel	errorlevel;
    int		debuglevel;
};

//////////////////////////////////////////////////////////////////

Object::Object()
{
    errorlevel = ERROR_PRINT;
    debuglevel = 0;
}

Object::~Object()
{
}


    

#endif /* _OBJECT_H */
