/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _RADIOBOXITEM_H
#define _RADIOBOXITEM_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Jan 11 13:04:04 1994 by George Kyriazis
 * Last Modified: Mon Aug  1 18:55:22 1994 by George Kyriazis
 *
 * a C++ encapsulation of a radio box of N items with a label
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

// X defines Object
#define Object XObject
#include <X11/Intrinsic.h>
#undef Object

#include "Object.h"
#include <Vk/VkComponent.h>

class RadioBoxItem : public Object, public VkComponent {
  public:
    RadioBoxItem( char *name, Widget parent, int n_choices = 2 );
    virtual ~RadioBoxItem();

    // set the string and return value for an item
    virtual	void	set( int index, char *name, int return_value );

    // call this when you are done building
    virtual	void	end();

    // setting values
    virtual	void	set_initial_value( int index );
    virtual	void	set_value( int index );

    // callback name when we get a new value
    static const char *const newValue;

  protected:
    virtual	void	create_widget( char *name, Widget parent );
    void	create_radio( char *name, Widget parent );
    void	create_menu( char *name, Widget parent );

    int		number;

    Widget	rowcol;
    Widget	label;
    Widget	rb;
    Widget	pulldown;

    typedef 	char	mystring[80];
    mystring	*str;
    XmString	*xmstr;
    int		*ret;
    Widget	*buttons;

    static	void	buttonCB( Widget, XtPointer, XtPointer );
    void	button_cb( Widget, XtPointer );

    // don't touch this
    char *name;
    Widget	parent;
    int	initial_value;
};

#endif /* _RADIOBOXITEM_H */
