/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Feb  8 11:18:03 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:14:11 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "TexGenOps.h"

#include "IfaceGeneratorP.h"

#include "TextItem.h"
#include "PlaneItem.h"

int TexGenOps::iface[] = {
    IF_BEGIN,
    IF_WINDOW, IF_THIS, NULL,
    (int) "Texture Generation", 1,

    IF_RADIO, IF_THIS, NULL,
    (int) "S Texture Generation: ", 2,
    0, (int) &TexGenOps::cb_set_texture_s,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RADIO, IF_THIS, NULL,
    (int) "S Tex Gen Mode: ", 3,
    1, (int) &TexGenOps::cb_set_glTexGen_s_gen_mode,
    (int) "GL_OBJECT_LINEAR", GL_OBJECT_LINEAR,
    (int) "GL_EYE_LINEAR", GL_EYE_LINEAR,
    (int) "GL_SPHERE_MAP", GL_SPHERE_MAP,

    IF_PLANE, IF_THIS, NULL,
    (int) "S Object Plane: ",
    IF_VALUE+100, IF_VALUE+101, IF_VALUE+102, IF_VALUE+103,
    (int) &TexGenOps::cb_set_glTexGen_s_obj_plane,

    IF_TEXT, IF_THIS, NULL,
    (int) "S Eye Plane: ",
    30, IF_VALUE+1,
    (int) &TextItem::VECTOR,
    (int) &TexGenOps::cb_set_glTexGen_s_eye_plane,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",

    IF_RADIO, IF_THIS, NULL,
    (int) "T Texture Generation: ", 2,
    0, (int) &TexGenOps::cb_set_texture_t,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RADIO, IF_THIS, NULL,
    (int) "T Tex Gen Mode: ", 3,
    1, (int) &TexGenOps::cb_set_glTexGen_t_gen_mode,
    (int) "GL_OBJECT_LINEAR", GL_OBJECT_LINEAR,
    (int) "GL_EYE_LINEAR", GL_EYE_LINEAR,
    (int) "GL_SPHERE_MAP", GL_SPHERE_MAP,

    IF_PLANE, IF_THIS, NULL,
    (int) "T Object Plane: ",
    IF_VALUE+200, IF_VALUE+201, IF_VALUE+202, IF_VALUE+203,
    (int) &TexGenOps::cb_set_glTexGen_t_obj_plane,

    IF_TEXT, IF_THIS, NULL,
    (int) "T Eye Plane: ",
    30, IF_VALUE+11,
    (int) &TextItem::VECTOR,
    (int) &TexGenOps::cb_set_glTexGen_t_eye_plane,

    IF_SEPARATOR, IF_THIS, NULL,
    (int) "separator",


    /* insert R widgets here, when R is working */


    IF_RADIO, IF_THIS, NULL,
    (int) "Q Texture Generation: ", 2,
    0, (int) &TexGenOps::cb_set_texture_q,
    (int) "Off", FALSE,
    (int) "On", TRUE,

    IF_RADIO, IF_THIS, NULL,
    (int) "Q Tex Gen Mode: ", 3,
    1, (int) &TexGenOps::cb_set_glTexGen_q_gen_mode,
    (int) "GL_OBJECT_LINEAR", GL_OBJECT_LINEAR,
    (int) "GL_EYE_LINEAR", GL_EYE_LINEAR,
    (int) "GL_SPHERE_MAP", GL_SPHERE_MAP,

    IF_TEXT, IF_THIS, NULL,
    (int) "Q Object Plane: ",
    30, IF_VALUE+30,
    (int) &TextItem::VECTOR,
    (int) &TexGenOps::cb_set_glTexGen_q_obj_plane,

    IF_TEXT, IF_THIS, NULL,
    (int) "Q Eye Plane: ",
    30, IF_VALUE+31,
    (int) &TextItem::VECTOR,
    (int) &TexGenOps::cb_set_glTexGen_q_eye_plane,

    
    IF_END
};

TexGenOps::TexGenOps( GlWindow *dwa )
: IfaceGenerator( dwa )
{
    install_this( iface );
    install_values();
    parse( iface );
    remember();
}

TexGenOps::~TexGenOps()
{
}

///////////////////////////////////////////////////////////////////

void
TexGenOps::install_values()
{
    // install values
    GLfloat	x, y, z, w;
    char	text[200];

    get_glTexGen_obj_plane( GL_S, &x, &y, &z, &w );
    install( iface, IF_VALUE+100, (int) ftoa(x) );
    install( iface, IF_VALUE+101, (int) ftoa(y) );
    install( iface, IF_VALUE+102, (int) ftoa(z) );
    install( iface, IF_VALUE+103, (int) ftoa(w) );

    get_glTexGen_eye_plane( GL_S, &x, &y, &z, &w );
    sprintf( text, "%f %f %f %f", x, y, z, w );
    install( iface, IF_VALUE+1, (int) new_strcpy( text ) );


    get_glTexGen_obj_plane( GL_T, &x, &y, &z, &w );
    install( iface, IF_VALUE+200, (int) ftoa(x) );
    install( iface, IF_VALUE+201, (int) ftoa(y) );
    install( iface, IF_VALUE+202, (int) ftoa(z) );
    install( iface, IF_VALUE+203, (int) ftoa(w) );

    get_glTexGen_eye_plane( GL_T, &x, &y, &z, &w );
    sprintf( text, "%f %f %f %f", x, y, z, w );
    install( iface, IF_VALUE+11, (int) new_strcpy( text ) );

    
    get_glTexGen_obj_plane( GL_R, &x, &y, &z, &w );
    sprintf( text, "%f %f %f %f", x, y, z, w );
    install( iface, IF_VALUE+20, (int) new_strcpy( text ) );

    get_glTexGen_eye_plane( GL_R, &x, &y, &z, &w );
    sprintf( text, "%f %f %f %f", x, y, z, w );
    install( iface, IF_VALUE+21, (int) new_strcpy( text ) );

    
    get_glTexGen_obj_plane( GL_Q, &x, &y, &z, &w );
    sprintf( text, "%f %f %f %f", x, y, z, w );
    install( iface, IF_VALUE+30, (int) new_strcpy( text ) );

    get_glTexGen_eye_plane( GL_Q, &x, &y, &z, &w );
    sprintf( text, "%f %f %f %f", x, y, z, w );
    install( iface, IF_VALUE+31, (int) new_strcpy( text ) );
}


void
TexGenOps::remember()
{
    GLfloat	f1, f2, f3, f4;
    GLenum	e;
    Boolean	b;

    get_texture( GL_TEXTURE_GEN_S, &b );
    get_glTexGen_gen_mode( GL_S, &e );
    get_glTexGen_obj_plane( GL_S, &f1, &f2, &f3, &f4 );
    get_glTexGen_eye_plane( GL_S, &f1, &f2, &f3, &f4 );
    
    get_texture( GL_TEXTURE_GEN_T, &b );
    get_glTexGen_gen_mode( GL_T, &e );
    get_glTexGen_obj_plane( GL_T, &f1, &f2, &f3, &f4 );
    get_glTexGen_eye_plane( GL_T, &f1, &f2, &f3, &f4 );
    
    get_texture( GL_TEXTURE_GEN_R, &b );
    get_glTexGen_gen_mode( GL_R, &e );
    get_glTexGen_obj_plane( GL_R, &f1, &f2, &f3, &f4 );
    get_glTexGen_eye_plane( GL_R, &f1, &f2, &f3, &f4 );
    
    get_texture( GL_TEXTURE_GEN_Q, &b );
    get_glTexGen_gen_mode( GL_Q, &e );
    get_glTexGen_obj_plane( GL_Q, &f1, &f2, &f3, &f4 );
    get_glTexGen_eye_plane( GL_Q, &f1, &f2, &f3, &f4 );
}


//
// texture generation operations
//

void
TexGenOps::set_texture( GLenum tp, Boolean bool )
{
    if( debuglevel > 0 ) {
	char *s;

	switch( tp ) {
	  case GL_TEXTURE_GEN_S:
	    s = "GL_TEXTURE_GEN_S";
	    break;

	  case GL_TEXTURE_GEN_T:
	    s = "GL_TEXTURE_GEN_T";
	    break;

	  case GL_TEXTURE_GEN_R:
	    s = "GL_TEXTURE_GEN_R";
	    break;

	  case GL_TEXTURE_GEN_Q:
	    s = "GL_TEXTURE_GEN_Q";
	    break;
	}

	if( bool ) {
	    printf("glEnable %s\n", s );
	} else {
	    printf("glDisable %s\n", s );
	}
    }
	
    switch_flag( tp, bool );

    switch( tp ) {
      case GL_TEXTURE_GEN_S:
	_texture_s = bool;
	break;
      case GL_TEXTURE_GEN_T:
	_texture_t = bool;
	break;
      case GL_TEXTURE_GEN_R:
	_texture_r = bool;
	break;
      case GL_TEXTURE_GEN_Q:
	_texture_q = bool;
	break;
    }

    redraw();
}

void
TexGenOps::get_texture( GLenum tp, Boolean *bool )
{
    Boolean state;

    switch( tp ) {
      case GL_TEXTURE_GEN_S:
	state = glIsEnabled( GL_TEXTURE_GEN_S );
	_texture_s = state;
	*bool = state;
	break;

      case GL_TEXTURE_GEN_T:
	state = glIsEnabled( GL_TEXTURE_GEN_T );
	_texture_t = state;
	*bool = state;
	break;

      case GL_TEXTURE_GEN_R:
	state = glIsEnabled( GL_TEXTURE_GEN_R );
	_texture_r = state;
	*bool = state;
	break;

      case GL_TEXTURE_GEN_Q:
	state = glIsEnabled( GL_TEXTURE_GEN_Q );
	_texture_q = state;
	*bool = state;
	break;
    }
}


void
TexGenOps::set_glTexGen_gen_mode( GLenum tp, GLenum val )
{
    if( debuglevel > 0 ) {
	char *tps;
	char *s;

	switch( tp ) {
	  case GL_S:
	    tps = "GL_S";
	    break;

	  case GL_T:
	    tps = "GL_T";
	    break;

	  case GL_R:
	    tps = "GL_R";
	    break;

	  case GL_Q:
	    tps = "GL_Q";
	    break;
	}

	switch( val ) {
	  case GL_OBJECT_LINEAR:
	    s = "GL_OBJECT_LINEAR";
	    break;

	  case GL_EYE_LINEAR:
	    s = "GL_EYE_LINEAR";
	    break;

	  case GL_SPHERE_MAP:
	    s = "GL_SPHERE_MAP";
	    break;
	}

	printf("glTexGen %s GL_TEXTURE_GEN_MODE %s\n", tps, s );
    }

    glTexGeni( tp, GL_TEXTURE_GEN_MODE, val );

    switch( tp ) {
      case GL_S:
	_glTexGen_gen_mode_s = val;
	break;
      case GL_T:
	_glTexGen_gen_mode_t = val;
	break;
      case GL_R:
	_glTexGen_gen_mode_r = val;
	break;
      case GL_Q:
	_glTexGen_gen_mode_q = val;
	break;
    }

    redraw();
}

void
TexGenOps::get_glTexGen_gen_mode( GLenum tp, GLenum *val )
{
    glGetTexGeniv( tp, GL_TEXTURE_GEN_MODE, (int *) val );
    
    switch( tp ) {
      case GL_S:
	_glTexGen_gen_mode_s = *val;
	break;
      case GL_T:
	_glTexGen_gen_mode_t = *val;
	break;
      case GL_R:
	_glTexGen_gen_mode_r = *val;
	break;
      case GL_Q:
	_glTexGen_gen_mode_q = *val;
	break;
    }
}

void
TexGenOps::set_glTexGen_obj_plane( GLenum tp,
				  GLfloat x, GLfloat y,
				  GLfloat z, GLfloat w )
{
    if( debuglevel > 0 ) {
	char *tps;

	switch( tp ) {
	  case GL_S:
	    tps = "GL_S";
	    break;

	  case GL_T:
	    tps = "GL_T";
	    break;

	  case GL_R:
	    tps = "GL_R";
	    break;

	  case GL_Q:
	    tps = "GL_Q";
	    break;
	}

	printf("glTexGen %s GL_OBJECT_PLANE [%f %f %f %f]\n",
	       tps, x, y, z, w );
    }

    GLfloat	v[4];

    v[0] = x;
    v[1] = y;
    v[2] = z;
    v[3] = w;

    glTexGenfv( tp, GL_OBJECT_PLANE, v );

    switch( tp ) {
      case GL_S:
	_glTexGen_obj_plane_x_s = x;
	_glTexGen_obj_plane_y_s = y;
	_glTexGen_obj_plane_z_s = z;
	_glTexGen_obj_plane_w_s = w;
	break;
      case GL_T:
	_glTexGen_obj_plane_x_t = x;
	_glTexGen_obj_plane_y_t = y;
	_glTexGen_obj_plane_z_t = z;
	_glTexGen_obj_plane_w_t = w;
	break;
      case GL_R:
	_glTexGen_obj_plane_x_r = x;
	_glTexGen_obj_plane_y_r = y;
	_glTexGen_obj_plane_z_r = z;
	_glTexGen_obj_plane_w_r = w;
	break;
      case GL_Q:
	_glTexGen_obj_plane_x_q = x;
	_glTexGen_obj_plane_y_q = y;
	_glTexGen_obj_plane_z_q = z;
	_glTexGen_obj_plane_w_q = w;
	break;
    }

    redraw();
}

void
TexGenOps::get_glTexGen_obj_plane( GLenum tp,
				  GLfloat *x, GLfloat *y,
				  GLfloat *z, GLfloat *w )
{
    GLfloat	v[4];

    glGetTexGenfv( tp, GL_OBJECT_PLANE, v );

    *x = v[0];
    *y = v[1];
    *z = v[2];
    *w = v[3];

    switch( tp ) {
      case GL_S:
	_glTexGen_obj_plane_x_s = *x;
	_glTexGen_obj_plane_y_s = *y;
	_glTexGen_obj_plane_z_s = *z;
	_glTexGen_obj_plane_w_s = *w;
	break;
      case GL_T:
	_glTexGen_obj_plane_x_t = *x;
	_glTexGen_obj_plane_y_t = *y;
	_glTexGen_obj_plane_z_t = *z;
	_glTexGen_obj_plane_w_t = *w;
	break;
      case GL_R:
	_glTexGen_obj_plane_x_r = *x;
	_glTexGen_obj_plane_y_r = *y;
	_glTexGen_obj_plane_z_r = *z;
	_glTexGen_obj_plane_w_r = *w;
	break;
      case GL_Q:
	_glTexGen_obj_plane_x_q = *x;
	_glTexGen_obj_plane_y_q = *y;
	_glTexGen_obj_plane_z_q = *z;
	_glTexGen_obj_plane_w_q = *w;
	break;
    }
}

void
TexGenOps::set_glTexGen_eye_plane( GLenum tp,
				  GLfloat x, GLfloat y,
				  GLfloat z, GLfloat w )
{
    if( debuglevel > 0 ) {
	char *tps;

	switch( tp ) {
	  case GL_S:
	    tps = "GL_S";
	    break;

	  case GL_T:
	    tps = "GL_T";
	    break;

	  case GL_R:
	    tps = "GL_R";
	    break;

	  case GL_Q:
	    tps = "GL_Q";
	    break;
	}

	printf("glTexGen %s GL_EYE_PLANE [%f %f %f %f]\n",
	       tps, x, y, z, w );
    }

    GLfloat	v[4];

    v[0] = x;
    v[1] = y;
    v[2] = z;
    v[3] = w;

    glTexGenfv( tp, GL_EYE_PLANE, v );

    switch( tp ) {
      case GL_S:
	_glTexGen_eye_plane_x_s = x;
	_glTexGen_eye_plane_y_s = y;
	_glTexGen_eye_plane_z_s = z;
	_glTexGen_eye_plane_w_s = w;
	break;
      case GL_T:
	_glTexGen_eye_plane_x_t = x;
	_glTexGen_eye_plane_y_t = y;
	_glTexGen_eye_plane_z_t = z;
	_glTexGen_eye_plane_w_t = w;
	break;
      case GL_R:
	_glTexGen_eye_plane_x_r = x;
	_glTexGen_eye_plane_y_r = y;
	_glTexGen_eye_plane_z_r = z;
	_glTexGen_eye_plane_w_r = w;
	break;
      case GL_Q:
	_glTexGen_eye_plane_x_q = x;
	_glTexGen_eye_plane_y_q = y;
	_glTexGen_eye_plane_z_q = z;
	_glTexGen_eye_plane_w_q = w;
	break;
    }

    redraw();
}

void
TexGenOps::get_glTexGen_eye_plane( GLenum tp,
				  GLfloat *x, GLfloat *y,
				  GLfloat *z, GLfloat *w )
{
    GLfloat	v[4];

    glGetTexGenfv( tp, GL_EYE_PLANE, v );

    *x = v[0];
    *y = v[1];
    *z = v[2];
    *w = v[3];

    switch( tp ) {
      case GL_S:
	_glTexGen_eye_plane_x_s = *x;
	_glTexGen_eye_plane_y_s = *y;
	_glTexGen_eye_plane_z_s = *z;
	_glTexGen_eye_plane_w_s = *w;
	break;
      case GL_T:
	_glTexGen_eye_plane_x_t = *x;
	_glTexGen_eye_plane_y_t = *y;
	_glTexGen_eye_plane_z_t = *z;
	_glTexGen_eye_plane_w_t = *w;
	break;
      case GL_R:
	_glTexGen_eye_plane_x_r = *x;
	_glTexGen_eye_plane_y_r = *y;
	_glTexGen_eye_plane_z_r = *z;
	_glTexGen_eye_plane_w_r = *w;
	break;
      case GL_Q:
	_glTexGen_eye_plane_x_q = *x;
	_glTexGen_eye_plane_y_q = *y;
	_glTexGen_eye_plane_z_q = *z;
	_glTexGen_eye_plane_w_q = *w;
	break;
    }
}


void
TexGenOps::reset()
{
    int	debugstack;
    Boolean redrawstack;
    
    if( debuglevel <= 1 ) {
	debugstack = debuglevel;
	set_debug_level( 0 );
    }
    if( redrawStatus ) {
	redrawstack = redrawStatus;
	setRedraw( FALSE );
    }

    set_texture( GL_TEXTURE_GEN_S, _texture_s );
    set_glTexGen_gen_mode( GL_S, _glTexGen_gen_mode_s );
    set_glTexGen_obj_plane( GL_S,
			   _glTexGen_obj_plane_x_s,
			   _glTexGen_obj_plane_y_s,
			   _glTexGen_obj_plane_z_s,
			   _glTexGen_obj_plane_w_s );
    set_glTexGen_eye_plane( GL_S,
			   _glTexGen_eye_plane_x_s,
			   _glTexGen_eye_plane_y_s,
			   _glTexGen_eye_plane_z_s,
			   _glTexGen_eye_plane_w_s );

    set_texture( GL_TEXTURE_GEN_T, _texture_t );
    set_glTexGen_gen_mode( GL_T, _glTexGen_gen_mode_t );
    set_glTexGen_obj_plane( GL_T,
			   _glTexGen_obj_plane_x_t,
			   _glTexGen_obj_plane_y_t,
			   _glTexGen_obj_plane_z_t,
			   _glTexGen_obj_plane_w_t );
    set_glTexGen_eye_plane( GL_T,
			   _glTexGen_eye_plane_x_t,
			   _glTexGen_eye_plane_y_t,
			   _glTexGen_eye_plane_z_t,
			   _glTexGen_eye_plane_w_t );

    set_texture( GL_TEXTURE_GEN_R, _texture_r );
    set_glTexGen_gen_mode( GL_R, _glTexGen_gen_mode_r );
    set_glTexGen_obj_plane( GL_R,
			   _glTexGen_obj_plane_x_r,
			   _glTexGen_obj_plane_y_r,
			   _glTexGen_obj_plane_z_r,
			   _glTexGen_obj_plane_w_r );
    set_glTexGen_eye_plane( GL_R,
			   _glTexGen_eye_plane_x_r,
			   _glTexGen_eye_plane_y_r,
			   _glTexGen_eye_plane_z_r,
			   _glTexGen_eye_plane_w_r );

    set_texture( GL_TEXTURE_GEN_Q, _texture_q );
    set_glTexGen_gen_mode( GL_Q, _glTexGen_gen_mode_q );
    set_glTexGen_obj_plane( GL_Q,
			   _glTexGen_obj_plane_x_q,
			   _glTexGen_obj_plane_y_q,
			   _glTexGen_obj_plane_z_q,
			   _glTexGen_obj_plane_w_q );
    set_glTexGen_eye_plane( GL_Q,
			   _glTexGen_eye_plane_x_q,
			   _glTexGen_eye_plane_y_q,
			   _glTexGen_eye_plane_z_q,
			   _glTexGen_eye_plane_w_q );

    if( debuglevel == 0 ) {
	set_debug_level( debugstack );
    }
    if( redrawstack == TRUE ) {
	setRedraw( TRUE );
    }
}

////////////////////////////////////////////////////////////////////
//  callbacks
////////////////////////////////////////////////////////////////////

void
TexGenOps::cb_set_texture_s( VkCallbackObject *, void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_texture( GL_TEXTURE_GEN_S, state );
}

void
TexGenOps::cb_set_texture_t( VkCallbackObject *, void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_texture( GL_TEXTURE_GEN_T, state );
}

void
TexGenOps::cb_set_texture_r( VkCallbackObject *, void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_texture( GL_TEXTURE_GEN_R, state );
}

void
TexGenOps::cb_set_texture_q( VkCallbackObject *, void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_texture( GL_TEXTURE_GEN_Q, state );
}


void
TexGenOps::cb_set_glTexGen_s_gen_mode( VkCallbackObject *,
				      void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_glTexGen_gen_mode( GL_S, state );
}

void
TexGenOps::cb_set_glTexGen_t_gen_mode( VkCallbackObject *,
				      void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_glTexGen_gen_mode( GL_T, state );
}

void
TexGenOps::cb_set_glTexGen_r_gen_mode( VkCallbackObject *,
				      void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_glTexGen_gen_mode( GL_R, state );
}

void
TexGenOps::cb_set_glTexGen_q_gen_mode( VkCallbackObject *,
				      void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    int state = (int) call;

    self->set_glTexGen_gen_mode( GL_Q, state );
}


void
TexGenOps::cb_set_glTexGen_s_obj_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    PlaneItem	*pi = (PlaneItem *) call;

    float	x, y, z, w;

    pi->get_plane( &x, &y, &z, &w );

    self->set_glTexGen_obj_plane( GL_S, x, y, z, w );
}

void
TexGenOps::cb_set_glTexGen_t_obj_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    PlaneItem	*pi = (PlaneItem *) call;

    float	x, y, z, w;

    pi->get_plane( &x, &y, &z, &w );

    self->set_glTexGen_obj_plane( GL_T, x, y, z, w );
}

void
TexGenOps::cb_set_glTexGen_r_obj_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    char *s = (char *) call;

    float	x, y, z, w;

    sscanf( s, "%f %f %f %f", &x, &y, &z, &w );

    self->set_glTexGen_obj_plane( GL_R, x, y, z, w );
}

void
TexGenOps::cb_set_glTexGen_q_obj_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    char *s = (char *) call;

    float	x, y, z, w;

    sscanf( s, "%f %f %f %f", &x, &y, &z, &w );

    self->set_glTexGen_obj_plane( GL_Q, x, y, z, w );
}


void
TexGenOps::cb_set_glTexGen_s_eye_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    char *s = (char *) call;

    float	x, y, z, w;

    sscanf( s, "%f %f %f %f", &x, &y, &z, &w );

    self->set_glTexGen_eye_plane( GL_S, x, y, z, w );
}

void
TexGenOps::cb_set_glTexGen_t_eye_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    char *s = (char *) call;

    float	x, y, z, w;

    sscanf( s, "%f %f %f %f", &x, &y, &z, &w );

    self->set_glTexGen_eye_plane( GL_T, x, y, z, w );
}

void
TexGenOps::cb_set_glTexGen_r_eye_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    char *s = (char *) call;

    float	x, y, z, w;

    sscanf( s, "%f %f %f %f", &x, &y, &z, &w );

    self->set_glTexGen_eye_plane( GL_R, x, y, z, w );
}

void
TexGenOps::cb_set_glTexGen_q_eye_plane( VkCallbackObject *,
				       void *client, void *call )
{
    TexGenOps *self = (TexGenOps *) client;
    char *s = (char *) call;

    float	x, y, z, w;

    sscanf( s, "%f %f %f %f", &x, &y, &z, &w );

    self->set_glTexGen_eye_plane( GL_Q, x, y, z, w );
}

