/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Jan 11 13:38:36 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:27 1994 by George Kyriazis
 *
 * < General description goes here > 
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "TopLevelWindow.h"

#include <Xm/RowColumn.h>
#include <Xm/ToggleB.h>

#include <Vk/VkSimpleWindow.h>

TopLevelWindow::TopLevelWindow( char *name )
: VkSimpleWindow( name )
{
    create_widget( name );
}

TopLevelWindow::~TopLevelWindow()
{
}

void
TopLevelWindow::create_widget( char *name )
{
    rowcol = XmCreateRowColumn( mainWindowWidget(),
			       name,
			       NULL, 0 );
    XtManageChild( rowcol );

    addView( rowcol );
}

void
TopLevelWindow::set_columns( int ncols )
{
    int	ac;
    Arg	av[10];

    ac = 0;
    XtSetArg( av[ac], XmNnumColumns, ncols ); ac++;
    XtSetValues( rowcol, av, ac );
}

int
TopLevelWindow::get_columns()
{
    int	ncols;
    int	ac;
    Arg	av[10];

    ac = 0;
    XtSetArg( av[ac], XmNnumColumns, &ncols );
    XtGetValues( rowcol, av, ac );

    return ncols;
}


TopLevelWindow::operator Widget() const
{
    return rowcol;
}

void
TopLevelWindow::handleWmDeleteMessage()
{
    hide();
}

void
TopLevelWindow::handleWmQuitMessage()
{
    hide();
}
