/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#ifndef _TRANSFORMS_H
#define _TRANSFORMS_H

/************************************************************************
 *
 * File: %M%
 *
 * Copyright (c) 1994 by Silicon Graphics Inc., Mt. View, CA 94039
 *
 * Created:       Tue Mar 15 14:18:18 1994 by George Kyriazis
 * Last Modified: Wed Mar 23 11:13:33 1994 by George Kyriazis
 *
 * show and get view-model/projection/texture matrices
 *
 ************************************************************************/

#ident "$Revision: 1.1 $"

#include "IfaceGenerator.h"

class MatrixItem;

class Transforms : public IfaceGenerator {
  public:
    Transforms( GlWindow * );
    virtual ~Transforms();

    virtual	void	reset();

    // get/set the matrices
    void	set_model_view( GLfloat *m );
    void	get_model_view( GLfloat **m );
    void	set_proj( GLfloat *m );
    void	get_proj( GLfloat **m );
    void	set_texture( GLfloat *m );
    void	get_texture( GLfloat **m );

    // set the text items
    void	set_model_view_text( GLfloat *m );
    void	set_proj_text( GLfloat *m );
    void	set_texture_text( GLfloat *m );

  protected:
    static	int	iface[];
    virtual	int	get_this() { return (int) this; }
    void	install_values();

    virtual	void	remember();

    // our state
    GLfloat	_model_view[16];
    MatrixItem *model_view_thing;
    GLfloat	_proj[16];
    MatrixItem *proj_thing;
    GLfloat	_texture[16];
    MatrixItem *texture_thing;

    // callbacks
    static	void	cb_set_model_view( CB_ARGS );
    static	void	cb_set_proj( CB_ARGS );
    static	void	cb_set_texture( CB_ARGS );
};

#endif /* _TRANSFORMS_H */
